
;CodeVisionAVR C Compiler V1.24.8d Professional
;(C) Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "mondeo.vec"
	.INCLUDE "mondeo.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 Chip type           : ATmega8
;       3 Program type        : Application
;       4 Clock frequency     : 8,000000 MHz
;       5 Memory model        : Small
;       6 External SRAM size  : 0
;       7 Data Stack size     : 256
;       8 *****************************************************/
;       9 #include <stdlib.h>
;      10 #include <mega8.h>
;      11        
;      12 #include <delay.h>
;      13 #include <stdio.h>
;      14 // Alphanumeric LCD Module functions
;      15 #asm
;      16    .equ __lcd_port=0x18 ;PORTB
   .equ __lcd_port=0x18 ;PORTB
;      17 #endasm
;      18 #include <lcd.h>
;      19 
;      20 char TotalFuelStr[14];
_TotalFuelStr:
	.BYTE 0xE
;      21 char Vtoraya_Stroka[14];
_Vtoraya_Stroka:
	.BYTE 0xE
;      22 char LitrNaSotnyStr[14];
_LitrNaSotnyStr:
	.BYTE 0xE
;      23 char TotalPutStr[14];
_TotalPutStr:
	.BYTE 0xE
;      24 int rezhim=2;    // 1-  , /100    2-  ,      3-   4-    5-  
;      25 
;      26 //int Key_interval=0; 
;      27 float LitrNaSotny=0;
_LitrNaSotny:
	.BYTE 0x4
;      28 float TotalFuel;
_TotalFuel:
	.BYTE 0x4
;      29 float TotalPut;
_TotalPut:
	.BYTE 0x4
;      30 
;      31 unsigned long int  StoGramm=0;
_StoGramm:
	.BYTE 0x4
;      32 unsigned long int  SpeedCounter=0;
_SpeedCounter:
	.BYTE 0x4
;      33 unsigned long int  i=0;
_i:
	.BYTE 0x4
;      34 unsigned long int  Speed_For_light=0;
_Speed_For_light:
	.BYTE 0x4
;      35 //unsigned long int  Speed=0;
;      36 
;      37 
;      38 eeprom unsigned long int  eepromPrFors; //   (  ,    0,01)/1000

	.ESEG
_eepromPrFors:
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
;      39 eeprom unsigned long int eepromImpuls_km;
_eepromImpuls_km:
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
;      40 unsigned long int  PrFors=0;

	.DSEG
_PrFors:
	.BYTE 0x4
;      41 unsigned long int  Impuls_km=0;
_Impuls_km:
	.BYTE 0x4
;      42 eeprom unsigned long int eepromTotalFuel;

	.ESEG
_eepromTotalFuel:
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
;      43 eeprom unsigned long int eepromTotalPut;
_eepromTotalPut:
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
;      44            
;      45 //  , 1 
;      46 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;      47 {

	.CSEG
_timer0_ovf_isr:
	ST   -Y,R30
;      48 Speed_For_light=0;
	LDI  R30,0
	STS  _Speed_For_light,R30
	STS  _Speed_For_light+1,R30
	STS  _Speed_For_light+2,R30
	STS  _Speed_For_light+3,R30
;      49 
;      50 };
	LD   R30,Y+
	RETI
;      51 
;      52 
;      53 
;      54 interrupt [EXT_INT0] void ext_int0_isr(void)
;      55 {
_ext_int0_isr:
	RCALL SUBOPT_0x0
;      56 SpeedCounter++;
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x2
	STS  _SpeedCounter,R30
	STS  _SpeedCounter+1,R31
	STS  _SpeedCounter+2,R22
	STS  _SpeedCounter+3,R23
;      57 TotalPut=TotalPut+1;
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
;      58 Speed_For_light++;
	LDS  R30,_Speed_For_light
	LDS  R31,_Speed_For_light+1
	LDS  R22,_Speed_For_light+2
	LDS  R23,_Speed_For_light+3
	RCALL SUBOPT_0x2
	STS  _Speed_For_light,R30
	STS  _Speed_For_light+1,R31
	STS  _Speed_For_light+2,R22
	STS  _Speed_For_light+3,R23
;      59 
;      60 }
	RCALL SUBOPT_0x6
	RETI
;      61 
;      62 
;      63 //   
;      64 interrupt [EXT_INT1] void ext_int1_isr(void)
;      65 {
_ext_int1_isr:
	RCALL SUBOPT_0x0
;      66  
;      67     if ( PIND.3 )  
	SBIS 0x10,3
	RJMP _0x4
;      68         { 
;      69            //  ,   
;      70         MCUCR=0x0B;//    
	LDI  R30,LOW(11)
	OUT  0x35,R30
;      71         TCCR1B=0x00; //  
	LDI  R30,LOW(0)
	OUT  0x2E,R30
;      72         i=i+TCNT1; //   ,    :)  0.83   0,01 
	IN   R30,0x2C
	IN   R31,0x2C+1
	RCALL SUBOPT_0x7
	CLR  R22
	CLR  R23
	RCALL __ADDD12
	STS  _i,R30
	STS  _i+1,R31
	STS  _i+2,R22
	STS  _i+3,R23
;      73         TCNT1=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
;      74         
;      75         if (i>PrFors) { 
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x7
	RCALL __CPD12
	BRLO PC+2
	RJMP _0x5
;      76               StoGramm++; //    10  :))
	LDS  R30,_StoGramm
	LDS  R31,_StoGramm+1
	LDS  R22,_StoGramm+2
	LDS  R23,_StoGramm+3
	RCALL SUBOPT_0x2
	STS  _StoGramm,R30
	STS  _StoGramm+1,R31
	STS  _StoGramm+2,R22
	STS  _StoGramm+3,R23
;      77               i=0;
	LDI  R30,0
	STS  _i,R30
	STS  _i+1,R30
	STS  _i+2,R30
	STS  _i+3,R30
;      78               //   /100       SpeedCounter-        
;      79            
;      80            LitrNaSotny=Impuls_km*100/SpeedCounter;   //     100  
	LDS  R26,_Impuls_km
	LDS  R27,_Impuls_km+1
	LDS  R24,_Impuls_km+2
	LDS  R25,_Impuls_km+3
	__GETD1N 0x64
	RCALL __MULD12U
	MOVW R26,R30
	MOVW R24,R22
	RCALL SUBOPT_0x1
	RCALL __DIVD21U
	RCALL __CDF1U
	RCALL SUBOPT_0x9
;      81                                                      //        
;      82                                                      //         100
;      83                                                      // 1 = 10 .
;      84                                                      
;      85           if (LitrNaSotny>10000) {
	RCALL SUBOPT_0xA
	__GETD1N 0x461C4000
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x6
;      86           LitrNaSotny=99990 ;
	__GETD1N 0x47C34B00
	RCALL SUBOPT_0x9
;      87                };
_0x6:
;      88                                            
;      89                                                      
;      90                                                      
;      91                                                       
;      92                                                      
;      93           
;      94            SpeedCounter=0;
	LDI  R30,0
	STS  _SpeedCounter,R30
	STS  _SpeedCounter+1,R30
	STS  _SpeedCounter+2,R30
	STS  _SpeedCounter+3,R30
;      95            TotalFuel=TotalFuel+1;   // 10 +
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xC
;      96            
;      97               
;      98               };
_0x5:
;      99 
;     100 
;     101     }
;     102     else   //  
	RJMP _0x7
_0x4:
;     103     {    
;     104              
;     105              MCUCR=0x0F;      //    
	LDI  R30,LOW(15)
	OUT  0x35,R30
;     106         TCCR1B=0x02;// 1  //  
	LDI  R30,LOW(2)
	OUT  0x2E,R30
;     107 
;     108 } 
_0x7:
;     109       }
	RCALL SUBOPT_0x6
	RETI
;     110 
;     111 
;     112 
;     113 
;     114 
;     115 
;     116 
;     117 void main(void)
;     118 {
_main:
;     119 
;     120 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
;     121 DDRB=0x00;
	OUT  0x17,R30
;     122 
;     123 PORTC=0x7F;
	LDI  R30,LOW(127)
	OUT  0x15,R30
;     124 DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
;     125 
;     126 PORTD=0x01;
	RCALL SUBOPT_0xD
;     127 DDRD=0x01;
	LDI  R30,LOW(1)
	OUT  0x11,R30
;     128 //PORTD=0x00;
;     129 //DDRD=0xF3;
;     130 //DDRD=0x00;
;     131 
;     132 
;     133 // Timer/Counter 0 initialization
;     134 // Clock source: System Clock
;     135 // Clock value: 7,813 kHz
;     136 TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
;     137 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     138 
;     139 
;     140 
;     141 
;     142 
;     143 
;     144 
;     145 
;     146 
;     147 
;     148 // Timer/Counter 1 initialization
;     149 // Clock source: System Clock
;     150 // Clock value: 1000,000 kHz
;     151 // Mode: Normal top=FFFFh
;     152 // OC1A output: Discon.
;     153 // OC1B output: Discon.
;     154 // Noise Canceler: Off
;     155 // Input Capture on Falling Edge
;     156 // Timer 1 Overflow Interrupt: On
;     157 // Input Capture Interrupt: Off
;     158 // Compare A Match Interrupt: Off
;     159 // Compare B Match Interrupt: Off
;     160 TCCR1A=0x00;
	OUT  0x2F,R30
;     161 TCCR1B=0x03;
	LDI  R30,LOW(3)
	OUT  0x2E,R30
;     162 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     163 TCNT1L=0x00;
	OUT  0x2C,R30
;     164 ICR1H=0x00;
	OUT  0x27,R30
;     165 ICR1L=0x00;
	OUT  0x26,R30
;     166 OCR1AH=0x00;
	OUT  0x2B,R30
;     167 OCR1AL=0x00;
	OUT  0x2A,R30
;     168 OCR1BH=0x00;
	OUT  0x29,R30
;     169 OCR1BL=0x00;
	OUT  0x28,R30
;     170 
;     171 // Timer/Counter 2 initialization
;     172 // Clock source: System Clock
;     173 // Clock value: Timer 2 Stopped
;     174 // Mode: Normal top=FFh
;     175 // OC2 output: Disconnected
;     176 ASSR=0x00;
	OUT  0x22,R30
;     177 TCCR2=0x00;
	OUT  0x25,R30
;     178 TCNT2=0x00;
	OUT  0x24,R30
;     179 OCR2=0x00;
	OUT  0x23,R30
;     180 
;     181 // External Interrupt(s) initialization
;     182 // INT0: On
;     183 // INT0 Mode: Rising Edge
;     184 // INT1: On
;     185 // INT1 Mode: Any change
;     186 GICR|=0xC0;
	IN   R30,0x3B
	ORI  R30,LOW(0xC0)
	OUT  0x3B,R30
;     187 //MCUCR=0x07;
;     188 MCUCR=0x0B;
	LDI  R30,LOW(11)
	OUT  0x35,R30
;     189 GIFR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3A,R30
;     190 
;     191 // Timer(s)/Counter(s) Interrupt(s) initialization
;     192 TIMSK=0x01;
	LDI  R30,LOW(1)
	OUT  0x39,R30
;     193 
;     194 // Analog Comparator initialization
;     195 // Analog Comparator: Off
;     196 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     197 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     198 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     199 
;     200 
;     201 
;     202 // Global enable interrupts
;     203 #asm("sei")
	sei
;     204 // LCD module initialization
;     205 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     206 delay_ms(100);
	RCALL SUBOPT_0xE
;     207 //lcd_putsf("test");
;     208 delay_ms(5);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0xF
;     209 
;     210 if (eepromPrFors<200) {
	LDI  R26,LOW(_eepromPrFors)
	LDI  R27,HIGH(_eepromPrFors)
	RCALL __EEPROMRDD
	RCALL SUBOPT_0x10
	BRSH _0x8
;     211 eepromPrFors=830; 
	__GETD1N 0x33E
	RCALL SUBOPT_0x11
;     212 };
_0x8:
;     213 if (eepromImpuls_km<200) {
	LDI  R26,LOW(_eepromImpuls_km)
	LDI  R27,HIGH(_eepromImpuls_km)
	RCALL __EEPROMRDD
	RCALL SUBOPT_0x10
	BRSH _0x9
;     214 eepromImpuls_km=5000; 
	__GETD1N 0x1388
	RCALL SUBOPT_0x12
;     215 };
_0x9:
;     216 
;     217 
;     218 TotalFuel=0;
	__GETD1N 0x0
	RCALL SUBOPT_0xC
;     219 PrFors=eepromPrFors*1000;
	LDI  R26,LOW(_eepromPrFors)
	LDI  R27,HIGH(_eepromPrFors)
	RCALL __EEPROMRDD
	__GETD2N 0x3E8
	RCALL __MULD12U
	RCALL SUBOPT_0x13
;     220 Impuls_km=eepromImpuls_km;
	LDI  R26,LOW(_eepromImpuls_km)
	LDI  R27,HIGH(_eepromImpuls_km)
	RCALL __EEPROMRDD
	RCALL SUBOPT_0x14
;     221 TotalFuel=eepromTotalFuel;
	LDI  R26,LOW(_eepromTotalFuel)
	LDI  R27,HIGH(_eepromTotalFuel)
	RCALL __EEPROMRDD
	RCALL __CDF1U
	RCALL SUBOPT_0xC
;     222 TotalPut=eepromTotalPut;
	LDI  R26,LOW(_eepromTotalPut)
	LDI  R27,HIGH(_eepromTotalPut)
	RCALL __EEPROMRDD
	RCALL __CDF1U
	RCALL SUBOPT_0x5
;     223 
;     224 PORTD=0x00; 
	LDI  R30,LOW(0)
	OUT  0x12,R30
;     225 delay_ms(100);
	RCALL SUBOPT_0xE
;     226  PORTD=0x01; 
	RCALL SUBOPT_0xD
;     227  delay_ms(100);
	RCALL SUBOPT_0xE
;     228  PORTD=0x00; 
	LDI  R30,LOW(0)
	OUT  0x12,R30
;     229 delay_ms(100);
	RCALL SUBOPT_0xE
;     230  PORTD=0x01; 
	RCALL SUBOPT_0xD
;     231  delay_ms(100);
	RCALL SUBOPT_0xE
;     232  PORTD=0x00; 
	LDI  R30,LOW(0)
	OUT  0x12,R30
;     233 //delay_ms(100);
;     234 // PORTD=0x01; 
;     235 // delay_ms(100);
;     236  
;     237 lcd_clear();
	RCALL _lcd_clear
;     238       
;     239 
;     240         
;     241 while (1)
_0xA:
;     242   //   eepromTotalFuel=TotalFuel/100;
;     243    //  eepromTotalPut=TotalPut/100;
;     244     // delay_ms(1000);
;     245  {
;     246   
;     247   ;
;     248   if (Speed_For_light>3) {
	LDS  R26,_Speed_For_light
	LDS  R27,_Speed_For_light+1
	LDS  R24,_Speed_For_light+2
	LDS  R25,_Speed_For_light+3
	__CPD2N 0x4
	BRLO _0xD
;     249 PORTD=0x01; 
	RCALL SUBOPT_0xD
;     250 };
_0xD:
;     251 
;     252 
;     253 
;     254         
;     255       
;     256 
;     257     
;     258     
;     259 
;     260 
;     261       
;     262        
;     263              
;     264        
;     265                     
;     266        if ( PINC.1==0) {
	SBIC 0x13,1
	RJMP _0xE
;     267            lcd_clear();
	RCALL SUBOPT_0x15
;     268             rezhim++;    
;     269                        if (rezhim>2) {
	RCALL SUBOPT_0x16
	BRGE _0xF
;     270        
;     271                        rezhim=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	MOVW R4,R30
;     272       
;     273                        };
_0xF:
;     274            
;     275   delay_ms(400);  
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	RCALL SUBOPT_0xF
;     276 }; //        
_0xE:
;     277 
;     278         if ( PINC.2==0) {
	SBIC 0x13,2
	RJMP _0x10
;     279            lcd_clear();
	RCALL SUBOPT_0x15
;     280             rezhim++; 
;     281             
;     282             if (rezhim<4) {
	RCALL SUBOPT_0x17
	CP   R4,R30
	CPC  R5,R31
	BRGE _0x11
;     283        
;     284                        rezhim=4;
	RCALL SUBOPT_0x17
	MOVW R4,R30
;     285       
;     286                        };
_0x11:
;     287                        
;     288                           
;     289                        if (rezhim==6) {
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RCALL SUBOPT_0x18
	BRNE _0x12
;     290        
;     291                        rezhim=4;
	RCALL SUBOPT_0x17
	MOVW R4,R30
;     292       
;     293                        };
_0x12:
;     294            
;     295   delay_ms(400);  
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	RCALL SUBOPT_0xF
;     296 }; //            
_0x10:
;     297       //*******************************************  
;     298               //   
;     299              if (rezhim==1) {               
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0x18
	BRNE _0x13
;     300         
;     301          lcd_gotoxy(10,0);
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
;     302       lcd_putsf("Litrs ");
	__POINTW1FN _0,0
	RCALL SUBOPT_0x1B
;     303       lcd_gotoxy(10,1);
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1C
	RCALL _lcd_gotoxy
;     304       lcd_putsf("L/100 ");
	__POINTW1FN _0,7
	RCALL SUBOPT_0x1B
;     305         
;     306         
;     307           lcd_gotoxy(1,0); //  
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1A
;     308          ftoa(TotalFuel/100,2,TotalFuelStr);
	RCALL SUBOPT_0x1D
;     309          lcd_puts(TotalFuelStr);
;     310          lcd_putsf("   ");
;     311        
;     312        lcd_gotoxy(1,1);    // /100
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1C
	RCALL _lcd_gotoxy
;     313        ftoa(LitrNaSotny/100,1,LitrNaSotnyStr);
	RCALL SUBOPT_0xA
	__GETD1N 0x42C80000
	RCALL __DIVF21
	RCALL __PUTPARD1
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1E
	RCALL _ftoa
;     314        lcd_puts(LitrNaSotnyStr);
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1F
;     315        lcd_putsf("   ");
;     316        
;     317     
;     318        
;     319        
;     320        };  //  if (rezhim==1) 
_0x13:
;     321         
;     322         
;     323              //   
;     324              if (rezhim==2) {               
	RCALL SUBOPT_0x16
	BRNE _0x14
;     325         
;     326        lcd_gotoxy(10,0);
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
;     327       lcd_putsf("Litrs");
	__POINTW1FN _0,18
	RCALL SUBOPT_0x1B
;     328       lcd_gotoxy(10,1);
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1C
	RCALL _lcd_gotoxy
;     329       lcd_putsf("Kilom.");
	__POINTW1FN _0,24
	RCALL SUBOPT_0x1B
;     330         
;     331         
;     332           lcd_gotoxy(1,0); //  
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1A
;     333          ftoa(TotalFuel/100,2,TotalFuelStr);
	RCALL SUBOPT_0x1D
;     334          lcd_puts(TotalFuelStr);
;     335          lcd_putsf("   ");
;     336        
;     337        lcd_gotoxy(1,1);    //  
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1C
	RCALL _lcd_gotoxy
;     338        ftoa(TotalPut/Impuls_km,2,TotalPutStr);
	RCALL SUBOPT_0x20
	LDS  R26,_TotalPut
	LDS  R27,_TotalPut+1
	LDS  R24,_TotalPut+2
	LDS  R25,_TotalPut+3
	RCALL __CDF1U
	RCALL __DIVF21
	RCALL __PUTPARD1
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL SUBOPT_0x21
	RCALL _ftoa
;     339        lcd_puts(TotalPutStr);
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x1F
;     340        lcd_putsf("   ");
;     341      
;     342        
;     343     
;     344        
;     345        
;     346        };  //  if (rezhim==2) 
_0x14:
;     347         
;     348         
;     349                                                  
;     350       
;     351              //   
;     352              if (rezhim==3) {               
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL SUBOPT_0x18
	BRNE _0x15
;     353         
;     354        lcd_gotoxy(4,0);
	RCALL SUBOPT_0x22
;     355        lcd_putsf("Options");     
	__POINTW1FN _0,31
	RCALL SUBOPT_0x1B
;     356        
;     357     
;     358        
;     359        };  //  if (rezhim==3) 
_0x15:
;     360       
;     361       
;     362                  //   
;     363              if (rezhim==4) {               
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	BRNE _0x16
;     364         
;     365        lcd_gotoxy(4,0);
	RCALL SUBOPT_0x22
;     366       lcd_putsf("Forsunka");
	__POINTW1FN _0,39
	RCALL SUBOPT_0x1B
;     367       itoa(PrFors/1000,Vtoraya_Stroka);
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
;     368        lcd_gotoxy(5,1); 
	RCALL _lcd_gotoxy
;     369        lcd_puts(Vtoraya_Stroka);
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x1F
;     370        lcd_putsf("   ");
;     371       
;     372        if ( PINC.3==0) {      // +
	SBIC 0x13,3
	RJMP _0x17
;     373        PrFors=PrFors+1000;
	RCALL SUBOPT_0x8
	__ADDD1N 1000
	RCALL SUBOPT_0x13
;     374        eepromPrFors=PrFors/1000; 
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x11
;     375       delay_ms(100);
	RCALL SUBOPT_0xE
;     376        };
_0x17:
;     377       
;     378         if ( PINC.4==0) {      // -
	SBIC 0x13,4
	RJMP _0x18
;     379        PrFors=PrFors-1000;
	RCALL SUBOPT_0x8
	__SUBD1N 1000
	RCALL SUBOPT_0x13
;     380        eepromPrFors=PrFors/1000; 
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x11
;     381       delay_ms(100);
	RCALL SUBOPT_0xE
;     382        };
_0x18:
;     383       
;     384        
;     385        };  //  if (rezhim==4) 
_0x16:
;     386       
;     387       
;     388       
;     389                        //   
;     390              if (rezhim==5) {               
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0x18
	BRNE _0x19
;     391         
;     392        lcd_gotoxy(4,0);
	RCALL SUBOPT_0x22
;     393       lcd_putsf("Speed");
	__POINTW1FN _0,48
	RCALL SUBOPT_0x1B
;     394       lcd_putsf("   ");
	__POINTW1FN _0,14
	RCALL SUBOPT_0x1B
;     395       itoa(Impuls_km,Vtoraya_Stroka);
	LDS  R30,_Impuls_km
	LDS  R31,_Impuls_km+1
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
;     396        lcd_gotoxy(5,1); 
	RCALL _lcd_gotoxy
;     397        lcd_puts(Vtoraya_Stroka);
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x1F
;     398        lcd_putsf("   ");
;     399       
;     400        if ( PINC.3==0) {      // +
	SBIC 0x13,3
	RJMP _0x1A
;     401        Impuls_km++;
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x27
;     402        eepromImpuls_km=Impuls_km; 
;     403       delay_ms(100);
;     404        };
_0x1A:
;     405       
;     406         if ( PINC.4==0) {      // -
	SBIC 0x13,4
	RJMP _0x1B
;     407        Impuls_km--;
	RCALL SUBOPT_0x20
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	RCALL SUBOPT_0x27
;     408        eepromImpuls_km=Impuls_km; 
;     409       delay_ms(100);
;     410        };
_0x1B:
;     411       
;     412        
;     413        };  //  if (rezhim==5) 
_0x19:
;     414       
;     415       
;     416        //********************************************
;     417        //   -,   .   
;     418        eepromTotalPut=TotalPut;
	RCALL SUBOPT_0x3
	RCALL __CFD1
	LDI  R26,LOW(_eepromTotalPut)
	LDI  R27,HIGH(_eepromTotalPut)
	RCALL __EEPROMWRD
;     419        eepromTotalFuel=TotalFuel;
	RCALL SUBOPT_0xB
	RCALL __CFD1
	LDI  R26,LOW(_eepromTotalFuel)
	LDI  R27,HIGH(_eepromTotalFuel)
	RCALL __EEPROMWRD
;     420       // eepromTotalPut=0;
;     421       // eepromTotalFuel=0;
;     422       //eepromTotalFuel=15; 
;     423        };  //  
	RJMP _0xA
;     424      
;     425 }
_0x1C:
	RJMP _0x1C
;     426 
;     427 
;     428 
;     429       
;     430 

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x0:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1:
	LDS  R30,_SpeedCounter
	LDS  R31,_SpeedCounter+1
	LDS  R22,_SpeedCounter+2
	LDS  R23,_SpeedCounter+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2:
	__SUBD1N -1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3:
	LDS  R30,_TotalPut
	LDS  R31,_TotalPut+1
	LDS  R22,_TotalPut+2
	LDS  R23,_TotalPut+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	__GETD2N 0x3F800000
	RCALL __ADDF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5:
	STS  _TotalPut,R30
	STS  _TotalPut+1,R31
	STS  _TotalPut+2,R22
	STS  _TotalPut+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x6:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7:
	LDS  R26,_i
	LDS  R27,_i+1
	LDS  R24,_i+2
	LDS  R25,_i+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x8:
	LDS  R30,_PrFors
	LDS  R31,_PrFors+1
	LDS  R22,_PrFors+2
	LDS  R23,_PrFors+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x9:
	STS  _LitrNaSotny,R30
	STS  _LitrNaSotny+1,R31
	STS  _LitrNaSotny+2,R22
	STS  _LitrNaSotny+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA:
	LDS  R26,_LitrNaSotny
	LDS  R27,_LitrNaSotny+1
	LDS  R24,_LitrNaSotny+2
	LDS  R25,_LitrNaSotny+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xB:
	LDS  R30,_TotalFuel
	LDS  R31,_TotalFuel+1
	LDS  R22,_TotalFuel+2
	LDS  R23,_TotalFuel+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0xC:
	STS  _TotalFuel,R30
	STS  _TotalFuel+1,R31
	STS  _TotalFuel+2,R22
	STS  _TotalFuel+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(1)
	OUT  0x12,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:30 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xF:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x10:
	__CPD1N 0xC8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x11:
	LDI  R26,LOW(_eepromPrFors)
	LDI  R27,HIGH(_eepromPrFors)
	RCALL __EEPROMWRD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x12:
	LDI  R26,LOW(_eepromImpuls_km)
	LDI  R27,HIGH(_eepromImpuls_km)
	RCALL __EEPROMWRD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x13:
	STS  _PrFors,R30
	STS  _PrFors+1,R31
	STS  _PrFors+2,R22
	STS  _PrFors+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x14:
	STS  _Impuls_km,R30
	STS  _Impuls_km+1,R31
	STS  _Impuls_km+2,R22
	STS  _Impuls_km+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x15:
	RCALL _lcd_clear
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x18:
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(10)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x1A:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RJMP _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x1B:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x1C:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x1D:
	LDS  R26,_TotalFuel
	LDS  R27,_TotalFuel+1
	LDS  R24,_TotalFuel+2
	LDS  R25,_TotalFuel+3
	__GETD1N 0x42C80000
	RCALL __DIVF21
	RCALL __PUTPARD1
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(_TotalFuelStr)
	LDI  R31,HIGH(_TotalFuelStr)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _ftoa
	LDI  R30,LOW(_TotalFuelStr)
	LDI  R31,HIGH(_TotalFuelStr)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_puts
	__POINTW1FN _0,14
	RJMP SUBOPT_0x1B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	LDI  R30,LOW(_LitrNaSotnyStr)
	LDI  R31,HIGH(_LitrNaSotnyStr)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1F:
	RCALL _lcd_puts
	__POINTW1FN _0,14
	RJMP SUBOPT_0x1B

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x20:
	LDS  R30,_Impuls_km
	LDS  R31,_Impuls_km+1
	LDS  R22,_Impuls_km+2
	LDS  R23,_Impuls_km+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x21:
	LDI  R30,LOW(_TotalPutStr)
	LDI  R31,HIGH(_TotalPutStr)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x22:
	LDI  R30,LOW(4)
	ST   -Y,R30
	RJMP SUBOPT_0x1A

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x23:
	LDS  R26,_PrFors
	LDS  R27,_PrFors+1
	LDS  R24,_PrFors+2
	LDS  R25,_PrFors+3
	__GETD1N 0x3E8
	RCALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x24:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x25:
	LDI  R30,LOW(_Vtoraya_Stroka)
	LDI  R31,HIGH(_Vtoraya_Stroka)
	RJMP SUBOPT_0x24

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	RCALL _itoa
	LDI  R30,LOW(5)
	ST   -Y,R30
	RJMP SUBOPT_0x1C

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x27:
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x12
	RJMP SUBOPT_0xE

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R19
	CLR  R20
	LDI  R21,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R19
	ROL  R20
	SUB  R0,R30
	SBC  R1,R31
	SBC  R19,R22
	SBC  R20,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R19,R22
	ADC  R20,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R21
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOV  R24,R19
	MOV  R25,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__EEPROMRDD:
	ADIW R26,2
	RCALL __EEPROMRDW
	MOV  R23,R31
	MOV  R22,R30
	SBIW R26,2

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRD:
	RCALL __EEPROMWRW
	ADIW R26,2
	MOV  R0,R30
	MOV  R1,R31
	MOV  R30,R22
	MOV  R31,R23
	RCALL __EEPROMWRW
	MOV  R30,R0
	MOV  R31,R1
	SBIW R26,2
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIC EECR,EEWE
	RJMP __EEPROMWRB
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	MOV  R21,R30
	MOV  R30,R26
	MOV  R26,R21
	MOV  R21,R31
	MOV  R31,R27
	MOV  R27,R21
	MOV  R21,R22
	MOV  R22,R24
	MOV  R24,R21
	MOV  R21,R23
	MOV  R23,R25
	MOV  R25,R21
	MOV  R21,R0
	MOV  R0,R1
	MOV  R1,R21
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __MAXRES
	RJMP __MINRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	LSR  R22
	ROR  R31
	ROR  R30
	LSR  R24
	ROR  R27
	ROR  R26
	PUSH R20
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R25,24
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R1
	ROL  R20
	ROL  R21
	ROL  R26
	ROL  R27
	ROL  R24
	DEC  R25
	BRNE __DIVF212
	MOV  R30,R1
	MOV  R31,R20
	MOV  R22,R21
	LSR  R26
	ADC  R30,R25
	ADC  R31,R25
	ADC  R22,R25
	POP  R20
	TST  R22
	BRMI __DIVF215
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
