/*****************************************************
Chip type           : ATmega32
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256

*****************************************************/
#include <stdlib.h>
#include <mega32.h>
#include <delay.h>
#include <stdio.h>
#include <alcd.h>
        
#asm
   .equ __lcd_port=0x12 ;PORTD
#endasm




#define ADC_VREF_TYPE 0x00

// 
#define KEY_RIGHT PINB.1
#define KEY_MENU PINB.5
#define KEY_UP PINB.0
#define KEY_DOWN PINB.2
#define KEY_LEFT PINB.4

#define TIME_ANTIDREB 100
#define DELAY_KEY_PRESSED 50  

#define LEG_IGNITION PIND.4       //  
#define LEG_LIGHT PIND.5          //  
#define PIN_DRL PORTC.6           //   
//#define PIN_BRIGHTNESS PORTC.5     

#define K_SRED_OST_KM 3       //    
#define K_SRED_DL_VPR 100     //    
#define DRL_SPEED 4           //        
//   

//      .   
#define DISP_SAVING 202
#define DISP_CLOCKS 130
#define DISP_CONTRAST 201
#define DISP_CLIMAT 150
#define DISP_ABOUT  200
#define DISP_DEBAG 210



#define DISP_MENU 110
#define DISP_MAIN_1 101
#define DISP_MAIN_2 102
#define DISP_MAIN_3 103

#define PUNKTOV_MENU 9    //  
#define DISP_NUMBER_MIN 10
#define DISP_NUMBER_MAX 18

#define DISP_ZAPRAVKA 10
#define DISP_RST_COUNTERS 11
#define DISP_SERVIS 12

#define DISP_OIL 13
#define DISP_GRM 14
#define DISP_FORS 15
#define DISP_SPEED 16

#define DISP_BRIGHTNESS 17
#define RST_DEFAULT 18


   

eeprom char eeprom_display_brightness = 5; 
eeprom unsigned long int  eeprom_v_bake;
eeprom unsigned int  eeprom_imp_km; 
eeprom float eeprom_PrFors;  //  4    // 722,89    
eeprom unsigned long int eeprom_do_zameny_grm_imp;
eeprom unsigned long int eeprom_do_zameny_masla_imp;
eeprom unsigned long int eeprom_vlito_total_ml;
eeprom unsigned long int eeprom_put_total_imp;
eeprom char eeprom_power_on_flag;
eeprom unsigned long int eeprom_hardreset_count;


unsigned long int chasiki =32400; 




float PrFors;   //   
unsigned long int imp_km;  //      
unsigned long int overflov_count_fors_mks =0;  //           

//   
unsigned long int  put_total_imp;
unsigned long int put_total_m;
float  vlito_total_ml;
float rashod_sred_l;
float  v_bake =0; //   

//     ,    ? :) 

// ,   
float rashod_mom_l =0;
unsigned long int calc_mom_rashod_count =0;
//  
unsigned long int  put_start_imp_mom_rash=0;
float  vlito_start_mom_rash=0;

char speed=0;
unsigned long int  speed_counter=0;
char flag_measure_speed =0; // :   , ,    1.
                            //    ,  ,  1 ,     2. 
                            //     .      ,  1 ,    3-  .




//  
char dlit_vpr_ready =0; // :   , ,    1.
                            //    ,  ,  dlit_vpr_zamer_count ,     2. 
                            //     .      ,  dlit_vpr_zamer_count > dlit_vpr_zamer ,    3-  .
                            
unsigned long int dlit_vpr =0;  //   

unsigned long int count_dlit_vpr_mks =0; //  

unsigned int dlit_vpr_zamer = 10; //    ,  
unsigned int dlit_vpr_zamer_count =0;//       
unsigned int revs_count_dl_vpr;      //  ,    

//  ,     .
unsigned long int  do_zameny_grm_imp =0;  
unsigned long int  do_zameny_masla_imp =0;

//    
float ost_km = 0; //     v_bake    .
float sred_ost_km;
char ost_km_count;

float adc_data =0;
float  v_bake_plus;
char displ_buffer[16];
char display_brightness = 0;
char old_display_number=255;
bit temp_data_saved =0;
int sel_item;
unsigned char refresh_lcd_count;

char flag_refresh_display =0;
char flag_calculate_data =0;
char display_number=DISP_MAIN_1;

//         
char refresh_display_worked = 0;
char flag_calculate_data_worked = 0;

void refresh_display(void);
void kb(void);
void add_ost_km(float new_data);
void enable_drl(void);
void save_temp_data(void);
void load_temp_data(void);
void load_defaults(void);
void calc_mom_rashod(void);
void main_cykl(void);
void calculate_data(void);
void calc_dlit_vpr(void);

//   
float debag_data1;
float debag_data2;

//char climat_enabled =0;
float temp_set =23;
float temp_real =10;
int clima_step =0;