
#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADCSR=6;     
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

void _lcd_write_data(unsigned char data);

unsigned char lcd_read_byte(unsigned char addr);

void lcd_write_byte(unsigned char addr, unsigned char data);

void lcd_gotoxy(unsigned char x, unsigned char y);

void lcd_clear(void);
void lcd_putchar(char c);

void lcd_puts(char *str);

void lcd_putsf(char flash *str);

void lcd_putse(char eeprom *str);

void lcd_init(unsigned char lcd_columns);

#pragma library alcd.lib

#asm
   .equ __lcd_port=0x12 ;PORTD
#endasm

eeprom char eeprom_display_brightness = 5; 
eeprom unsigned long int  eeprom_v_bake;
eeprom unsigned int  eeprom_imp_km; 
eeprom float eeprom_PrFors;  
eeprom unsigned long int eeprom_do_zameny_grm_imp;
eeprom unsigned long int eeprom_do_zameny_masla_imp;
eeprom unsigned long int eeprom_vlito_total_ml;
eeprom unsigned long int eeprom_put_total_imp;
eeprom char eeprom_power_on_flag;
eeprom unsigned long int eeprom_hardreset_count;

unsigned long int chasiki =32400; 

float PrFors;   
unsigned long int imp_km;  
unsigned long int overflov_count_fors_mks =0;  

unsigned long int  put_total_imp;
unsigned long int put_total_m;
float  vlito_total_ml;
float rashod_sred_l;
float  v_bake =0; 

float rashod_mom_l =0;
unsigned long int calc_mom_rashod_count =0;

unsigned long int  put_start_imp_mom_rash=0;
float  vlito_start_mom_rash=0;

char speed=0;
unsigned long int  speed_counter=0;
char flag_measure_speed =0; 

char dlit_vpr_ready =0; 

unsigned long int dlit_vpr =0;  

unsigned long int count_dlit_vpr_mks =0; 

unsigned int dlit_vpr_zamer = 10; 
unsigned int dlit_vpr_zamer_count =0;
unsigned int revs_count_dl_vpr;      

unsigned long int  do_zameny_grm_imp =0;  
unsigned long int  do_zameny_masla_imp =0;

float ost_km = 0; 
float sred_ost_km;
char ost_km_count;

float adc_data =0;
float  v_bake_plus;
char displ_buffer[16];
char display_brightness = 0;
char old_display_number=255;
bit temp_data_saved =0;
int sel_item;
unsigned char refresh_lcd_count;

char flag_refresh_display =0;
char flag_calculate_data =0;
char display_number=101;

char refresh_display_worked = 0;
char flag_calculate_data_worked = 0;

void refresh_display(void);
void kb(void);
void add_ost_km(float new_data);
void enable_drl(void);
void save_temp_data(void);
void load_temp_data(void);
void load_defaults(void);
void calc_mom_rashod(void);
void main_cykl(void);
void calculate_data(void);
void calc_dlit_vpr(void);

float debag_data1;
float debag_data2;

float temp_set =23;
float temp_real =10;
int clima_step =0;
void ports_init(void)
{
PORTA=0b00000000;
DDRA =0b00000000;

PORTB=0b11111111;
DDRB =0b00001000;

PORTC=0b00000000;    
DDRC= 0b11111111;

PORTD=0b10111100;
DDRD= 0b10000000;
}

void timers_init(void)
{

TCCR0=0x6A;
TCNT0=0x00;
OCR0=0x00;

TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x1E;
OCR1AL=0x85;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x00;
TCCR2=0x02;
TCNT2=0x00;
OCR2=0x00;

GICR|=0xC0;

MCUCR=0b00001001;

GIFR=0xC0;
ACSR=0x80;
SFIOR=0x00;

TIMSK=0b01010000;   

}

interrupt [11] void timer0_comp_isr(void)
{
PORTC.0 = 0;
}

interrupt [12] void timer0_ovf_isr(void)
{
PORTC.0 = 1;
}

interrupt [8] void timer1_compa_isr(void)
{

chasiki++;
if(chasiki >= 86400){chasiki = 0; }

TCNT1 =0;

if(flag_measure_speed == 1)
{
flag_measure_speed =2; 
}  
else
{
if(flag_measure_speed == 2){flag_measure_speed =3;} 
}
if(PIND.4       )
{
if(!dlit_vpr_ready)
{
dlit_vpr_zamer_count++;
if(dlit_vpr_zamer_count >= dlit_vpr_zamer){dlit_vpr_ready = 1;dlit_vpr_zamer_count=0;} 
} 

calc_mom_rashod_count++;
}
flag_refresh_display = 1;

ADCSRA|=0xCB; 
flag_calculate_data = 1; 

}

interrupt [3] void ext_int1_isr(void)
{
put_total_imp++;
do_zameny_grm_imp--;
do_zameny_masla_imp--;
if(flag_measure_speed == 2){speed_counter++;} 
}

interrupt [17] void adc_isr(void)
{
adc_data =0;ADCSRA|=0x00;return; 
adc_data=ADCW;

}

void load_defaults(void)
{

eeprom_v_bake = 0;
eeprom_imp_km = 5000; 
eeprom_PrFors = 775.9; 
eeprom_do_zameny_grm_imp = 0;
eeprom_do_zameny_masla_imp = 0;
eeprom_vlito_total_ml = 0;
eeprom_put_total_imp = 0;

eeprom_display_brightness = 3;
eeprom_power_on_flag =1;
eeprom_hardreset_count=0;
#asm
   JMP __RESET
#endasm 
}

void main(void)
{
ports_init();
lcd_init(16);
lcd_putsf("  - - - -");
delay_ms(200);
if((!PINB.0)&&(!PINB.2))
{
load_defaults();   
lcd_putsf("   Loading   ");
lcd_putsf("   defaults..");
delay_ms(2000);

} 

timers_init();
load_temp_data();

ost_km_count =0;
sred_ost_km =0;
PrFors = eeprom_PrFors;
imp_km = eeprom_imp_km;
ADMUX=0x00;
ADCSRA=0x8F;
refresh_lcd_count = 0;
refresh_display_worked = 0;
#asm("sei") 
flag_refresh_display = 1;
if(eeprom_power_on_flag){eeprom_hardreset_count++;}
eeprom_power_on_flag = 1;

main_cykl();
}

void calc_mom_rashod(void)                                                                                             

{    
float  put_mom_km ;
float vlito_mom_l;
float new_rashod;

if(calc_mom_rashod_count >= 3)  
{
put_mom_km = put_total_imp - put_start_imp_mom_rash;

put_mom_km = put_mom_km/imp_km;
vlito_mom_l = (vlito_total_ml - vlito_start_mom_rash)/1000;

if(put_mom_km){new_rashod = (vlito_mom_l/put_mom_km)*100;}
else{new_rashod = 99;}
if((new_rashod+0.15 < rashod_mom_l)||(new_rashod > rashod_mom_l)){rashod_mom_l = new_rashod;}
if(rashod_mom_l > 99){rashod_mom_l = 99.9;}
if(rashod_mom_l < 0){rashod_mom_l = 99.9;} 

put_start_imp_mom_rash=put_total_imp;
vlito_start_mom_rash = vlito_total_ml;
calc_mom_rashod_count =0;
}
}

void calc_dlit_vpr(void)
{

if(!dlit_vpr_ready){return;}

if(revs_count_dl_vpr < 20){dlit_vpr = 99;} 
else{dlit_vpr = count_dlit_vpr_mks/revs_count_dl_vpr;}

count_dlit_vpr_mks =0;
dlit_vpr_zamer_count =0;
revs_count_dl_vpr = 0;
dlit_vpr_ready =0;
}

void calculate_data(void)
{
char new_speed;

if(flag_calculate_data_worked){return;}
flag_calculate_data_worked = 1;

if(put_total_imp < 500*imp_km)
{
put_total_m = put_total_imp*1000/imp_km;
}
else
{
put_total_m = put_total_imp/imp_km*1000;
}

if(put_total_m>1000)
{
rashod_sred_l = (vlito_total_ml/put_total_m)*100;
}
else
{
rashod_sred_l = 99.9;
}
add_ost_km(v_bake / rashod_sred_l/10);

if(flag_measure_speed == 3)  
{

speed_counter = speed_counter*3600;
new_speed = (speed_counter/imp_km);
if(new_speed+1 != speed){speed = new_speed;}
if(speed < 2){speed =0;}
flag_measure_speed = 1;
speed_counter =0;
}

flag_calculate_data = 0;
flag_calculate_data_worked = 0;
}

void add_ost_km(float new_data)
{

if(new_data < ost_km){ost_km = new_data;}
if(new_data > ost_km+25){ost_km = new_data;}
return;

if(ost_km+3 < new_data){ost_km = new_data;}

if(ost_km_count < 3       )
{
ost_km_count++;
sred_ost_km += new_data;
}
else
{
ost_km_count = 0;
ost_km = sred_ost_km/3       ;
sred_ost_km = 0;
}

}

void save_temp_data(void)
{
if( temp_data_saved){return;};

eeprom_v_bake = (int)v_bake;
eeprom_do_zameny_grm_imp = do_zameny_grm_imp;
eeprom_do_zameny_masla_imp = do_zameny_masla_imp;
eeprom_vlito_total_ml = (int)vlito_total_ml;
eeprom_put_total_imp = put_total_imp;
temp_data_saved =1; 

}

void load_temp_data(void)
{
v_bake = eeprom_v_bake;
do_zameny_grm_imp = eeprom_do_zameny_grm_imp;
do_zameny_masla_imp = eeprom_do_zameny_masla_imp;
vlito_total_ml = eeprom_vlito_total_ml;
put_total_imp = eeprom_put_total_imp;  
temp_data_saved =0;
display_brightness = eeprom_display_brightness;
}

void light_display(void)
{

if(((PIND.4       )||(PIND.5          ))&&TCCR0==0x00){TCCR0=0x6A;}  

if((!PIND.4       )&&(!PIND.5          )&&(TCCR0 == 0x6A)){TCCR0=0x00;PORTB.3 =0;} 

}

void enable_drl(void)
{

if((PIND.5          )&&(PORTC.6           )){PORTC.6           =0;
save_temp_data();
#asm
   JMP __RESET
#endasm 
return;};

if(PIND.5          ){return;};

if((PIND.4       )&&(PORTC.6           )){return;}

if((!PIND.4       )&&(!PORTC.6           )){return;}

if((PIND.4       )&&(!PORTC.6           )){if(speed > 4           ){PORTC.6           =1;}return;}

if((!PIND.4       )&&(PORTC.6           )){PORTC.6           =0;save_temp_data();
#asm
   JMP __RESET
#endasm 
return;}
}

void kb(void)  
{ 

if ((display_number==101)||(display_number==102)||(display_number==103))
{
if(!PINB.1)
{ 

refresh_lcd_count =0; 
if(display_number == 101){display_number =102;refresh_display();while(!PINB.1){} delay_ms(100);return;}
if(display_number == 102){display_number =103;refresh_display();while(!PINB.1){} delay_ms(100);return;}
if(display_number == 103){display_number =101;refresh_display();while(!PINB.1){} delay_ms(100);return;}
}
if(!PINB.4)
{ 

refresh_lcd_count =0; 
if(display_number == 103){display_number =102;refresh_display();while(!PINB.4){} delay_ms(100);return;}
if(display_number == 102){display_number =101;refresh_display();while(!PINB.4){} delay_ms(100);return;}
if(display_number == 101){display_number =103;refresh_display();while(!PINB.4){} delay_ms(100);return;}
}
if(!PINB.5)
{   

refresh_lcd_count =0;
display_number = 110;
sel_item = 10;
refresh_display();
while(!PINB.5){}
delay_ms(100);
return;
} 
}

if (display_number==110)
{
if(!PINB.0)
{   
refresh_lcd_count =0;
old_display_number=0;
sel_item--; 
if(sel_item < 10){sel_item =18;}
refresh_display();
while(!PINB.0){}
delay_ms(100);
return;
}
if(!PINB.2)
{
refresh_lcd_count =0;
old_display_number=0;
sel_item++;
if(sel_item > 18){sel_item =10;}
refresh_display();
while(!PINB.2){} 
delay_ms(100);
return;
}
if(!PINB.5)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = sel_item;
refresh_display();
while(!PINB.5){}
delay_ms(100);
return;
}
if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 101;
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}
}

if (display_number==10)   
{
if(!PINB.0)
{
refresh_lcd_count =0;  
old_display_number=0;
v_bake_plus = v_bake_plus + 100;
refresh_display();
delay_ms(50  *5); 
while(!PINB.0){{delay_ms(50  );v_bake_plus = v_bake_plus + 1000;refresh_display();}}
delay_ms(100);
return;
}

if(!PINB.2)
{
refresh_lcd_count =0;
old_display_number=0;
v_bake_plus = v_bake_plus - 100;
refresh_display();
delay_ms(50  *5); 
while(!PINB.2){{delay_ms(50  );v_bake_plus = v_bake_plus - 1000;refresh_display();}} 
delay_ms(100);
return;
}

if(!PINB.1)
{
refresh_lcd_count =0;  
old_display_number=0;
v_bake_plus = v_bake_plus + 10000;
refresh_display();
while(!PINB.1){}
delay_ms(100);
return;
}

if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 110;
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}

if(!PINB.5)  
{
refresh_lcd_count =0;
v_bake = v_bake + v_bake_plus;
old_display_number=0;
display_number = 101;
refresh_display();
while(!PINB.5){}
delay_ms(100);
return;
}

};

if (display_number==12)   
{
if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 110;
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}

if(!PINB.5)       
{

return;
}

};

if (display_number==11)   
{
if(!PINB.1)
{
refresh_lcd_count =0;  
old_display_number=0;
put_total_imp = 0;
vlito_total_ml = 0;
eeprom_put_total_imp = 0;
eeprom_vlito_total_ml = 0;
display_number = 110; 
refresh_display();
while(!PINB.1){}
delay_ms(100);
return;
}

if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 110; 
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}

}  

if (display_number==15)   
{
if(!PINB.0)
{
refresh_lcd_count =0;  
old_display_number=0;
PrFors = PrFors+0.1;
refresh_display();  
delay_ms(50  *5); 
while(!PINB.0){{delay_ms(50  );PrFors = PrFors+1;;refresh_display();}}
delay_ms(100);
return;
}

if(!PINB.2)
{
refresh_lcd_count =0;
old_display_number=0;
PrFors = PrFors-0.1;
refresh_display();
delay_ms(50  *5); 
while(!PINB.2){{delay_ms(50  ); PrFors = PrFors-1;;refresh_display();}} 
delay_ms(100);
return;
}

if(!PINB.1)
{

}

if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 110;
PrFors = eeprom_PrFors;
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}

if(!PINB.5)  
{
refresh_lcd_count =0;
eeprom_PrFors =  PrFors;
old_display_number=0;
display_number = 110;
refresh_display();
while(!PINB.5){}
delay_ms(100);
return;
}

};

if (display_number==16)   
{
if(!PINB.0)
{
refresh_lcd_count =0;  
old_display_number=0;
imp_km = imp_km+1;
refresh_display();
delay_ms(50  *5); 
while(!PINB.0){delay_ms(50  );imp_km = imp_km + 10;refresh_display();}
delay_ms(100);
return;
}

if(!PINB.2)
{
refresh_lcd_count =0;
old_display_number=0;
imp_km = imp_km-1;
refresh_display();
delay_ms(50  *5); 
while(!PINB.2){delay_ms(50  );imp_km = imp_km-10;refresh_display();} 
delay_ms(100);
return;
}

if(!PINB.1)
{
refresh_lcd_count =0;  
old_display_number=0; 
imp_km = imp_km + 1000;
refresh_display();
while(!PINB.1){}
delay_ms(100);
return;
}

if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 110;
imp_km = eeprom_imp_km;
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}

if(!PINB.5)  
{
refresh_lcd_count =0;
eeprom_imp_km =  imp_km;
old_display_number=0;
display_number = 110;
refresh_display();
while(!PINB.5){}
delay_ms(100);
return;
}

}                           

if (display_number==14)   
{
if(!PINB.0)
{
refresh_lcd_count =0;  
old_display_number=0;
do_zameny_grm_imp = do_zameny_grm_imp+(imp_km*1000);     
refresh_display();
delay_ms(50  *5);     
while(!PINB.0){{delay_ms(50  );do_zameny_grm_imp = do_zameny_grm_imp+(imp_km*1000);;refresh_display();}}
delay_ms(100);
return;
}

if(!PINB.2)
{
refresh_lcd_count =0;
old_display_number=0;
do_zameny_grm_imp = do_zameny_grm_imp-(imp_km*100);      
refresh_display();  
delay_ms(50  *5); 
while(!PINB.2){{delay_ms(50  );do_zameny_grm_imp = do_zameny_grm_imp-(imp_km*100);;refresh_display();}} 
delay_ms(100);
return;
}

if(!PINB.1)
{
refresh_lcd_count =0;  
old_display_number=0;
do_zameny_grm_imp = imp_km*100000;
refresh_display();
while(!PINB.1){}
delay_ms(100);
return;
}

if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 110; 
do_zameny_grm_imp = eeprom_do_zameny_grm_imp;
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}

if(!PINB.5)  
{
refresh_lcd_count =0;
eeprom_do_zameny_grm_imp = do_zameny_grm_imp;
old_display_number=0;
display_number = 110;
refresh_display();
while(!PINB.5){}
delay_ms(100);
return;
}
}                            

if (display_number==13)   
{
if(!PINB.0)
{
refresh_lcd_count =0;  
old_display_number=0;  

do_zameny_masla_imp = do_zameny_masla_imp+(imp_km*100);
refresh_display();
delay_ms(50  *5);
while(!PINB.0){delay_ms(50  );do_zameny_masla_imp = do_zameny_masla_imp+(imp_km*100);refresh_display();}
delay_ms(100);
return;
}

if(!PINB.2)
{
refresh_lcd_count =0;
old_display_number=0;
do_zameny_masla_imp = do_zameny_masla_imp-(imp_km*10);
refresh_display();
delay_ms(50  *5);
while(!PINB.2){delay_ms(50  );do_zameny_masla_imp = do_zameny_masla_imp-(imp_km*10);refresh_display();} 
delay_ms(100);
return;
}

if(!PINB.1)
{
refresh_lcd_count =0;  
old_display_number=0;
do_zameny_masla_imp = imp_km*10000;
refresh_display();
while(!PINB.1){}
delay_ms(100);
return;
}

if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 110; 
do_zameny_masla_imp = eeprom_do_zameny_masla_imp;
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}

if(!PINB.5)  
{
refresh_lcd_count =0;
eeprom_do_zameny_masla_imp = do_zameny_masla_imp;
old_display_number=0;
display_number = 110;
refresh_display();
while(!PINB.5){}
delay_ms(100);
return;
}

}  

if (display_number==210)   
{
if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 110; 
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}

if(!PINB.5)  
{
refresh_lcd_count =0;

refresh_display();
while(!PINB.5){}
delay_ms(100);
return;
}

}  

if (display_number==18)   
{
if(!PINB.1)
{
refresh_lcd_count =0;  
old_display_number=0;
load_defaults();
load_temp_data();
display_number = 110;
refresh_display();
while(!PINB.1){}
delay_ms(100);
return;
}

if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 110; 
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}

}  

if (display_number==200)   
{
if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 110; 
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}

}

if (display_number==201)   
{
if(!PINB.0)
{
refresh_lcd_count =0;  
old_display_number=0;

refresh_display();
delay_ms(100*5);

delay_ms(100);
return;
}

if(!PINB.2)
{
refresh_lcd_count =0;
old_display_number=0;

refresh_display(); 
delay_ms(50  *5);

delay_ms(100);
return;
}

if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 110; 
refresh_lcd_count =220;
while(!PINB.4){}
delay_ms(100);
return;
}

if(!PINB.5)  
{
refresh_lcd_count =0;

old_display_number=0;
display_number = 110;
refresh_lcd_count =220;
while(!PINB.5){}
delay_ms(100);
return;
}
}

if (display_number==17)   
{
if(!PINB.0)
{
refresh_lcd_count =0;  
old_display_number=0;
display_brightness++;if(display_brightness > 10){display_brightness =10;};
refresh_display();
delay_ms(100*5);
while(!PINB.0){delay_ms(50  *2);display_brightness++;if(display_brightness > 10){display_brightness =10;};refresh_display();}
delay_ms(100);
return;
}

if(!PINB.2)
{
refresh_lcd_count =0;
old_display_number=0;
display_brightness--;if(display_brightness < 1){display_brightness =1;};

refresh_display(); 
delay_ms(50  *5);
while(!PINB.2){delay_ms(50  *2);display_brightness--;if(display_brightness < 1){display_brightness =1;};refresh_display();}
delay_ms(100);
return;
}

if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 110; 
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}

if(!PINB.5)  
{
refresh_lcd_count =0;
eeprom_display_brightness = display_brightness;
old_display_number=0;
display_number = 110;
refresh_display();
while(!PINB.5){}
delay_ms(100);
return;
}
}

if (display_number==150)   
{
if(!PINB.0)
{
refresh_lcd_count =0;  
old_display_number=0;
clima_step++;if(clima_step > 100){clima_step =100;};
refresh_display();
delay_ms(100*5);
while(!PINB.0){delay_ms(50  );clima_step++;if(clima_step > 100){clima_step =100;};refresh_display();}
delay_ms(100);
return;
}

if(!PINB.2)
{
refresh_lcd_count =0;
old_display_number=0;
clima_step--;if(clima_step < 1){clima_step =1;};
refresh_display(); 
delay_ms(50  *5);
while(!PINB.2){delay_ms(50  );clima_step--;if(clima_step < 1){clima_step =1;};refresh_display();}
delay_ms(100);
return;
}

if(!PINB.4)
{
refresh_lcd_count =0;
old_display_number=0;
display_number = 110; 
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}

}

if (display_number==130)   
{
if(!PINB.0)
{
refresh_lcd_count =0;  
old_display_number=0;
chasiki = chasiki + 3600;
refresh_display();
delay_ms(100*5);
while(!PINB.0){delay_ms(50  *2);chasiki = chasiki + 3600;refresh_display();}
delay_ms(100);
return;
}

if(!PINB.2)
{
refresh_lcd_count =0;  
old_display_number=0;
chasiki = chasiki - 3600;
refresh_display();
delay_ms(100*5);
while(!PINB.2){delay_ms(50  *2);chasiki = chasiki - 3600;refresh_display();}
delay_ms(100);
return;
}

if(!PINB.4)
{
refresh_lcd_count =0;  
old_display_number=0;
display_number = 110; 
refresh_display();
while(!PINB.4){}
delay_ms(100);
return;
}

if(!PINB.1)
{
refresh_lcd_count =0;  
old_display_number=0;
chasiki = chasiki + 60;
refresh_display();
delay_ms(100*5);
while(!PINB.1){delay_ms(50  *2);chasiki = chasiki + 60;refresh_display();}
delay_ms(100);
return;
}

}

}
void refresh_display(void)
{
int temp_brightness; 
float dlit_vpr_f;
float put_total_m_f;

if(!PIND.5          ){temp_brightness = display_brightness+3;}else{temp_brightness = display_brightness;}

switch (temp_brightness) {
case 1: OCR0 =1;break;
case 2: OCR0 =5;break;
case 3: OCR0 =10;break;
case 4: OCR0 =20;break;
case 5: OCR0 =30;break;
case 6: OCR0 =50;break;
case 7: OCR0 =80;break;
case 8: OCR0 =130;break;
case 9: OCR0 =175;break;
case 10: OCR0 =255;break;
default:OCR0 =255;
};

if(refresh_display_worked){return;}
refresh_display_worked = 1;
flag_refresh_display = 0;
if(display_number != old_display_number){lcd_clear();}
old_display_number = display_number;

if(display_number ==101) 
{  

lcd_gotoxy(0,0);
lcd_putsf("                ");
if(PORTC.6           )
{
lcd_gotoxy(0,0);
lcd_putsf("D< ");
}

ftoa(speed,0,displ_buffer);
if(speed < 100)
{
if(speed < 10)lcd_gotoxy(6,0);
else{lcd_gotoxy(5,0);}
}
if(speed >= 100){lcd_gotoxy(4,0);}
lcd_puts(displ_buffer); 

lcd_putsf("km/h ");

lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(0,1);
lcd_putsf("ost ");
ftoa(v_bake/1000,1,displ_buffer);
lcd_puts(displ_buffer);
lcd_putsf("L=");
if(ost_km < 0)
{
lcd_putsf("- - ");
}
else
{
if(ost_km > 999)
{
lcd_putsf("999");
}
else
{
ftoa(ost_km,0,displ_buffer);
lcd_puts(displ_buffer);
}
lcd_putsf(" km");
}
refresh_display_worked = 0;return;  
} 

if(display_number ==102) 
{  

lcd_gotoxy(0,0);
lcd_putsf("                ");

ftoa(speed,0,displ_buffer);
if(speed < 100)
{
if(speed < 10)lcd_gotoxy(2,0);
else{lcd_gotoxy(1,0);}
}
if(speed >= 100){lcd_gotoxy(0,0);}
lcd_puts(displ_buffer); 
lcd_gotoxy(4,0);
lcd_putsf("km/h ");

dlit_vpr_f = dlit_vpr;
dlit_vpr_f=dlit_vpr_f/1000;   

ftoa(dlit_vpr_f,2,displ_buffer); 
lcd_gotoxy(9,0);
lcd_puts(displ_buffer);
lcd_gotoxy(13,0);
lcd_putsf("ms");

if((dlit_vpr_zamer_count < dlit_vpr_zamer/3)&&(dlit_vpr_zamer_count > 1)){lcd_gotoxy(15,0);lcd_putsf("*");}
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(0,1);
lcd_putsf("mom ");
ftoa(rashod_mom_l,1,displ_buffer);
lcd_puts(displ_buffer);     
lcd_putsf(" L/100km");
refresh_display_worked = 0;return;  
}  

if(display_number ==103)
{  

lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(0,0);

put_total_m_f = put_total_m;
if(put_total_m_f < 1000){ftoa(put_total_m_f/1000,3,displ_buffer);}
if((put_total_m_f >= 1000)&&(put_total_m_f < 10000)){ftoa(put_total_m_f/1000,2,displ_buffer);}
if((put_total_m_f >= 100000)&&(put_total_m_f < 1000000)){ftoa(put_total_m_f/1000,1,displ_buffer);}
if(put_total_m_f >= 1000000){ftoa(put_total_m_f/1000,0,displ_buffer);}

ftoa(put_total_m_f/1000,2,displ_buffer);
lcd_puts(displ_buffer);  
lcd_gotoxy(5,0);
lcd_putsf("km");
lcd_gotoxy(10,0);
if(vlito_total_ml < 10000){ftoa(vlito_total_ml/1000,2,displ_buffer);}
if((vlito_total_ml > 10000)&&(vlito_total_ml < 100000)){ftoa(vlito_total_ml/1000,1,displ_buffer);}
if(vlito_total_ml >= 10000){ftoa(vlito_total_ml/1000,0,displ_buffer);}
lcd_puts(displ_buffer);     
lcd_putsf("L");      

lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(0,1);
lcd_putsf("cp ");
if(rashod_sred_l == 99.9)
{
lcd_putsf("- - ");
}
else
{
ftoa(rashod_sred_l,1,displ_buffer);
lcd_puts(displ_buffer);
}     
lcd_putsf(" L/100km");
refresh_display_worked = 0;return;  
}  

if(display_number ==110)
{
switch (sel_item)
{ 

case 10:
{ 
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(4,0); 
lcd_putsf("Zapravka");
}
refresh_display_worked = 0;break;

case 12: 
{
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(4,0); 
lcd_putsf("Servisnye");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(4,1); 
lcd_putsf("Intervaly");
}
refresh_display_worked = 0;break;

case 11: 
{
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(0,0); 
lcd_putsf("Sbros scetcikov");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(0,1); 
lcd_putsf("probega, rashoda");
}
refresh_display_worked = 0;break;

case 15: 
{
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(0,0); 
lcd_putsf("Nastroyka dannyh");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(4,1); 
lcd_putsf("forsunok");
}
refresh_display_worked = 0;break;

case 16: 
{
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(1,0); 
lcd_putsf("Nastr. datcika");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(4,1); 
lcd_putsf("skorosti");
}          
refresh_display_worked = 0;break;

case 14: 
{
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(2,0); 
lcd_putsf("Sledyusaa");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(2,1); 
lcd_putsf("zamena GRM");
}          
refresh_display_worked = 0;break;

case 13: 
{
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(2,0); 
lcd_putsf("Sledyusaa");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(1,1); 
lcd_putsf("zamena masla");
}          
refresh_display_worked = 0;break;

case 210: 
{
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(4,0); 
lcd_putsf(" Debag");
lcd_gotoxy(0,1);

}          
refresh_display_worked = 0;break;

case 18: 
{
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(5,0); 
lcd_putsf("Reset");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(4,1); 
lcd_putsf("default");
}          
refresh_display_worked = 0;break;
case 200: 
{
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(5,0); 
lcd_putsf("About");
lcd_gotoxy(0,1);
lcd_putsf("                ");
}          
refresh_display_worked = 0;break; 
case 201: 
{
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(3,0); 
lcd_putsf("Contrast");
lcd_gotoxy(0,1);
lcd_putsf("                ");
}          
refresh_display_worked = 0;break; 
case 17: 
{
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(2,0); 
lcd_putsf("Brightness");
lcd_gotoxy(0,1);
lcd_putsf("                ");
}          
refresh_display_worked = 0;break; 

case 130: 
{
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(2,0); 
lcd_putsf(" Set clocks   ");
lcd_gotoxy(0,1);
lcd_putsf("                ");
} 
refresh_display_worked = 0;break; 
default:refresh_display_worked = 0;break;
};
}

if(display_number ==10)
{

lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(4,0); 
lcd_putsf("Zapravka");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(5,1);
ftoa(v_bake_plus/1000,1,displ_buffer);
lcd_puts(displ_buffer);
lcd_putsf(" L");
refresh_display_worked = 0;return; 
} 

if(display_number ==12)
{ 

lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(1,0); 
lcd_putsf(" GRM = ");
ftoa(do_zameny_grm_imp/imp_km,0,displ_buffer);
lcd_puts(displ_buffer);
lcd_putsf("km");

lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(1,1); 
lcd_putsf(" maslo = ");
ftoa(do_zameny_masla_imp/imp_km,0,displ_buffer);
lcd_puts(displ_buffer);
lcd_putsf("km");
refresh_display_worked = 0;return;
}

if(display_number ==11)
{ 

lcd_gotoxy(0,0);
lcd_putsf("Sbros scetcikov  <'No   '>'Yes'");
refresh_display_worked = 0;return; 
}

if(display_number ==15)
{  

lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(1,0); 
lcd_putsf("Forsunki");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(2,1);
ftoa(PrFors,1,displ_buffer);
lcd_puts(displ_buffer);
lcd_putsf(" ml/min");
refresh_display_worked = 0;return;
}   

if(display_number ==16)
{ 

lcd_gotoxy(0,0);
lcd_putsf("Datcik skorosti ");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(2,1);
ftoa(imp_km,0,displ_buffer);
lcd_puts(displ_buffer);
lcd_putsf(" imp/km");
refresh_display_worked = 0;return;
}  

if(display_number ==14)
{ 

lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(2,0);
lcd_putsf("GRM cerez");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(2,1);
ftoa((unsigned long int)(do_zameny_grm_imp/imp_km),0,displ_buffer);
lcd_puts(displ_buffer);
lcd_putsf(" km");
refresh_display_worked = 0;return;
} 

if(display_number ==13)
{ 

lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(2,0);
lcd_putsf("maslo cerez");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(3,1);
ftoa((unsigned long int)(do_zameny_masla_imp/imp_km),0,displ_buffer);
lcd_puts(displ_buffer);
lcd_putsf(" km");
refresh_display_worked = 0;return;
} 

if(display_number ==210)
{
lcd_clear(); 
ftoa(debag_data1,3,displ_buffer);
lcd_puts(displ_buffer); 
lcd_gotoxy(0,1); 
ftoa(debag_data2,3,displ_buffer);
lcd_puts(displ_buffer);
refresh_display_worked = 0;return; 
}  

if(display_number ==18)
{

lcd_gotoxy(0,0);
lcd_putsf("Reset default ?  <'No   '>'Yes'");
refresh_display_worked = 0;return;
}

if(display_number ==200)
{ 
lcd_gotoxy(0,0);
lcd_putsf("vk.com/**** :)");
refresh_display_worked = 0;return;
}

if(display_number ==201)
{ 
refresh_display_worked = 0;display_number =101;return;

lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(4,0);
lcd_putsf("Contrast");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(6,1);

lcd_puts(displ_buffer);
refresh_display_worked = 0;return;
}

if(display_number ==17)
{ 
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(3,0);
lcd_putsf("Brightness");
lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(7,1);
ftoa(display_brightness,0,displ_buffer);
lcd_puts(displ_buffer);
refresh_display_worked = 0;return;
} 

if(display_number ==150)
{ 
refresh_display_worked = 0;display_number =101;return;
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(0,0);
lcd_putsf("ust ");
ftoa(temp_set,0,displ_buffer);
lcd_puts(displ_buffer);
lcd_gotoxy(7,0);
lcd_putsf("real ");
ftoa(temp_real,1,displ_buffer);
lcd_puts(displ_buffer); 

lcd_gotoxy(0,1);
lcd_putsf("                ");
lcd_gotoxy(3,1);
ftoa(clima_step,0,displ_buffer);
lcd_puts(displ_buffer);
lcd_putsf(" step");
refresh_display_worked = 0;return;
} 

if(display_number ==202)
{ 

lcd_gotoxy(0,0);
lcd_putsf("  Saving data   ");
lcd_gotoxy(0,1);
lcd_putsf("                ");
refresh_display_worked = 0;return;
}

if(display_number ==130)
{ 

lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(4,0); 

lcd_puts(displ_buffer);
lcd_putsf(":");

lcd_puts(displ_buffer);
lcd_putsf(":");

lcd_puts(displ_buffer);

refresh_display_worked = 0;return;
} 

}

void main_cykl(void){while(1){

if(PIND.4       )
{ 
temp_data_saved =0;
eeprom_power_on_flag = 1;
calc_mom_rashod(); 

calc_dlit_vpr();  

}
else 
{

if(!temp_data_saved) { save_temp_data();eeprom_power_on_flag = 0;}
dlit_vpr =0; 
rashod_mom_l = 0;
display_number=101;
}
kb();  
if(flag_calculate_data){calculate_data();}
if(flag_refresh_display){refresh_display();}
if(flag_measure_speed == 0){flag_measure_speed =1;} 
enable_drl(); 
light_display(); 

}}

interrupt [6] void timer2_ovf_isr(void)
{
if(!PIND.4       ){return;} 

overflov_count_fors_mks++;

}

interrupt [2] void ext_int0_isr(void)
{
float vlito_tek_ml;
unsigned long int current_time_vprysk =0;
if(!PIND.4       ){TCCR2=0x00;return;}   
if ( PIND.2 ) 
{   

temp_data_saved =0;
TCCR2=0x00; 

current_time_vprysk = (unsigned long int)(overflov_count_fors_mks*255)+TCNT2;  

if(current_time_vprysk)
{
vlito_tek_ml = PrFors/(60000000/current_time_vprysk);
if(!dlit_vpr_ready)
{       
revs_count_dl_vpr++;
count_dlit_vpr_mks = count_dlit_vpr_mks + current_time_vprysk;   
}
vlito_total_ml = vlito_total_ml + vlito_tek_ml; 
v_bake = v_bake - vlito_tek_ml;
}
overflov_count_fors_mks =0;
TCNT2 =0;

}
else   
{ 
if(PIND.4       )  
{ 
TCNT2 =0;
TCCR2=0x02; 
}
}
}

