void ports_init(void)
{
PORTA=0b00000000;
DDRA =0b00000000;

PORTB=0b11111111;
DDRB =0b00001000;
                    // 0 1 6 7   
                    // 2 3 4 5
PORTC=0b00000000;    
DDRC= 0b11111111;

PORTD=0b10111100;
DDRD= 0b10000000;
}

void timers_init(void)
{
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: Fast PWM top=0xFF
// OC0 output: Inverted PWM
TCCR0=0x6A;
TCNT0=0x00;
OCR0=0x00;


// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x1E;
OCR1AL=0x85;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x00;
TCCR2=0x02;
TCNT2=0x00;
OCR2=0x00;

GICR|=0xC0;


MCUCR=0b00001001;
     
/* MCUCR
0000 00 00  INT0 low
0000 00 01  INT0 any
0000 00 10  INT0 fall
0000 00 11  INT0 ris

0000 00 00  INT1 low
0000 01 00  INT1 any
0000 10 00  INT1 fall
0000 11 00  INT1 ris

00 00 00 00  INT2 low
00 01 00 00  INT2 any
00 10 00 00  INT2 fall
00 11 00 00  INT2 ris
*/



GIFR=0xC0;
ACSR=0x80;
SFIOR=0x00;

TIMSK=0b01010000;   
/*
//7    - T2
//6   - T2
//5    - T1
//4     - T1
//3    » - T1
//2   - T1
//1    - T0
//0   - T0
*/
}

// Timer 0 output compare interrupt service routine
interrupt [TIM0_COMP] void timer0_comp_isr(void)
{
PORTC.0 = 0;
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
PORTC.0 = 1;
}

// Timer1 output compare A interrupt service routine    ,   1 
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
//if(PORTC == 0xFF){PORTC = 0x00;}
//else{PORTC = 0xFF;}
chasiki++;
if(chasiki >= 86400){chasiki = 0; }
//TCCR1B=0x00;
TCNT1 =0;
//PORTD.7 = !PORTD.7;
   if(flag_measure_speed == 1)
   {
   flag_measure_speed =2; //   ,  ! 
   }  
   else
   {
   if(flag_measure_speed == 2){flag_measure_speed =3;} //   , , calculate_data, 
   }
   if(LEG_IGNITION)
   {
   if(!dlit_vpr_ready)
   {
   dlit_vpr_zamer_count++;
   if(dlit_vpr_zamer_count >= dlit_vpr_zamer){dlit_vpr_ready = 1;dlit_vpr_zamer_count=0;} //   , , 
   } 
   
   calc_mom_rashod_count++;
   }
   flag_refresh_display = 1;
    
     
     ADCSRA|=0xCB; //  ,
     flag_calculate_data = 1; 
     
  //  TCCR1B=0x05;
}
 

//      
interrupt [EXT_INT1] void ext_int1_isr(void)
{
put_total_imp++;
do_zameny_grm_imp--;
do_zameny_masla_imp--;
if(flag_measure_speed == 2){speed_counter++;} // ,   
}

interrupt [ADC_INT] void adc_isr(void)
{
adc_data =0;ADCSRA|=0x00;return; 
adc_data=ADCW;

 }

void load_defaults(void)
{
//    
eeprom_v_bake = 0;
eeprom_imp_km = 5000; 
eeprom_PrFors = 775.9; // 722,89    
eeprom_do_zameny_grm_imp = 0;
eeprom_do_zameny_masla_imp = 0;
eeprom_vlito_total_ml = 0;
eeprom_put_total_imp = 0;
//   
eeprom_display_brightness = 3;
eeprom_power_on_flag =1;
eeprom_hardreset_count=0;
 #asm
   JMP __RESET
#endasm 
}

void main(void)
{// eeprom_v_bake = 30000;
  ports_init();
  lcd_init(16);
  lcd_putsf("  - - - -");
  delay_ms(200);
  if((!KEY_UP)&&(!KEY_DOWN))
 {
 load_defaults();   
 lcd_putsf("   Loading   ");
 lcd_putsf("   defaults..");
 delay_ms(2000);
 
 } 
 
 
  timers_init();
  load_temp_data();
  
  //  
  ost_km_count =0;
  sred_ost_km =0;
  PrFors = eeprom_PrFors;
  imp_km = eeprom_imp_km;
  ADMUX=ADC_VREF_TYPE;
  ADCSRA=0x8F;
  refresh_lcd_count = 0;
  refresh_display_worked = 0;
  #asm("sei") 
  flag_refresh_display = 1;
  if(eeprom_power_on_flag){eeprom_hardreset_count++;}//   ,   
  eeprom_power_on_flag = 1;
 // debag_data1 = eeprom_hardreset_count;
  main_cykl();
}

void calc_mom_rashod(void)                                                                                             
     //      rashod_mom_l  
{    //    ,   -       ,  -   :)
float  put_mom_km ;
float vlito_mom_l;
float new_rashod;
//    put_total_imp - put_start_imp_mom_rash
//   vlito_total_ml - vlito_start_mom_rash

 if(calc_mom_rashod_count >= 3)  //   3 , 
{
put_mom_km = put_total_imp - put_start_imp_mom_rash;
 
 put_mom_km = put_mom_km/imp_km;
 vlito_mom_l = (vlito_total_ml - vlito_start_mom_rash)/1000;
 
 //debag_data1 = (put_total_imp - put_start_imp_mom_rash);
//debag_data2 = vlito_mom_l;
 
 
 //    ,   100 
 if(put_mom_km){new_rashod = (vlito_mom_l/put_mom_km)*100;}
 else{new_rashod = 99;}
 if((new_rashod+0.15 < rashod_mom_l)||(new_rashod > rashod_mom_l)){rashod_mom_l = new_rashod;}
 if(rashod_mom_l > 99){rashod_mom_l = 99.9;}
 if(rashod_mom_l < 0){rashod_mom_l = 99.9;} 
 //     
 put_start_imp_mom_rash=put_total_imp;
 vlito_start_mom_rash = vlito_total_ml;
 calc_mom_rashod_count =0;
}
}

void calc_dlit_vpr(void)
{

if(!dlit_vpr_ready){return;}
//      , - ,  /,  :)  
//      dlit_vpr,  
if(revs_count_dl_vpr < 20){dlit_vpr = 99;} 
else{dlit_vpr = count_dlit_vpr_mks/revs_count_dl_vpr;}

//     ,   ostatok_tcnt2_vpr  TCNT2
count_dlit_vpr_mks =0;
dlit_vpr_zamer_count =0;
revs_count_dl_vpr = 0;
dlit_vpr_ready =0;
}

void calculate_data(void)
{
char new_speed;

if(flag_calculate_data_worked){return;}
flag_calculate_data_worked = 1;

if(put_total_imp < 500*imp_km)
{
put_total_m = put_total_imp*1000/imp_km;
}
else
{
put_total_m = put_total_imp/imp_km*1000;
}

if(put_total_m>1000)
{
rashod_sred_l = (vlito_total_ml/put_total_m)*100;
}
else
{
rashod_sred_l = 99.9;
}
add_ost_km(v_bake / rashod_sred_l/10);
// 
//adc_data=adc_data*100/18.65;
//adc_data = 14.2;
// 
if(flag_measure_speed == 3)  //     1   speed_counter
{
//   k,      
speed_counter = speed_counter*3600;
new_speed = (speed_counter/imp_km);
if(new_speed+1 != speed){speed = new_speed;}
if(speed < 2){speed =0;}
flag_measure_speed = 1;
speed_counter =0;
}






////     
flag_calculate_data = 0;
flag_calculate_data_worked = 0;
}

void add_ost_km(float new_data)
{

//       1-2-3    445 452
//debag_data1 = new_data;
//debag_data2 = ost_km;
if(new_data < ost_km){ost_km = new_data;}
if(new_data > ost_km+25){ost_km = new_data;}
return;

if(ost_km+3 < new_data){ost_km = new_data;}

//  ,    K_SRED_OST_KM        ,   K_SRED_OST_KM-   ,     K_SRED_OST_KM
if(ost_km_count < K_SRED_OST_KM)
{
ost_km_count++;
sred_ost_km += new_data;
}
else
{
ost_km_count = 0;
ost_km = sred_ost_km/K_SRED_OST_KM;
sred_ost_km = 0;
}








}

void save_temp_data(void)
{
if( temp_data_saved){return;};
 // display_number=DISP_SAVING; 
 // refresh_display();
  eeprom_v_bake = (int)v_bake;
  eeprom_do_zameny_grm_imp = do_zameny_grm_imp;
  eeprom_do_zameny_masla_imp = do_zameny_masla_imp;
  eeprom_vlito_total_ml = (int)vlito_total_ml;
  eeprom_put_total_imp = put_total_imp;
  temp_data_saved =1; 
 // delay_ms(2000);
//  display_number=DISP_MAIN_1;
  
}
 
void load_temp_data(void)
{
  v_bake = eeprom_v_bake;
  do_zameny_grm_imp = eeprom_do_zameny_grm_imp;
  do_zameny_masla_imp = eeprom_do_zameny_masla_imp;
  vlito_total_ml = eeprom_vlito_total_ml;
  put_total_imp = eeprom_put_total_imp;  
  temp_data_saved =0;
  display_brightness = eeprom_display_brightness;
}

void light_display(void)
{



if(((LEG_IGNITION)||(LEG_LIGHT))&&TCCR0==0x00){TCCR0=0x6A;}  //    

if((!LEG_IGNITION)&&(!LEG_LIGHT)&&(TCCR0 == 0x6A)){TCCR0=0x00;PORTB.3 =0;} //     

 
    
   
   
   
}

void enable_drl(void)
{


//   , 
if((LEG_LIGHT)&&(PIN_DRL)){PIN_DRL=0;
save_temp_data();
 #asm
   JMP __RESET
#endasm 
return;};

if(LEG_LIGHT){return;};
//  ,   - 
if((LEG_IGNITION)&&(PIN_DRL)){return;}

//  ,   - 
if((!LEG_IGNITION)&&(!PIN_DRL)){return;}

//  ,  ,  
if((LEG_IGNITION)&&(!PIN_DRL)){if(speed > DRL_SPEED){PIN_DRL=1;}return;}

//  ,   - 
if((!LEG_IGNITION)&&(PIN_DRL)){PIN_DRL=0;save_temp_data();
 #asm
   JMP __RESET
#endasm 
return;}
}



