
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32A
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: Yes
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATmega32A
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2143
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _speed=R5
	.DEF _flag_measure_speed=R4
	.DEF _dlit_vpr_ready=R7
	.DEF _dlit_vpr_zamer=R8
	.DEF _dlit_vpr_zamer_count=R10
	.DEF _revs_count_dl_vpr=R12
	.DEF _ost_km_count=R6

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  _ext_int0_isr
	JMP  _ext_int1_isr
	JMP  0x00
	JMP  0x00
	JMP  _timer2_ovf_isr
	JMP  0x00
	JMP  _timer1_compa_isr
	JMP  0x00
	JMP  0x00
	JMP  _timer0_comp_isr
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _adc_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  0x90,0x7E
_0x4:
	.DB  0xFF
_0x5:
	.DB  0x65
_0x6:
	.DB  0x0,0x0,0xB8,0x41
_0x7:
	.DB  0x0,0x0,0x20,0x41
_0x1C8:
	.DB  0x0,0x0,0x0,0x0,0xA,0x0,0x0,0x0
_0x0:
	.DB  0x20,0x20,0x2D,0x20,0x2D,0x20,0x2D,0x20
	.DB  0x2D,0x0,0x20,0x20,0x20,0x4C,0x6F,0x61
	.DB  0x64,0x69,0x6E,0x67,0x20,0x20,0x20,0x0
	.DB  0x20,0x20,0x20,0x64,0x65,0x66,0x61,0x75
	.DB  0x6C,0x74,0x73,0x2E,0x2E,0x0,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x0,0x44
	.DB  0x3C,0x20,0x0,0x6B,0x6D,0x2F,0x68,0x20
	.DB  0x0,0x6F,0x73,0x74,0x20,0x0,0x4C,0x3D
	.DB  0x0,0x2D,0x20,0x2D,0x20,0x0,0x39,0x39
	.DB  0x39,0x0,0x20,0x6B,0x6D,0x0,0x6D,0x73
	.DB  0x0,0x2A,0x0,0x6D,0x6F,0x6D,0x20,0x0
	.DB  0x20,0x4C,0x2F,0x31,0x30,0x30,0x6B,0x6D
	.DB  0x0,0x4C,0x0,0x63,0x70,0x20,0x0,0x5A
	.DB  0x61,0x70,0x72,0x61,0x76,0x6B,0x61,0x0
	.DB  0x53,0x65,0x72,0x76,0x69,0x73,0x6E,0x79
	.DB  0x65,0x0,0x49,0x6E,0x74,0x65,0x72,0x76
	.DB  0x61,0x6C,0x79,0x0,0x53,0x62,0x72,0x6F
	.DB  0x73,0x20,0x73,0x63,0x65,0x74,0x63,0x69
	.DB  0x6B,0x6F,0x76,0x0,0x70,0x72,0x6F,0x62
	.DB  0x65,0x67,0x61,0x2C,0x20,0x72,0x61,0x73
	.DB  0x68,0x6F,0x64,0x61,0x0,0x4E,0x61,0x73
	.DB  0x74,0x72,0x6F,0x79,0x6B,0x61,0x20,0x64
	.DB  0x61,0x6E,0x6E,0x79,0x68,0x0,0x66,0x6F
	.DB  0x72,0x73,0x75,0x6E,0x6F,0x6B,0x0,0x4E
	.DB  0x61,0x73,0x74,0x72,0x2E,0x20,0x64,0x61
	.DB  0x74,0x63,0x69,0x6B,0x61,0x0,0x73,0x6B
	.DB  0x6F,0x72,0x6F,0x73,0x74,0x69,0x0,0x53
	.DB  0x6C,0x65,0x64,0x79,0x75,0x73,0x61,0x61
	.DB  0x0,0x7A,0x61,0x6D,0x65,0x6E,0x61,0x20
	.DB  0x47,0x52,0x4D,0x0,0x7A,0x61,0x6D,0x65
	.DB  0x6E,0x61,0x20,0x6D,0x61,0x73,0x6C,0x61
	.DB  0x0,0x20,0x44,0x65,0x62,0x61,0x67,0x0
	.DB  0x52,0x65,0x73,0x65,0x74,0x0,0x64,0x65
	.DB  0x66,0x61,0x75,0x6C,0x74,0x0,0x41,0x62
	.DB  0x6F,0x75,0x74,0x0,0x43,0x6F,0x6E,0x74
	.DB  0x72,0x61,0x73,0x74,0x0,0x42,0x72,0x69
	.DB  0x67,0x68,0x74,0x6E,0x65,0x73,0x73,0x0
	.DB  0x20,0x53,0x65,0x74,0x20,0x63,0x6C,0x6F
	.DB  0x63,0x6B,0x73,0x20,0x20,0x20,0x0,0x20
	.DB  0x4C,0x0,0x20,0x47,0x52,0x4D,0x20,0x3D
	.DB  0x20,0x0,0x20,0x6D,0x61,0x73,0x6C,0x6F
	.DB  0x20,0x3D,0x20,0x0,0x53,0x62,0x72,0x6F
	.DB  0x73,0x20,0x73,0x63,0x65,0x74,0x63,0x69
	.DB  0x6B,0x6F,0x76,0x20,0x20,0x3C,0x27,0x4E
	.DB  0x6F,0x20,0x20,0x20,0x27,0x3E,0x27,0x59
	.DB  0x65,0x73,0x27,0x0,0x46,0x6F,0x72,0x73
	.DB  0x75,0x6E,0x6B,0x69,0x0,0x20,0x6D,0x6C
	.DB  0x2F,0x6D,0x69,0x6E,0x0,0x44,0x61,0x74
	.DB  0x63,0x69,0x6B,0x20,0x73,0x6B,0x6F,0x72
	.DB  0x6F,0x73,0x74,0x69,0x20,0x0,0x20,0x69
	.DB  0x6D,0x70,0x2F,0x6B,0x6D,0x0,0x47,0x52
	.DB  0x4D,0x20,0x63,0x65,0x72,0x65,0x7A,0x0
	.DB  0x6D,0x61,0x73,0x6C,0x6F,0x20,0x63,0x65
	.DB  0x72,0x65,0x7A,0x0,0x52,0x65,0x73,0x65
	.DB  0x74,0x20,0x64,0x65,0x66,0x61,0x75,0x6C
	.DB  0x74,0x20,0x3F,0x20,0x20,0x3C,0x27,0x4E
	.DB  0x6F,0x20,0x20,0x20,0x27,0x3E,0x27,0x59
	.DB  0x65,0x73,0x27,0x0,0x76,0x6B,0x2E,0x63
	.DB  0x6F,0x6D,0x2F,0x2A,0x2A,0x2A,0x2A,0x20
	.DB  0x3A,0x29,0x0,0x75,0x73,0x74,0x20,0x0
	.DB  0x72,0x65,0x61,0x6C,0x20,0x0,0x20,0x73
	.DB  0x74,0x65,0x70,0x0,0x20,0x20,0x53,0x61
	.DB  0x76,0x69,0x6E,0x67,0x20,0x64,0x61,0x74
	.DB  0x61,0x20,0x20,0x20,0x0,0x3A,0x0
_0x2000060:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0
_0x2040003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x02
	.DW  _chasiki
	.DW  _0x3*2

	.DW  0x01
	.DW  _old_display_number
	.DW  _0x4*2

	.DW  0x01
	.DW  _display_number
	.DW  _0x5*2

	.DW  0x04
	.DW  _temp_set
	.DW  _0x6*2

	.DW  0x04
	.DW  _temp_real
	.DW  _0x7*2

	.DW  0x08
	.DW  0x04
	.DW  _0x1C8*2

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x2000060*2

	.DW  0x02
	.DW  __base_y_G102
	.DW  _0x2040003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;#include <mondeo.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
   .equ __lcd_port=0x12 ;PORTD

	.DSEG
;#include <mondeo_func.c>
;void ports_init(void)
; 0000 0002 {

	.CSEG
_ports_init:
;PORTA=0b00000000;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;DDRA =0b00000000;
	OUT  0x1A,R30
;
;PORTB=0b11111111;
	LDI  R30,LOW(255)
	OUT  0x18,R30
;DDRB =0b00001000;
	LDI  R30,LOW(8)
	OUT  0x17,R30
;                    // 0 1 6 7   
;                    // 2 3 4 5
;PORTC=0b00000000;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;DDRC= 0b11111111;
	LDI  R30,LOW(255)
	OUT  0x14,R30
;
;PORTD=0b10111100;
	LDI  R30,LOW(188)
	OUT  0x12,R30
;DDRD= 0b10000000;
	LDI  R30,LOW(128)
	OUT  0x11,R30
;}
	RET
;
;void timers_init(void)
;{
_timers_init:
;// Timer/Counter 0 initialization
;// Clock source: System Clock
;// Clock value: 1000,000 kHz
;// Mode: Fast PWM top=0xFF
;// OC0 output: Inverted PWM
;TCCR0=0x6A;
	LDI  R30,LOW(106)
	OUT  0x33,R30
;TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;OCR0=0x00;
	OUT  0x3C,R30
;
;
;// Timer/Counter 1 initialization
;// Clock source: System Clock
;// Clock value: 7,813 kHz
;// Mode: Normal top=0xFFFF
;// OC1A output: Discon.
;// OC1B output: Discon.
;// Noise Canceler: Off
;// Input Capture on Falling Edge
;// Timer1 Overflow Interrupt: On
;// Input Capture Interrupt: Off
;// Compare A Match Interrupt: On
;// Compare B Match Interrupt: Off
;TCCR1A=0x00;
	OUT  0x2F,R30
;TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
;TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;TCNT1L=0x00;
	OUT  0x2C,R30
;ICR1H=0x00;
	OUT  0x27,R30
;ICR1L=0x00;
	OUT  0x26,R30
;OCR1AH=0x1E;
	LDI  R30,LOW(30)
	OUT  0x2B,R30
;OCR1AL=0x85;
	LDI  R30,LOW(133)
	OUT  0x2A,R30
;OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
;OCR1BL=0x00;
	OUT  0x28,R30
;
;ASSR=0x00;
	OUT  0x22,R30
;TCCR2=0x02;
	LDI  R30,LOW(2)
	OUT  0x25,R30
;TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;OCR2=0x00;
	OUT  0x23,R30
;
;GICR|=0xC0;
	IN   R30,0x3B
	ORI  R30,LOW(0xC0)
	OUT  0x3B,R30
;
;
;MCUCR=0b00001001;
	LDI  R30,LOW(9)
	OUT  0x35,R30
;
;/* MCUCR
;0000 00 00  INT0 low
;0000 00 01  INT0 any
;0000 00 10  INT0 fall
;0000 00 11  INT0 ris
;
;0000 00 00  INT1 low
;0000 01 00  INT1 any
;0000 10 00  INT1 fall
;0000 11 00  INT1 ris
;
;00 00 00 00  INT2 low
;00 01 00 00  INT2 any
;00 10 00 00  INT2 fall
;00 11 00 00  INT2 ris
;*/
;
;
;
;GIFR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3A,R30
;ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;
;TIMSK=0b01010000;
	LDI  R30,LOW(80)
	OUT  0x39,R30
;/*
;//7    - T2
;//6   - T2
;//5    - T1
;//4     - T1
;//3    » - T1
;//2   - T1
;//1    - T0
;//0   - T0
;*/
;}
	RET
;
;// Timer 0 output compare interrupt service routine
;interrupt [TIM0_COMP] void timer0_comp_isr(void)
;{
_timer0_comp_isr:
;PORTC.0 = 0;
	CBI  0x15,0
;}
	RETI
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;{
_timer0_ovf_isr:
;PORTC.0 = 1;
	SBI  0x15,0
;}
	RETI
;
;// Timer1 output compare A interrupt service routine    ,   1 
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)
;{
_timer1_compa_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;//if(PORTC == 0xFF){PORTC = 0x00;}
;//else{PORTC = 0xFF;}
;chasiki++;
	LDI  R26,LOW(_chasiki)
	LDI  R27,HIGH(_chasiki)
	CALL SUBOPT_0x0
;if(chasiki >= 86400){chasiki = 0; }
	LDS  R26,_chasiki
	LDS  R27,_chasiki+1
	LDS  R24,_chasiki+2
	LDS  R25,_chasiki+3
	__CPD2N 0x15180
	BRLO _0xC
	LDI  R30,LOW(0)
	STS  _chasiki,R30
	STS  _chasiki+1,R30
	STS  _chasiki+2,R30
	STS  _chasiki+3,R30
;//TCCR1B=0x00;
;TCNT1 =0;
_0xC:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
;//PORTD.7 = !PORTD.7;
;   if(flag_measure_speed == 1)
	LDI  R30,LOW(1)
	CP   R30,R4
	BRNE _0xD
;   {
;   flag_measure_speed =2; //   ,  !
	LDI  R30,LOW(2)
	RJMP _0x1BA
;   }
;   else
_0xD:
;   {
;   if(flag_measure_speed == 2){flag_measure_speed =3;} //   , , calculate_data, 
	LDI  R30,LOW(2)
	CP   R30,R4
	BRNE _0xF
	LDI  R30,LOW(3)
_0x1BA:
	MOV  R4,R30
;   }
_0xF:
;   if(LEG_IGNITION)
	SBIS 0x10,4
	RJMP _0x10
;   {
;   if(!dlit_vpr_ready)
	TST  R7
	BRNE _0x11
;   {
;   dlit_vpr_zamer_count++;
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
;   if(dlit_vpr_zamer_count >= dlit_vpr_zamer){dlit_vpr_ready = 1;dlit_vpr_zamer_count=0;} //   , ,
	__CPWRR 10,11,8,9
	BRLO _0x12
	LDI  R30,LOW(1)
	MOV  R7,R30
	CLR  R10
	CLR  R11
;   }
_0x12:
;
;   calc_mom_rashod_count++;
_0x11:
	LDI  R26,LOW(_calc_mom_rashod_count)
	LDI  R27,HIGH(_calc_mom_rashod_count)
	CALL SUBOPT_0x0
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
;   }
;   flag_refresh_display = 1;
_0x10:
	LDI  R30,LOW(1)
	STS  _flag_refresh_display,R30
;
;
;     ADCSRA|=0xCB; //  ,
	IN   R30,0x6
	ORI  R30,LOW(0xCB)
	OUT  0x6,R30
;     flag_calculate_data = 1;
	LDI  R30,LOW(1)
	STS  _flag_calculate_data,R30
;
;  //  TCCR1B=0x05;
;}
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;
;
;//  
;interrupt [EXT_INT1] void ext_int1_isr(void)
;{
_ext_int1_isr:
	CALL SUBOPT_0x1
;put_total_imp++;
	LDI  R26,LOW(_put_total_imp)
	LDI  R27,HIGH(_put_total_imp)
	CALL SUBOPT_0x0
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
;do_zameny_grm_imp--;
	LDI  R26,LOW(_do_zameny_grm_imp)
	LDI  R27,HIGH(_do_zameny_grm_imp)
	CALL SUBOPT_0x2
;do_zameny_masla_imp--;
	LDI  R26,LOW(_do_zameny_masla_imp)
	LDI  R27,HIGH(_do_zameny_masla_imp)
	CALL SUBOPT_0x2
;if(flag_measure_speed == 2){speed_counter++;} // ,   
	LDI  R30,LOW(2)
	CP   R30,R4
	BRNE _0x13
	LDI  R26,LOW(_speed_counter)
	LDI  R27,HIGH(_speed_counter)
	CALL SUBOPT_0x0
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
;}
_0x13:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;
;interrupt [ADC_INT] void adc_isr(void)
;{
_adc_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;adc_data =0;ADCSRA|=0x00;return;
	LDI  R30,LOW(0)
	STS  _adc_data,R30
	STS  _adc_data+1,R30
	STS  _adc_data+2,R30
	STS  _adc_data+3,R30
	IN   R30,0x6
	OUT  0x6,R30
;adc_data=ADCW;
;
; }
_0x1C7:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;void load_defaults(void)
;{
_load_defaults:
;//  
;eeprom_v_bake = 0;
	LDI  R26,LOW(_eeprom_v_bake)
	LDI  R27,HIGH(_eeprom_v_bake)
	CALL SUBOPT_0x3
;eeprom_imp_km = 5000;
	LDI  R26,LOW(_eeprom_imp_km)
	LDI  R27,HIGH(_eeprom_imp_km)
	LDI  R30,LOW(5000)
	LDI  R31,HIGH(5000)
	CALL __EEPROMWRW
;eeprom_PrFors = 775.9; // 722,89    
	LDI  R26,LOW(_eeprom_PrFors)
	LDI  R27,HIGH(_eeprom_PrFors)
	__GETD1N 0x4441F99A
	CALL __EEPROMWRD
;eeprom_do_zameny_grm_imp = 0;
	LDI  R26,LOW(_eeprom_do_zameny_grm_imp)
	LDI  R27,HIGH(_eeprom_do_zameny_grm_imp)
	CALL SUBOPT_0x3
;eeprom_do_zameny_masla_imp = 0;
	LDI  R26,LOW(_eeprom_do_zameny_masla_imp)
	LDI  R27,HIGH(_eeprom_do_zameny_masla_imp)
	CALL SUBOPT_0x3
;eeprom_vlito_total_ml = 0;
	LDI  R26,LOW(_eeprom_vlito_total_ml)
	LDI  R27,HIGH(_eeprom_vlito_total_ml)
	CALL SUBOPT_0x3
;eeprom_put_total_imp = 0;
	LDI  R26,LOW(_eeprom_put_total_imp)
	LDI  R27,HIGH(_eeprom_put_total_imp)
	CALL SUBOPT_0x3
;//   
;eeprom_display_brightness = 3;
	LDI  R26,LOW(_eeprom_display_brightness)
	LDI  R27,HIGH(_eeprom_display_brightness)
	LDI  R30,LOW(3)
	CALL __EEPROMWRB
;eeprom_power_on_flag =1;
	CALL SUBOPT_0x4
;eeprom_hardreset_count=0;
	LDI  R26,LOW(_eeprom_hardreset_count)
	LDI  R27,HIGH(_eeprom_hardreset_count)
	CALL SUBOPT_0x3
; #asm
   JMP __RESET
;}
	RET
;
;void main(void)
;{// eeprom_v_bake = 30000;
_main:
;  ports_init();
	RCALL _ports_init
;  lcd_init(16);
	LDI  R26,LOW(16)
	CALL _lcd_init
;  lcd_putsf("  - - - -");
	__POINTW2FN _0x0,0
	CALL _lcd_putsf
;  delay_ms(200);
	LDI  R26,LOW(200)
	CALL SUBOPT_0x5
;  if((!KEY_UP)&&(!KEY_DOWN))
	SBIC 0x16,0
	RJMP _0x15
	SBIS 0x16,2
	RJMP _0x16
_0x15:
	RJMP _0x14
_0x16:
; {
; load_defaults();
	RCALL _load_defaults
; lcd_putsf("   Loading   ");
	__POINTW2FN _0x0,10
	CALL _lcd_putsf
; lcd_putsf("   defaults..");
	__POINTW2FN _0x0,24
	CALL _lcd_putsf
; delay_ms(2000);
	LDI  R26,LOW(2000)
	LDI  R27,HIGH(2000)
	CALL _delay_ms
;
; }
;
;
;  timers_init();
_0x14:
	RCALL _timers_init
;  load_temp_data();
	RCALL _load_temp_data
;
;  //  
;  ost_km_count =0;
	CLR  R6
;  sred_ost_km =0;
	CALL SUBOPT_0x6
;  PrFors = eeprom_PrFors;
	CALL SUBOPT_0x7
;  imp_km = eeprom_imp_km;
	CALL SUBOPT_0x8
;  ADMUX=ADC_VREF_TYPE;
	LDI  R30,LOW(0)
	OUT  0x7,R30
;  ADCSRA=0x8F;
	LDI  R30,LOW(143)
	OUT  0x6,R30
;  refresh_lcd_count = 0;
	CALL SUBOPT_0x9
;  refresh_display_worked = 0;
	STS  _refresh_display_worked,R30
;  #asm("sei")
	sei
;  flag_refresh_display = 1;
	LDI  R30,LOW(1)
	STS  _flag_refresh_display,R30
;  if(eeprom_power_on_flag){eeprom_hardreset_count++;}//   ,   
	LDI  R26,LOW(_eeprom_power_on_flag)
	LDI  R27,HIGH(_eeprom_power_on_flag)
	CALL __EEPROMRDB
	CPI  R30,0
	BREQ _0x17
	LDI  R26,LOW(_eeprom_hardreset_count)
	LDI  R27,HIGH(_eeprom_hardreset_count)
	CALL __EEPROMRDD
	__SUBD1N -1
	CALL __EEPROMWRD
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
;  eeprom_power_on_flag = 1;
_0x17:
	CALL SUBOPT_0x4
; // debag_data1 = eeprom_hardreset_count;
;  main_cykl();
	CALL _main_cykl
;}
_0x18:
	RJMP _0x18
;
;void calc_mom_rashod(void)
;     //      rashod_mom_l
;{    //    ,   -       ,  -   :)
_calc_mom_rashod:
;float  put_mom_km ;
;float vlito_mom_l;
;float new_rashod;
;//    put_total_imp - put_start_imp_mom_rash
;//   vlito_total_ml - vlito_start_mom_rash
;
; if(calc_mom_rashod_count >= 3)  //   3 ,
	SBIW R28,12
;	put_mom_km -> Y+8
;	vlito_mom_l -> Y+4
;	new_rashod -> Y+0
	LDS  R26,_calc_mom_rashod_count
	LDS  R27,_calc_mom_rashod_count+1
	LDS  R24,_calc_mom_rashod_count+2
	LDS  R25,_calc_mom_rashod_count+3
	__CPD2N 0x3
	BRSH PC+3
	JMP _0x19
;{
;put_mom_km = put_total_imp - put_start_imp_mom_rash;
	LDS  R26,_put_start_imp_mom_rash
	LDS  R27,_put_start_imp_mom_rash+1
	LDS  R24,_put_start_imp_mom_rash+2
	LDS  R25,_put_start_imp_mom_rash+3
	CALL SUBOPT_0xA
	CALL __SUBD12
	CALL __CDF1U
	__PUTD1S 8
;
; put_mom_km = put_mom_km/imp_km;
	CALL SUBOPT_0xB
	__GETD2S 8
	CALL SUBOPT_0xC
	__PUTD1S 8
; vlito_mom_l = (vlito_total_ml - vlito_start_mom_rash)/1000;
	LDS  R26,_vlito_start_mom_rash
	LDS  R27,_vlito_start_mom_rash+1
	LDS  R24,_vlito_start_mom_rash+2
	LDS  R25,_vlito_start_mom_rash+3
	CALL SUBOPT_0xD
	CALL __SUBF12
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0xE
	__PUTD1S 4
;
; //debag_data1 = (put_total_imp - put_start_imp_mom_rash);
;//debag_data2 = vlito_mom_l;
;
;
; //    ,   100
; if(put_mom_km){new_rashod = (vlito_mom_l/put_mom_km)*100;}
	__GETD1S 8
	CALL __CPD10
	BREQ _0x1A
	__GETD2S 4
	CALL __DIVF21
	CALL SUBOPT_0xF
	RJMP _0x1BB
; else{new_rashod = 99;}
_0x1A:
	__GETD1N 0x42C60000
_0x1BB:
	CALL __PUTD1S0
; if((new_rashod+0.15 < rashod_mom_l)||(new_rashod > rashod_mom_l)){rashod_mom_l = new_rashod;}
	CALL SUBOPT_0x10
	__GETD2N 0x3E19999A
	CALL __ADDF12
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x11
	CALL __CMPF12
	BRLO _0x1D
	CALL SUBOPT_0x11
	CALL SUBOPT_0x12
	BREQ PC+4
	BRCS PC+3
	JMP  _0x1D
	RJMP _0x1C
_0x1D:
	CALL SUBOPT_0x10
	CALL SUBOPT_0x13
; if(rashod_mom_l > 99){rashod_mom_l = 99.9;}
_0x1C:
	LDS  R26,_rashod_mom_l
	LDS  R27,_rashod_mom_l+1
	LDS  R24,_rashod_mom_l+2
	LDS  R25,_rashod_mom_l+3
	__GETD1N 0x42C60000
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x1F
	CALL SUBOPT_0x14
; if(rashod_mom_l < 0){rashod_mom_l = 99.9;}
_0x1F:
	LDS  R26,_rashod_mom_l+3
	TST  R26
	BRPL _0x20
	CALL SUBOPT_0x14
; //     
; put_start_imp_mom_rash=put_total_imp;
_0x20:
	CALL SUBOPT_0xA
	STS  _put_start_imp_mom_rash,R30
	STS  _put_start_imp_mom_rash+1,R31
	STS  _put_start_imp_mom_rash+2,R22
	STS  _put_start_imp_mom_rash+3,R23
; vlito_start_mom_rash = vlito_total_ml;
	CALL SUBOPT_0xD
	STS  _vlito_start_mom_rash,R30
	STS  _vlito_start_mom_rash+1,R31
	STS  _vlito_start_mom_rash+2,R22
	STS  _vlito_start_mom_rash+3,R23
; calc_mom_rashod_count =0;
	LDI  R30,LOW(0)
	STS  _calc_mom_rashod_count,R30
	STS  _calc_mom_rashod_count+1,R30
	STS  _calc_mom_rashod_count+2,R30
	STS  _calc_mom_rashod_count+3,R30
;}
;}
_0x19:
	ADIW R28,12
	RET
;
;void calc_dlit_vpr(void)
;{
_calc_dlit_vpr:
;
;if(!dlit_vpr_ready){return;}
	TST  R7
	BRNE _0x21
	RET
;//      , - ,  /,  :)
;//      dlit_vpr, 
;if(revs_count_dl_vpr < 20){dlit_vpr = 99;}
_0x21:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CP   R12,R30
	CPC  R13,R31
	BRSH _0x22
	__GETD1N 0x63
	RJMP _0x1BC
;else{dlit_vpr = count_dlit_vpr_mks/revs_count_dl_vpr;}
_0x22:
	MOVW R30,R12
	CALL SUBOPT_0x15
	CLR  R22
	CLR  R23
	CALL __DIVD21U
_0x1BC:
	STS  _dlit_vpr,R30
	STS  _dlit_vpr+1,R31
	STS  _dlit_vpr+2,R22
	STS  _dlit_vpr+3,R23
;
;//     ,   ostatok_tcnt2_vpr  TCNT2
;count_dlit_vpr_mks =0;
	LDI  R30,LOW(0)
	STS  _count_dlit_vpr_mks,R30
	STS  _count_dlit_vpr_mks+1,R30
	STS  _count_dlit_vpr_mks+2,R30
	STS  _count_dlit_vpr_mks+3,R30
;dlit_vpr_zamer_count =0;
	CLR  R10
	CLR  R11
;revs_count_dl_vpr = 0;
	CLR  R12
	CLR  R13
;dlit_vpr_ready =0;
	CLR  R7
;}
	RET
;
;void calculate_data(void)
;{
_calculate_data:
;char new_speed;
;
;if(flag_calculate_data_worked){return;}
	ST   -Y,R17
;	new_speed -> R17
	LDS  R30,_flag_calculate_data_worked
	CPI  R30,0
	BREQ _0x24
	RJMP _0x20C000A
;flag_calculate_data_worked = 1;
_0x24:
	LDI  R30,LOW(1)
	STS  _flag_calculate_data_worked,R30
;
;if(put_total_imp < 500*imp_km)
	CALL SUBOPT_0xB
	__GETD2N 0x1F4
	CALL __MULD12U
	CALL SUBOPT_0x16
	CALL __CPD21
	BRSH _0x25
;{
;put_total_m = put_total_imp*1000/imp_km;
	CALL SUBOPT_0xA
	CALL SUBOPT_0x17
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0xB
	CALL __DIVD21U
	RJMP _0x1BD
;}
;else
_0x25:
;{
;put_total_m = put_total_imp/imp_km*1000;
	CALL SUBOPT_0xB
	CALL SUBOPT_0x16
	CALL __DIVD21U
	CALL SUBOPT_0x17
_0x1BD:
	STS  _put_total_m,R30
	STS  _put_total_m+1,R31
	STS  _put_total_m+2,R22
	STS  _put_total_m+3,R23
;}
;
;if(put_total_m>1000)
	LDS  R26,_put_total_m
	LDS  R27,_put_total_m+1
	LDS  R24,_put_total_m+2
	LDS  R25,_put_total_m+3
	__CPD2N 0x3E9
	BRLO _0x27
;{
;rashod_sred_l = (vlito_total_ml/put_total_m)*100;
	CALL SUBOPT_0x18
	CALL SUBOPT_0x19
	CALL SUBOPT_0xC
	CALL SUBOPT_0xF
	RJMP _0x1BE
;}
;else
_0x27:
;{
;rashod_sred_l = 99.9;
	__GETD1N 0x42C7CCCD
_0x1BE:
	STS  _rashod_sred_l,R30
	STS  _rashod_sred_l+1,R31
	STS  _rashod_sred_l+2,R22
	STS  _rashod_sred_l+3,R23
;}
;add_ost_km(v_bake / rashod_sred_l/10);
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x1B
	CALL __DIVF21
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x1C
	CALL __DIVF21
	MOVW R26,R30
	MOVW R24,R22
	RCALL _add_ost_km
;// 
;//adc_data=adc_data*100/18.65;
;//adc_data = 14.2;
;// 
;if(flag_measure_speed == 3)  //     1   speed_counter
	LDI  R30,LOW(3)
	CP   R30,R4
	BREQ PC+3
	JMP _0x29
;{
;//   k,     
;speed_counter = speed_counter*3600;
	LDS  R30,_speed_counter
	LDS  R31,_speed_counter+1
	LDS  R22,_speed_counter+2
	LDS  R23,_speed_counter+3
	__GETD2N 0xE10
	CALL __MULD12U
	STS  _speed_counter,R30
	STS  _speed_counter+1,R31
	STS  _speed_counter+2,R22
	STS  _speed_counter+3,R23
;new_speed = (speed_counter/imp_km);
	CALL SUBOPT_0xB
	LDS  R26,_speed_counter
	LDS  R27,_speed_counter+1
	LDS  R24,_speed_counter+2
	LDS  R25,_speed_counter+3
	CALL __DIVD21U
	MOV  R17,R30
;if(new_speed+1 != speed){speed = new_speed;}
	MOV  R30,R17
	LDI  R31,0
	ADIW R30,1
	MOVW R26,R30
	MOV  R30,R5
	LDI  R31,0
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x2A
	MOV  R5,R17
;if(speed < 2){speed =0;}
_0x2A:
	LDI  R30,LOW(2)
	CP   R5,R30
	BRSH _0x2B
	CLR  R5
;flag_measure_speed = 1;
_0x2B:
	LDI  R30,LOW(1)
	MOV  R4,R30
;speed_counter =0;
	LDI  R30,LOW(0)
	STS  _speed_counter,R30
	STS  _speed_counter+1,R30
	STS  _speed_counter+2,R30
	STS  _speed_counter+3,R30
;}
;
;
;
;
;
;
;////     
;flag_calculate_data = 0;
_0x29:
	LDI  R30,LOW(0)
	STS  _flag_calculate_data,R30
;flag_calculate_data_worked = 0;
	STS  _flag_calculate_data_worked,R30
;}
_0x20C000A:
	LD   R17,Y+
	RET
;
;void add_ost_km(float new_data)
;{
_add_ost_km:
;
;//       1-2-3    445 452
;//debag_data1 = new_data;
;//debag_data2 = ost_km;
;if(new_data < ost_km){ost_km = new_data;}
	CALL __PUTPARD2
;	new_data -> Y+0
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x12
	BRSH _0x2C
	CALL SUBOPT_0x1E
;if(new_data > ost_km+25){ost_km = new_data;}
_0x2C:
	CALL SUBOPT_0x1D
	__GETD2N 0x41C80000
	CALL __ADDF12
	CALL SUBOPT_0x12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x2D
	CALL SUBOPT_0x1E
;return;
_0x2D:
;
;if(ost_km+3 < new_data){ost_km = new_data;}
;
;//  ,    K_SRED_OST_KM        ,   K_SRED_OST_KM-   ,     K_SRED_OST_KM
;if(ost_km_count < K_SRED_OST_KM)
;{
;ost_km_count++;
;sred_ost_km += new_data;
;}
;else
;{
;ost_km_count = 0;
;ost_km = sred_ost_km/K_SRED_OST_KM;
;sred_ost_km = 0;
;}
;
;
;
;
;
;
;
;
;}
_0x20C0009:
	ADIW R28,4
	RET
;
;void save_temp_data(void)
;{
_save_temp_data:
;if( temp_data_saved){return;};
	SBRC R2,0
	RET
; // display_number=DISP_SAVING;
; // refresh_display();
;  eeprom_v_bake = (int)v_bake;
	CALL SUBOPT_0x20
	CALL __CFD1
	LDI  R26,LOW(_eeprom_v_bake)
	LDI  R27,HIGH(_eeprom_v_bake)
	CALL __CWD1
	CALL __EEPROMWRD
;  eeprom_do_zameny_grm_imp = do_zameny_grm_imp;
	CALL SUBOPT_0x21
;  eeprom_do_zameny_masla_imp = do_zameny_masla_imp;
	CALL SUBOPT_0x22
;  eeprom_vlito_total_ml = (int)vlito_total_ml;
	CALL SUBOPT_0xD
	CALL __CFD1
	LDI  R26,LOW(_eeprom_vlito_total_ml)
	LDI  R27,HIGH(_eeprom_vlito_total_ml)
	CALL __CWD1
	CALL __EEPROMWRD
;  eeprom_put_total_imp = put_total_imp;
	CALL SUBOPT_0xA
	LDI  R26,LOW(_eeprom_put_total_imp)
	LDI  R27,HIGH(_eeprom_put_total_imp)
	CALL __EEPROMWRD
;  temp_data_saved =1;
	SET
	BLD  R2,0
; // delay_ms(2000);
;//  display_number=DISP_MAIN_1;
;
;}
	RET
;
;void load_temp_data(void)
;{
_load_temp_data:
;  v_bake = eeprom_v_bake;
	LDI  R26,LOW(_eeprom_v_bake)
	LDI  R27,HIGH(_eeprom_v_bake)
	CALL __EEPROMRDD
	LDI  R26,LOW(_v_bake)
	LDI  R27,HIGH(_v_bake)
	CALL __CDF1U
	CALL __PUTDP1
;  do_zameny_grm_imp = eeprom_do_zameny_grm_imp;
	CALL SUBOPT_0x23
;  do_zameny_masla_imp = eeprom_do_zameny_masla_imp;
	CALL SUBOPT_0x24
;  vlito_total_ml = eeprom_vlito_total_ml;
	LDI  R26,LOW(_eeprom_vlito_total_ml)
	LDI  R27,HIGH(_eeprom_vlito_total_ml)
	CALL __EEPROMRDD
	LDI  R26,LOW(_vlito_total_ml)
	LDI  R27,HIGH(_vlito_total_ml)
	CALL __CDF1U
	CALL __PUTDP1
;  put_total_imp = eeprom_put_total_imp;
	LDI  R26,LOW(_eeprom_put_total_imp)
	LDI  R27,HIGH(_eeprom_put_total_imp)
	CALL __EEPROMRDD
	STS  _put_total_imp,R30
	STS  _put_total_imp+1,R31
	STS  _put_total_imp+2,R22
	STS  _put_total_imp+3,R23
;  temp_data_saved =0;
	CLT
	BLD  R2,0
;  display_brightness = eeprom_display_brightness;
	LDI  R26,LOW(_eeprom_display_brightness)
	LDI  R27,HIGH(_eeprom_display_brightness)
	CALL __EEPROMRDB
	STS  _display_brightness,R30
;}
	RET
;
;void light_display(void)
;{
_light_display:
;
;
;
;if(((LEG_IGNITION)||(LEG_LIGHT))&&TCCR0==0x00){TCCR0=0x6A;}  //    
	SBIC 0x10,4
	RJMP _0x33
	SBIS 0x10,5
	RJMP _0x35
_0x33:
	IN   R30,0x33
	CPI  R30,0
	BREQ _0x36
_0x35:
	RJMP _0x32
_0x36:
	LDI  R30,LOW(106)
	OUT  0x33,R30
;
;if((!LEG_IGNITION)&&(!LEG_LIGHT)&&(TCCR0 == 0x6A)){TCCR0=0x00;PORTB.3 =0;} //    
_0x32:
	SBIC 0x10,4
	RJMP _0x38
	SBIC 0x10,5
	RJMP _0x38
	IN   R30,0x33
	CPI  R30,LOW(0x6A)
	BREQ _0x39
_0x38:
	RJMP _0x37
_0x39:
	LDI  R30,LOW(0)
	OUT  0x33,R30
	CBI  0x18,3
;
;
;
;
;
;
;}
_0x37:
	RET
;
;void enable_drl(void)
;{
_enable_drl:
;
;
;//   , 
;if((LEG_LIGHT)&&(PIN_DRL)){PIN_DRL=0;
	SBIS 0x10,5
	RJMP _0x3D
	SBIC 0x15,6
	RJMP _0x3E
_0x3D:
	RJMP _0x3C
_0x3E:
	CBI  0x15,6
;save_temp_data();
	RCALL _save_temp_data
; #asm
   JMP __RESET
;return;};
	RET
_0x3C:
;
;if(LEG_LIGHT){return;};
	SBIC 0x10,5
	RET
;//  ,   - 
;if((LEG_IGNITION)&&(PIN_DRL)){return;}
	SBIS 0x10,4
	RJMP _0x43
	SBIC 0x15,6
	RJMP _0x44
_0x43:
	RJMP _0x42
_0x44:
	RET
;
;//  ,   - 
;if((!LEG_IGNITION)&&(!PIN_DRL)){return;}
_0x42:
	SBIC 0x10,4
	RJMP _0x46
	SBIS 0x15,6
	RJMP _0x47
_0x46:
	RJMP _0x45
_0x47:
	RET
;
;//  ,  ,  
;if((LEG_IGNITION)&&(!PIN_DRL)){if(speed > DRL_SPEED){PIN_DRL=1;}return;}
_0x45:
	SBIS 0x10,4
	RJMP _0x49
	SBIS 0x15,6
	RJMP _0x4A
_0x49:
	RJMP _0x48
_0x4A:
	LDI  R30,LOW(4)
	CP   R30,R5
	BRSH _0x4B
	SBI  0x15,6
_0x4B:
	RET
;
;//  ,   - 
;if((!LEG_IGNITION)&&(PIN_DRL)){PIN_DRL=0;save_temp_data();
_0x48:
	SBIC 0x10,4
	RJMP _0x4F
	SBIC 0x15,6
	RJMP _0x50
_0x4F:
	RJMP _0x4E
_0x50:
	CBI  0x15,6
	RCALL _save_temp_data
; #asm
   JMP __RESET
;return;}
	RET
;}
_0x4E:
	RET
;
;
;
;#include <mondeo_kb.c>
;void kb(void)  // KEY_MENU   KEY_UP  KEY_DOWN   KEY_LEFT  KEY_RIGHT
; 0000 0003  {
_kb:
;// while(!KEY_LEFT){
;// lcd_clear();
;//ftoa(PORTB,0,displ_buffer);
;//  lcd_puts(displ_buffer);delay_ms(1000);return;
;// }
;
;
;  //   
; if ((display_number==DISP_MAIN_1)||(display_number==DISP_MAIN_2)||(display_number==DISP_MAIN_3))
	LDS  R26,_display_number
	CPI  R26,LOW(0x65)
	BREQ _0x54
	CPI  R26,LOW(0x66)
	BREQ _0x54
	CPI  R26,LOW(0x67)
	BREQ _0x54
	RJMP _0x53
_0x54:
; {
; if(!KEY_RIGHT)
	SBIC 0x16,1
	RJMP _0x56
; {
;
; refresh_lcd_count =0;
	LDI  R30,LOW(0)
	STS  _refresh_lcd_count,R30
; if(display_number == DISP_MAIN_1){display_number =DISP_MAIN_2;refresh_display();while(!KEY_RIGHT){} delay_ms(TIME_ANTIDREB);return;}
	LDS  R26,_display_number
	CPI  R26,LOW(0x65)
	BRNE _0x57
	LDI  R30,LOW(102)
	CALL SUBOPT_0x25
_0x58:
	SBIS 0x16,1
	RJMP _0x58
	RJMP _0x20C0008
; if(display_number == DISP_MAIN_2){display_number =DISP_MAIN_3;refresh_display();while(!KEY_RIGHT){} delay_ms(TIME_ANTIDREB);return;}
_0x57:
	LDS  R26,_display_number
	CPI  R26,LOW(0x66)
	BRNE _0x5B
	LDI  R30,LOW(103)
	CALL SUBOPT_0x25
_0x5C:
	SBIS 0x16,1
	RJMP _0x5C
	RJMP _0x20C0008
; if(display_number == DISP_MAIN_3){display_number =DISP_MAIN_1;refresh_display();while(!KEY_RIGHT){} delay_ms(TIME_ANTIDREB);return;}
_0x5B:
	LDS  R26,_display_number
	CPI  R26,LOW(0x67)
	BRNE _0x5F
	LDI  R30,LOW(101)
	CALL SUBOPT_0x25
_0x60:
	SBIS 0x16,1
	RJMP _0x60
	RJMP _0x20C0008
; }
_0x5F:
; if(!KEY_LEFT)
_0x56:
	SBIC 0x16,4
	RJMP _0x63
; {
;
; refresh_lcd_count =0;
	LDI  R30,LOW(0)
	STS  _refresh_lcd_count,R30
; if(display_number == DISP_MAIN_3){display_number =DISP_MAIN_2;refresh_display();while(!KEY_LEFT){} delay_ms(TIME_ANTIDREB);return;}
	LDS  R26,_display_number
	CPI  R26,LOW(0x67)
	BRNE _0x64
	LDI  R30,LOW(102)
	CALL SUBOPT_0x25
_0x65:
	SBIS 0x16,4
	RJMP _0x65
	RJMP _0x20C0008
; if(display_number == DISP_MAIN_2){display_number =DISP_MAIN_1;refresh_display();while(!KEY_LEFT){} delay_ms(TIME_ANTIDREB);return;}
_0x64:
	LDS  R26,_display_number
	CPI  R26,LOW(0x66)
	BRNE _0x68
	LDI  R30,LOW(101)
	CALL SUBOPT_0x25
_0x69:
	SBIS 0x16,4
	RJMP _0x69
	RJMP _0x20C0008
; if(display_number == DISP_MAIN_1){display_number =DISP_MAIN_3;refresh_display();while(!KEY_LEFT){} delay_ms(TIME_ANTIDREB);return;}
_0x68:
	LDS  R26,_display_number
	CPI  R26,LOW(0x65)
	BRNE _0x6C
	LDI  R30,LOW(103)
	CALL SUBOPT_0x25
_0x6D:
	SBIS 0x16,4
	RJMP _0x6D
	RJMP _0x20C0008
; }
_0x6C:
; if(!KEY_MENU)
_0x63:
	SBIC 0x16,5
	RJMP _0x70
; {
;
; refresh_lcd_count =0;
	LDI  R30,LOW(0)
	STS  _refresh_lcd_count,R30
; display_number = DISP_MENU;
	LDI  R30,LOW(110)
	STS  _display_number,R30
; sel_item = DISP_NUMBER_MIN;
	CALL SUBOPT_0x26
; refresh_display();
	RCALL _refresh_display
; while(!KEY_MENU){}
_0x71:
	SBIS 0x16,5
	RJMP _0x71
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0008
; return;
; }
; }
_0x70:
;
;if (display_number==DISP_MENU)
_0x53:
	LDS  R26,_display_number
	CPI  R26,LOW(0x6E)
	BREQ PC+3
	JMP _0x74
;{
; if(!KEY_UP)
	SBIC 0x16,0
	RJMP _0x75
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x27
; sel_item--;
	SBIW R30,1
	CALL SUBOPT_0x28
; if(sel_item < DISP_NUMBER_MIN){sel_item =DISP_NUMBER_MAX;}
	SBIW R26,10
	BRGE _0x76
	LDI  R30,LOW(18)
	LDI  R31,HIGH(18)
	STS  _sel_item,R30
	STS  _sel_item+1,R31
; refresh_display();
_0x76:
	RCALL _refresh_display
; while(!KEY_UP){}
_0x77:
	SBIS 0x16,0
	RJMP _0x77
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0008
; return;
; }
; if(!KEY_DOWN)
_0x75:
	SBIC 0x16,2
	RJMP _0x7A
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x27
; sel_item++;
	ADIW R30,1
	CALL SUBOPT_0x28
; if(sel_item > DISP_NUMBER_MAX){sel_item =DISP_NUMBER_MIN;}
	SBIW R26,19
	BRLT _0x7B
	CALL SUBOPT_0x26
; refresh_display();
_0x7B:
	RCALL _refresh_display
; while(!KEY_DOWN){}
_0x7C:
	SBIS 0x16,2
	RJMP _0x7C
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0008
; return;
; }
; if(!KEY_MENU)
_0x7A:
	SBIC 0x16,5
	RJMP _0x7F
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	STS  _old_display_number,R30
; display_number = sel_item;
	LDS  R30,_sel_item
	CALL SUBOPT_0x25
; refresh_display();
; while(!KEY_MENU){}
_0x80:
	SBIS 0x16,5
	RJMP _0x80
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0008
; return;
; }
; if(!KEY_LEFT)
_0x7F:
	SBIC 0x16,4
	RJMP _0x83
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	STS  _old_display_number,R30
; display_number = DISP_MAIN_1;
	LDI  R30,LOW(101)
	CALL SUBOPT_0x25
; refresh_display();
; while(!KEY_LEFT){}
_0x84:
	SBIS 0x16,4
	RJMP _0x84
; delay_ms(TIME_ANTIDREB);
_0x20C0008:
	LDI  R26,LOW(100)
	CALL SUBOPT_0x5
; return;
	RET
; }
; }
_0x83:
;
;if (display_number==DISP_ZAPRAVKA)   //         // delay_ms(DELAY_KEY_PRESSED*5); {delay_ms(DELAY_KEY_PRESSED);display_contrast;refresh_display();}
_0x74:
	LDS  R26,_display_number
	CPI  R26,LOW(0xA)
	BREQ PC+3
	JMP _0x87
;{
; if(!KEY_UP)
	SBIC 0x16,0
	RJMP _0x88
; {
; refresh_lcd_count =0;  //  +1 
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x29
; v_bake_plus = v_bake_plus + 100;
	CALL SUBOPT_0x2A
; refresh_display();
; delay_ms(DELAY_KEY_PRESSED*5);
	LDI  R26,LOW(250)
	CALL SUBOPT_0x5
; while(!KEY_UP){{delay_ms(DELAY_KEY_PRESSED);v_bake_plus = v_bake_plus + 1000;refresh_display();}}
_0x89:
	SBIC 0x16,0
	RJMP _0x8B
	LDI  R26,LOW(50)
	CALL SUBOPT_0x5
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x2A
	RJMP _0x89
_0x8B:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_DOWN)
_0x88:
	SBIC 0x16,2
	RJMP _0x8C
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x29
; v_bake_plus = v_bake_plus - 100;
	CALL SUBOPT_0x2C
; refresh_display();
; delay_ms(DELAY_KEY_PRESSED*5);
	LDI  R26,LOW(250)
	CALL SUBOPT_0x5
; while(!KEY_DOWN){{delay_ms(DELAY_KEY_PRESSED);v_bake_plus = v_bake_plus - 1000;refresh_display();}}
_0x8D:
	SBIC 0x16,2
	RJMP _0x8F
	LDI  R26,LOW(50)
	CALL SUBOPT_0x5
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x2C
	RJMP _0x8D
_0x8F:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_RIGHT)
_0x8C:
	SBIC 0x16,1
	RJMP _0x90
; {
; refresh_lcd_count =0;  // +10 
	CALL SUBOPT_0x9
; old_display_number=0;
	STS  _old_display_number,R30
; v_bake_plus = v_bake_plus + 10000;
	CALL SUBOPT_0x2D
	__GETD2N 0x461C4000
	CALL SUBOPT_0x2A
; refresh_display();
; while(!KEY_RIGHT){}
_0x91:
	SBIS 0x16,1
	RJMP _0x91
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_LEFT)
_0x90:
	SBIC 0x16,4
	RJMP _0x94
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_LEFT){}
_0x95:
	SBIS 0x16,4
	RJMP _0x95
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_MENU)  // 
_0x94:
	SBIC 0x16,5
	RJMP _0x98
; {
; refresh_lcd_count =0;
	LDI  R30,LOW(0)
	STS  _refresh_lcd_count,R30
; v_bake = v_bake + v_bake_plus;
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x1B
	CALL __ADDF12
	CALL SUBOPT_0x2F
; old_display_number=0;
	LDI  R30,LOW(0)
	STS  _old_display_number,R30
; display_number = DISP_MAIN_1;
	LDI  R30,LOW(101)
	CALL SUBOPT_0x25
; refresh_display();
; while(!KEY_MENU){}
_0x99:
	SBIS 0x16,5
	RJMP _0x99
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
;};
_0x98:
_0x87:
;
;if (display_number==DISP_SERVIS)   // 
	LDS  R26,_display_number
	CPI  R26,LOW(0xC)
	BRNE _0x9C
;{
; if(!KEY_LEFT)
	SBIC 0x16,4
	RJMP _0x9D
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_LEFT){}
_0x9E:
	SBIS 0x16,4
	RJMP _0x9E
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_MENU)
_0x9D:
	SBIS 0x16,5
; {
;// refresh_lcd_count =0;
;// old_display_number=0;
;// display_number = 1;
;// refresh_display();
;// while(!KEY_MENU){}
;// delay_ms(TIME_ANTIDREB);
; return;
	RET
; }
;
;};
_0x9C:
;
;if (display_number==DISP_RST_COUNTERS)   //    
	LDS  R26,_display_number
	CPI  R26,LOW(0xB)
	BRNE _0xA2
;{
; if(!KEY_RIGHT)
	SBIC 0x16,1
	RJMP _0xA3
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	STS  _old_display_number,R30
; put_total_imp = 0;
	LDI  R30,LOW(0)
	STS  _put_total_imp,R30
	STS  _put_total_imp+1,R30
	STS  _put_total_imp+2,R30
	STS  _put_total_imp+3,R30
; vlito_total_ml = 0;
	STS  _vlito_total_ml,R30
	STS  _vlito_total_ml+1,R30
	STS  _vlito_total_ml+2,R30
	STS  _vlito_total_ml+3,R30
; eeprom_put_total_imp = 0;
	LDI  R26,LOW(_eeprom_put_total_imp)
	LDI  R27,HIGH(_eeprom_put_total_imp)
	CALL SUBOPT_0x3
; eeprom_vlito_total_ml = 0;
	LDI  R26,LOW(_eeprom_vlito_total_ml)
	LDI  R27,HIGH(_eeprom_vlito_total_ml)
	CALL SUBOPT_0x3
; display_number = DISP_MENU;
	LDI  R30,LOW(110)
	CALL SUBOPT_0x25
; refresh_display();
; while(!KEY_RIGHT){}
_0xA4:
	SBIS 0x16,1
	RJMP _0xA4
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_LEFT)
_0xA3:
	SBIC 0x16,4
	RJMP _0xA7
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_LEFT){}
_0xA8:
	SBIS 0x16,4
	RJMP _0xA8
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
;
;
;
;
;
;  }  // End kb
_0xA7:
;
;if (display_number==DISP_FORS)   // 
_0xA2:
	LDS  R26,_display_number
	CPI  R26,LOW(0xF)
	BREQ PC+3
	JMP _0xAB
;{
; if(!KEY_UP)
	SBIC 0x16,0
	RJMP _0xAC
; {
; refresh_lcd_count =0;  //  +1 /
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x30
; PrFors = PrFors+0.1;
	CALL SUBOPT_0x31
; refresh_display();
; delay_ms(DELAY_KEY_PRESSED*5);
	LDI  R26,LOW(250)
	CALL SUBOPT_0x5
; while(!KEY_UP){{delay_ms(DELAY_KEY_PRESSED);PrFors = PrFors+1;;refresh_display();}}
_0xAD:
	SBIC 0x16,0
	RJMP _0xAF
	LDI  R26,LOW(50)
	CALL SUBOPT_0x5
	CALL SUBOPT_0x32
	CALL SUBOPT_0x31
	RJMP _0xAD
_0xAF:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_DOWN)
_0xAC:
	SBIC 0x16,2
	RJMP _0xB0
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x30
; PrFors = PrFors-0.1;
	CALL SUBOPT_0x33
; refresh_display();
; delay_ms(DELAY_KEY_PRESSED*5);
	LDI  R26,LOW(250)
	CALL SUBOPT_0x5
; while(!KEY_DOWN){{delay_ms(DELAY_KEY_PRESSED); PrFors = PrFors-1;;refresh_display();}}
_0xB1:
	SBIC 0x16,2
	RJMP _0xB3
	LDI  R26,LOW(50)
	CALL SUBOPT_0x5
	CALL SUBOPT_0x32
	CALL SUBOPT_0x33
	RJMP _0xB1
_0xB3:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_RIGHT)
_0xB0:
; {
;// refresh_lcd_count =0;
;// old_display_number=0;
;// PrFors = PrFors+10;
;// refresh_display();
;// while(!KEY_RIGHT){}
;// delay_ms(TIME_ANTIDREB);
;// return;
; }
;
; if(!KEY_LEFT)
	SBIC 0x16,4
	RJMP _0xB5
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x34
; display_number = DISP_MENU;
; PrFors = eeprom_PrFors;
	CALL SUBOPT_0x7
; refresh_display();
	RCALL _refresh_display
; while(!KEY_LEFT){}
_0xB6:
	SBIS 0x16,4
	RJMP _0xB6
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_MENU)  // 
_0xB5:
	SBIC 0x16,5
	RJMP _0xB9
; {
; refresh_lcd_count =0;
	LDI  R30,LOW(0)
	STS  _refresh_lcd_count,R30
; eeprom_PrFors =  PrFors;
	CALL SUBOPT_0x35
	LDI  R26,LOW(_eeprom_PrFors)
	LDI  R27,HIGH(_eeprom_PrFors)
	CALL __EEPROMWRD
; old_display_number=0;
	LDI  R30,LOW(0)
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_MENU){}
_0xBA:
	SBIS 0x16,5
	RJMP _0xBA
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
;};
_0xB9:
_0xAB:
;
;if (display_number==DISP_SPEED)   //  
	LDS  R26,_display_number
	CPI  R26,LOW(0x10)
	BREQ PC+3
	JMP _0xBD
;{
; if(!KEY_UP)
	SBIC 0x16,0
	RJMP _0xBE
; {
; refresh_lcd_count =0;  //  +10
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x36
; imp_km = imp_km+1;
	__ADDD1N 1
	CALL SUBOPT_0x37
; refresh_display();
; delay_ms(DELAY_KEY_PRESSED*5);
	LDI  R26,LOW(250)
	CALL SUBOPT_0x5
; while(!KEY_UP){delay_ms(DELAY_KEY_PRESSED);imp_km = imp_km + 10;refresh_display();}
_0xBF:
	SBIC 0x16,0
	RJMP _0xC1
	LDI  R26,LOW(50)
	CALL SUBOPT_0x5
	CALL SUBOPT_0xB
	__ADDD1N 10
	CALL SUBOPT_0x37
	RJMP _0xBF
_0xC1:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_DOWN)
_0xBE:
	SBIC 0x16,2
	RJMP _0xC2
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x36
; imp_km = imp_km-1;
	__SUBD1N 1
	CALL SUBOPT_0x37
; refresh_display();
; delay_ms(DELAY_KEY_PRESSED*5);
	LDI  R26,LOW(250)
	CALL SUBOPT_0x5
; while(!KEY_DOWN){delay_ms(DELAY_KEY_PRESSED);imp_km = imp_km-10;refresh_display();}
_0xC3:
	SBIC 0x16,2
	RJMP _0xC5
	LDI  R26,LOW(50)
	CALL SUBOPT_0x5
	CALL SUBOPT_0xB
	__SUBD1N 10
	CALL SUBOPT_0x37
	RJMP _0xC3
_0xC5:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_RIGHT)
_0xC2:
	SBIC 0x16,1
	RJMP _0xC6
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x36
;  imp_km = imp_km + 1000;
	__ADDD1N 1000
	CALL SUBOPT_0x37
; refresh_display();
; while(!KEY_RIGHT){}
_0xC7:
	SBIS 0x16,1
	RJMP _0xC7
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_LEFT)
_0xC6:
	SBIC 0x16,4
	RJMP _0xCA
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x34
; display_number = DISP_MENU;
; imp_km = eeprom_imp_km;
	CALL SUBOPT_0x8
; refresh_display();
	RCALL _refresh_display
; while(!KEY_LEFT){}
_0xCB:
	SBIS 0x16,4
	RJMP _0xCB
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_MENU)  // 
_0xCA:
	SBIC 0x16,5
	RJMP _0xCE
; {
; refresh_lcd_count =0;
	LDI  R30,LOW(0)
	STS  _refresh_lcd_count,R30
; eeprom_imp_km =  imp_km;
	LDS  R30,_imp_km
	LDS  R31,_imp_km+1
	LDI  R26,LOW(_eeprom_imp_km)
	LDI  R27,HIGH(_eeprom_imp_km)
	CALL __EEPROMWRW
; old_display_number=0;
	LDI  R30,LOW(0)
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_MENU){}
_0xCF:
	SBIS 0x16,5
	RJMP _0xCF
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
;
;
;
;  }
_0xCE:
;
;if (display_number==DISP_GRM)   // 
_0xBD:
	LDS  R26,_display_number
	CPI  R26,LOW(0xE)
	BREQ PC+3
	JMP _0xD2
;{
; if(!KEY_UP)
	SBIC 0x16,0
	RJMP _0xD3
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x36
; do_zameny_grm_imp = do_zameny_grm_imp+(imp_km*1000);
	CALL SUBOPT_0x17
	CALL SUBOPT_0x38
; refresh_display();
;  delay_ms(DELAY_KEY_PRESSED*5);
	LDI  R26,LOW(250)
	CALL SUBOPT_0x5
; while(!KEY_UP){{delay_ms(DELAY_KEY_PRESSED);do_zameny_grm_imp = do_zameny_grm_imp+(imp_km*1000);;refresh_display();}}
_0xD4:
	SBIC 0x16,0
	RJMP _0xD6
	LDI  R26,LOW(50)
	CALL SUBOPT_0x5
	CALL SUBOPT_0xB
	CALL SUBOPT_0x17
	CALL SUBOPT_0x38
	RJMP _0xD4
_0xD6:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_DOWN)
_0xD3:
	SBIC 0x16,2
	RJMP _0xD7
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x36
; do_zameny_grm_imp = do_zameny_grm_imp-(imp_km*100);
	CALL SUBOPT_0x39
; refresh_display();
; delay_ms(DELAY_KEY_PRESSED*5);
	LDI  R26,LOW(250)
	CALL SUBOPT_0x5
; while(!KEY_DOWN){{delay_ms(DELAY_KEY_PRESSED);do_zameny_grm_imp = do_zameny_grm_imp-(imp_km*100);;refresh_display();}}
_0xD8:
	SBIC 0x16,2
	RJMP _0xDA
	LDI  R26,LOW(50)
	CALL SUBOPT_0x5
	CALL SUBOPT_0xB
	CALL SUBOPT_0x39
	RJMP _0xD8
_0xDA:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_RIGHT)
_0xD7:
	SBIC 0x16,1
	RJMP _0xDB
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x36
; do_zameny_grm_imp = imp_km*100000;
	__GETD2N 0x186A0
	CALL __MULD12U
	STS  _do_zameny_grm_imp,R30
	STS  _do_zameny_grm_imp+1,R31
	STS  _do_zameny_grm_imp+2,R22
	STS  _do_zameny_grm_imp+3,R23
; refresh_display();
	RCALL _refresh_display
; while(!KEY_RIGHT){}
_0xDC:
	SBIS 0x16,1
	RJMP _0xDC
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_LEFT)
_0xDB:
	SBIC 0x16,4
	RJMP _0xDF
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x34
; display_number = DISP_MENU;
; do_zameny_grm_imp = eeprom_do_zameny_grm_imp;
	CALL SUBOPT_0x23
; refresh_display();
	RCALL _refresh_display
; while(!KEY_LEFT){}
_0xE0:
	SBIS 0x16,4
	RJMP _0xE0
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_MENU)  // 
_0xDF:
	SBIC 0x16,5
	RJMP _0xE3
; {
; refresh_lcd_count =0;
	LDI  R30,LOW(0)
	STS  _refresh_lcd_count,R30
; eeprom_do_zameny_grm_imp = do_zameny_grm_imp;
	CALL SUBOPT_0x21
; old_display_number=0;
	LDI  R30,LOW(0)
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_MENU){}
_0xE4:
	SBIS 0x16,5
	RJMP _0xE4
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
; }
_0xE3:
;
;if (display_number==DISP_OIL)   // 
_0xD2:
	LDS  R26,_display_number
	CPI  R26,LOW(0xD)
	BREQ PC+3
	JMP _0xE7
;{
; if(!KEY_UP)
	SBIC 0x16,0
	RJMP _0xE8
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x36
;
; do_zameny_masla_imp = do_zameny_masla_imp+(imp_km*100);
	CALL SUBOPT_0x3A
; refresh_display();
;  delay_ms(DELAY_KEY_PRESSED*5);
	LDI  R26,LOW(250)
	CALL SUBOPT_0x5
; while(!KEY_UP){delay_ms(DELAY_KEY_PRESSED);do_zameny_masla_imp = do_zameny_masla_imp+(imp_km*100);refresh_display();}
_0xE9:
	SBIC 0x16,0
	RJMP _0xEB
	LDI  R26,LOW(50)
	CALL SUBOPT_0x5
	CALL SUBOPT_0xB
	CALL SUBOPT_0x3A
	RJMP _0xE9
_0xEB:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_DOWN)
_0xE8:
	SBIC 0x16,2
	RJMP _0xEC
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x36
; do_zameny_masla_imp = do_zameny_masla_imp-(imp_km*10);
	CALL SUBOPT_0x3B
; refresh_display();
; delay_ms(DELAY_KEY_PRESSED*5);
	LDI  R26,LOW(250)
	CALL SUBOPT_0x5
; while(!KEY_DOWN){delay_ms(DELAY_KEY_PRESSED);do_zameny_masla_imp = do_zameny_masla_imp-(imp_km*10);refresh_display();}
_0xED:
	SBIC 0x16,2
	RJMP _0xEF
	LDI  R26,LOW(50)
	CALL SUBOPT_0x5
	CALL SUBOPT_0xB
	CALL SUBOPT_0x3B
	RJMP _0xED
_0xEF:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_RIGHT)
_0xEC:
	SBIC 0x16,1
	RJMP _0xF0
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x36
; do_zameny_masla_imp = imp_km*10000;
	__GETD2N 0x2710
	CALL __MULD12U
	STS  _do_zameny_masla_imp,R30
	STS  _do_zameny_masla_imp+1,R31
	STS  _do_zameny_masla_imp+2,R22
	STS  _do_zameny_masla_imp+3,R23
; refresh_display();
	RCALL _refresh_display
; while(!KEY_RIGHT){}
_0xF1:
	SBIS 0x16,1
	RJMP _0xF1
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_LEFT)
_0xF0:
	SBIC 0x16,4
	RJMP _0xF4
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x34
; display_number = DISP_MENU;
; do_zameny_masla_imp = eeprom_do_zameny_masla_imp;
	CALL SUBOPT_0x24
; refresh_display();
	RCALL _refresh_display
; while(!KEY_LEFT){}
_0xF5:
	SBIS 0x16,4
	RJMP _0xF5
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_MENU)  // 
_0xF4:
	SBIC 0x16,5
	RJMP _0xF8
; {
; refresh_lcd_count =0;
	LDI  R30,LOW(0)
	STS  _refresh_lcd_count,R30
; eeprom_do_zameny_masla_imp = do_zameny_masla_imp;
	CALL SUBOPT_0x22
; old_display_number=0;
	LDI  R30,LOW(0)
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_MENU){}
_0xF9:
	SBIS 0x16,5
	RJMP _0xF9
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
;
;
;
;  }  // End kb
_0xF8:
;
;if (display_number==DISP_DEBAG)   // 
_0xE7:
	LDS  R26,_display_number
	CPI  R26,LOW(0xD2)
	BRNE _0xFC
;{
; if(!KEY_LEFT)
	SBIC 0x16,4
	RJMP _0xFD
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_LEFT){}
_0xFE:
	SBIS 0x16,4
	RJMP _0xFE
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_MENU)  // 
_0xFD:
	SBIC 0x16,5
	RJMP _0x101
; {
; refresh_lcd_count =0;
	LDI  R30,LOW(0)
	STS  _refresh_lcd_count,R30
;// old_display_number=0;
;// display_number = 4;
; refresh_display();
	RCALL _refresh_display
; while(!KEY_MENU){}
_0x102:
	SBIS 0x16,5
	RJMP _0x102
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
;
;
;
;  }  // End kb
_0x101:
;
;if (display_number==RST_DEFAULT)   //   
_0xFC:
	LDS  R26,_display_number
	CPI  R26,LOW(0x12)
	BRNE _0x105
;{
; if(!KEY_RIGHT)
	SBIC 0x16,1
	RJMP _0x106
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	STS  _old_display_number,R30
; load_defaults();
	CALL _load_defaults
; load_temp_data();
	RCALL _load_temp_data
; display_number = DISP_MENU;
	LDI  R30,LOW(110)
	CALL SUBOPT_0x25
; refresh_display();
; while(!KEY_RIGHT){}
_0x107:
	SBIS 0x16,1
	RJMP _0x107
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_LEFT)
_0x106:
	SBIC 0x16,4
	RJMP _0x10A
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_LEFT){}
_0x10B:
	SBIS 0x16,4
	RJMP _0x10B
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
;
;
;
;
;
;  }  // End kb
_0x10A:
;
;if (display_number==DISP_ABOUT)   // DISP_ABOUT
_0x105:
	LDS  R26,_display_number
	CPI  R26,LOW(0xC8)
	BRNE _0x10E
;{
; if(!KEY_LEFT)
	SBIC 0x16,4
	RJMP _0x10F
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_LEFT){}
_0x110:
	SBIS 0x16,4
	RJMP _0x110
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
;}
_0x10F:
;
;if (display_number==DISP_CONTRAST)   // 
_0x10E:
	LDS  R26,_display_number
	CPI  R26,LOW(0xC9)
	BRNE _0x113
;{
; if(!KEY_UP)
	SBIC 0x16,0
	RJMP _0x114
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	STS  _old_display_number,R30
; //display_contrast++;if(display_contrast > 100){display_contrast =100;};
; //lcd_contrast(display_contrast);
; refresh_display();
	CALL SUBOPT_0x3C
; delay_ms(TIME_ANTIDREB*5);
; //while(!KEY_UP){delay_ms(DELAY_KEY_PRESSED);display_contrast++;if(display_contrast > 100){display_contrast =100;};refresh_display();}
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_DOWN)
_0x114:
	SBIC 0x16,2
	RJMP _0x115
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	STS  _old_display_number,R30
; //display_contrast--;if(display_contrast < 1){display_contrast =1;};
; //lcd_contrast(display_contrast);
; refresh_display();
	CALL SUBOPT_0x3D
;delay_ms(DELAY_KEY_PRESSED*5);
; //while(!KEY_DOWN){delay_ms(DELAY_KEY_PRESSED);display_contrast--;if(display_contrast < 1){display_contrast =1;};refresh_display();}
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_LEFT)
_0x115:
	SBIC 0x16,4
	RJMP _0x116
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x34
; display_number = DISP_MENU;
; refresh_lcd_count =220;
	LDI  R30,LOW(220)
	STS  _refresh_lcd_count,R30
; while(!KEY_LEFT){}
_0x117:
	SBIS 0x16,4
	RJMP _0x117
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_MENU)  // 
_0x116:
	SBIC 0x16,5
	RJMP _0x11A
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; //eeprom_display_contrast = display_contrast;
; old_display_number=0;
	CALL SUBOPT_0x34
; display_number = DISP_MENU;
; refresh_lcd_count =220;
	LDI  R30,LOW(220)
	STS  _refresh_lcd_count,R30
; while(!KEY_MENU){}
_0x11B:
	SBIS 0x16,5
	RJMP _0x11B
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;}
_0x11A:
;
;if (display_number==DISP_BRIGHTNESS)   // 
_0x113:
	LDS  R26,_display_number
	CPI  R26,LOW(0x11)
	BREQ PC+3
	JMP _0x11E
;{
; if(!KEY_UP)
	SBIC 0x16,0
	RJMP _0x11F
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	STS  _old_display_number,R30
; display_brightness++;if(display_brightness > 10){display_brightness =10;};
	CALL SUBOPT_0x3E
	BRLO _0x120
	LDI  R30,LOW(10)
	STS  _display_brightness,R30
_0x120:
; refresh_display();
	CALL SUBOPT_0x3C
; delay_ms(TIME_ANTIDREB*5);
; while(!KEY_UP){delay_ms(DELAY_KEY_PRESSED*2);display_brightness++;if(display_brightness > 10){display_brightness =10;};refresh_display();}
_0x121:
	SBIC 0x16,0
	RJMP _0x123
	LDI  R26,LOW(100)
	CALL SUBOPT_0x5
	CALL SUBOPT_0x3E
	BRLO _0x124
	LDI  R30,LOW(10)
	STS  _display_brightness,R30
_0x124:
	RCALL _refresh_display
	RJMP _0x121
_0x123:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_DOWN)
_0x11F:
	SBIC 0x16,2
	RJMP _0x125
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	STS  _old_display_number,R30
; display_brightness--;if(display_brightness < 1){display_brightness =1;};
	CALL SUBOPT_0x3F
	BRSH _0x126
	LDI  R30,LOW(1)
	STS  _display_brightness,R30
_0x126:
; //lcd_contrast(display_contrast);
; refresh_display();
	CALL SUBOPT_0x3D
;delay_ms(DELAY_KEY_PRESSED*5);
; while(!KEY_DOWN){delay_ms(DELAY_KEY_PRESSED*2);display_brightness--;if(display_brightness < 1){display_brightness =1;};refresh_display();}
_0x127:
	SBIC 0x16,2
	RJMP _0x129
	LDI  R26,LOW(100)
	CALL SUBOPT_0x5
	CALL SUBOPT_0x3F
	BRSH _0x12A
	LDI  R30,LOW(1)
	STS  _display_brightness,R30
_0x12A:
	RCALL _refresh_display
	RJMP _0x127
_0x129:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_LEFT)
_0x125:
	SBIC 0x16,4
	RJMP _0x12B
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_LEFT){}
_0x12C:
	SBIS 0x16,4
	RJMP _0x12C
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_MENU)  // 
_0x12B:
	SBIC 0x16,5
	RJMP _0x12F
; {
; refresh_lcd_count =0;
	LDI  R30,LOW(0)
	STS  _refresh_lcd_count,R30
; eeprom_display_brightness = display_brightness;
	LDS  R30,_display_brightness
	LDI  R26,LOW(_eeprom_display_brightness)
	LDI  R27,HIGH(_eeprom_display_brightness)
	CALL __EEPROMWRB
; old_display_number=0;
	LDI  R30,LOW(0)
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_MENU){}
_0x130:
	SBIS 0x16,5
	RJMP _0x130
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;}
_0x12F:
;
; if (display_number==DISP_CLIMAT)   // DISP_CLIMAT
_0x11E:
	LDS  R26,_display_number
	CPI  R26,LOW(0x96)
	BREQ PC+3
	JMP _0x133
;{
; if(!KEY_UP)
	SBIC 0x16,0
	RJMP _0x134
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x40
; clima_step++;if(clima_step > 100){clima_step =100;};
	CALL SUBOPT_0x41
	BRLT _0x135
	CALL SUBOPT_0x42
_0x135:
; refresh_display();
	CALL SUBOPT_0x3C
; delay_ms(TIME_ANTIDREB*5);
; while(!KEY_UP){delay_ms(DELAY_KEY_PRESSED);clima_step++;if(clima_step > 100){clima_step =100;};refresh_display();}
_0x136:
	SBIC 0x16,0
	RJMP _0x138
	LDI  R26,LOW(50)
	CALL SUBOPT_0x5
	LDI  R26,LOW(_clima_step)
	LDI  R27,HIGH(_clima_step)
	LD   R30,X+
	LD   R31,X+
	CALL SUBOPT_0x41
	BRLT _0x139
	CALL SUBOPT_0x42
_0x139:
	RCALL _refresh_display
	RJMP _0x136
_0x138:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_DOWN)
_0x134:
	SBIC 0x16,2
	RJMP _0x13A
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x40
; clima_step--;if(clima_step < 1){clima_step =1;};
	CALL SUBOPT_0x43
	BRGE _0x13B
	CALL SUBOPT_0x44
_0x13B:
; refresh_display();
	CALL SUBOPT_0x3D
;delay_ms(DELAY_KEY_PRESSED*5);
; while(!KEY_DOWN){delay_ms(DELAY_KEY_PRESSED);clima_step--;if(clima_step < 1){clima_step =1;};refresh_display();}
_0x13C:
	SBIC 0x16,2
	RJMP _0x13E
	LDI  R26,LOW(50)
	CALL SUBOPT_0x5
	LDI  R26,LOW(_clima_step)
	LDI  R27,HIGH(_clima_step)
	LD   R30,X+
	LD   R31,X+
	CALL SUBOPT_0x43
	BRGE _0x13F
	CALL SUBOPT_0x44
_0x13F:
	RCALL _refresh_display
	RJMP _0x13C
_0x13E:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_LEFT)
_0x13A:
	SBIC 0x16,4
	RJMP _0x140
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_LEFT){}
_0x141:
	SBIS 0x16,4
	RJMP _0x141
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
;// if(!KEY_MENU)  // 
;// {
;// refresh_lcd_count =0;
;// eeprom_display_brightness = display_brightness;
;// old_display_number=0;
;// display_number = DISP_MENU;
;// refresh_display();
;// while(!KEY_MENU){}
;// delay_ms(TIME_ANTIDREB);
;// return;
;// }
;}
_0x140:
;
; if (display_number==DISP_CLOCKS)   // 
_0x133:
	LDS  R26,_display_number
	CPI  R26,LOW(0x82)
	BREQ PC+3
	JMP _0x144
;{
; if(!KEY_UP)
	SBIC 0x16,0
	RJMP _0x145
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x45
; chasiki = chasiki + 3600;
	CALL SUBOPT_0x46
; refresh_display();
	CALL SUBOPT_0x3C
; delay_ms(TIME_ANTIDREB*5);
; while(!KEY_UP){delay_ms(DELAY_KEY_PRESSED*2);chasiki = chasiki + 3600;refresh_display();}
_0x146:
	SBIC 0x16,0
	RJMP _0x148
	LDI  R26,LOW(100)
	CALL SUBOPT_0x5
	CALL SUBOPT_0x47
	CALL SUBOPT_0x46
	RCALL _refresh_display
	RJMP _0x146
_0x148:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_DOWN)
_0x145:
	SBIC 0x16,2
	RJMP _0x149
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x45
; chasiki = chasiki - 3600;
	CALL SUBOPT_0x48
; refresh_display();
	CALL SUBOPT_0x3C
; delay_ms(TIME_ANTIDREB*5);
; while(!KEY_DOWN){delay_ms(DELAY_KEY_PRESSED*2);chasiki = chasiki - 3600;refresh_display();}
_0x14A:
	SBIC 0x16,2
	RJMP _0x14C
	LDI  R26,LOW(100)
	CALL SUBOPT_0x5
	CALL SUBOPT_0x47
	CALL SUBOPT_0x48
	RCALL _refresh_display
	RJMP _0x14A
_0x14C:
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_LEFT)
_0x149:
	SBIC 0x16,4
	RJMP _0x14D
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
;old_display_number=0;
	CALL SUBOPT_0x2E
; display_number = DISP_MENU;
; refresh_display();
; while(!KEY_LEFT){}
_0x14E:
	SBIS 0x16,4
	RJMP _0x14E
; delay_ms(TIME_ANTIDREB);
	RJMP _0x20C0007
; return;
; }
;
; if(!KEY_RIGHT)
_0x14D:
	SBIC 0x16,1
	RJMP _0x151
; {
; refresh_lcd_count =0;
	CALL SUBOPT_0x9
; old_display_number=0;
	CALL SUBOPT_0x45
; chasiki = chasiki + 60;
	CALL SUBOPT_0x49
; refresh_display();
	CALL SUBOPT_0x3C
; delay_ms(TIME_ANTIDREB*5);
; while(!KEY_RIGHT){delay_ms(DELAY_KEY_PRESSED*2);chasiki = chasiki + 60;refresh_display();}
_0x152:
	SBIC 0x16,1
	RJMP _0x154
	LDI  R26,LOW(100)
	CALL SUBOPT_0x5
	CALL SUBOPT_0x47
	CALL SUBOPT_0x49
	RCALL _refresh_display
	RJMP _0x152
_0x154:
; delay_ms(TIME_ANTIDREB);
_0x20C0007:
	LDI  R26,LOW(100)
	CALL SUBOPT_0x5
; return;
	RET
; }
;
;
;
;}
_0x151:
;
;
;
;
;
;
;
;
;
;
;
;
;
;
; }
_0x144:
	RET
;#include <mondeo_display.c>
;void refresh_display(void)
; 0000 0004 {
_refresh_display:
;int temp_brightness;
;float dlit_vpr_f;
;float put_total_m_f;
;//dlit_vpr_f = dlit_vpr;
;//    dlit_vpr_f=dlit_vpr_f/1000;
;//debag_data1 = dlit_vpr_f;
;//debag_data2 = dlit_vpr_zamer_count;
; if(!LEG_LIGHT){temp_brightness = display_brightness+3;}else{temp_brightness = display_brightness;}
	SBIW R28,8
	ST   -Y,R17
	ST   -Y,R16
;	temp_brightness -> R16,R17
;	dlit_vpr_f -> Y+6
;	put_total_m_f -> Y+2
	SBIC 0x10,5
	RJMP _0x155
	LDS  R30,_display_brightness
	LDI  R31,0
	ADIW R30,3
	MOVW R16,R30
	RJMP _0x156
_0x155:
	LDS  R16,_display_brightness
	CLR  R17
_0x156:
;
;
;
;switch (temp_brightness) {
	MOVW R30,R16
;    case 1: OCR0 =1;break;
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x15A
	LDI  R30,LOW(1)
	RJMP _0x1BF
;    case 2: OCR0 =5;break;
_0x15A:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x15B
	LDI  R30,LOW(5)
	RJMP _0x1BF
;    case 3: OCR0 =10;break;
_0x15B:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x15C
	LDI  R30,LOW(10)
	RJMP _0x1BF
;    case 4: OCR0 =20;break;
_0x15C:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x15D
	LDI  R30,LOW(20)
	RJMP _0x1BF
;    case 5: OCR0 =30;break;
_0x15D:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x15E
	LDI  R30,LOW(30)
	RJMP _0x1BF
;    case 6: OCR0 =50;break;
_0x15E:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x15F
	LDI  R30,LOW(50)
	RJMP _0x1BF
;    case 7: OCR0 =80;break;
_0x15F:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x160
	LDI  R30,LOW(80)
	RJMP _0x1BF
;    case 8: OCR0 =130;break;
_0x160:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x161
	LDI  R30,LOW(130)
	RJMP _0x1BF
;    case 9: OCR0 =175;break;
_0x161:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x162
	LDI  R30,LOW(175)
	RJMP _0x1BF
;    case 10: OCR0 =255;break;
_0x162:
;    default:OCR0 =255;
_0x1C0:
	LDI  R30,LOW(255)
_0x1BF:
	OUT  0x3C,R30
;    };
;
;
;
;
;//OCR2=display_brightness*10;
;//OCR2=155;
;// PORTC = 0xFF;delay_ms(1000);
;// PORTC = 0x00;delay_ms(1000);
;
;  //    .        .      .      .       .       .     .     .    
;  //   rashod_sred_l      rashod_mom_l     speed       adc_data_display     put_total_m      vlito_total_ml              v_bake               ost_km                dlit_vpr
;// PORTC.7 = !PORTC.7; return;
;if(refresh_display_worked){return;}
	LDS  R30,_refresh_display_worked
	CPI  R30,0
	BREQ _0x165
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,10
	RET
;refresh_display_worked = 1;
_0x165:
	LDI  R30,LOW(1)
	STS  _refresh_display_worked,R30
;flag_refresh_display = 0;
	LDI  R30,LOW(0)
	STS  _flag_refresh_display,R30
;if(display_number != old_display_number){lcd_clear();}
	LDS  R30,_old_display_number
	LDS  R26,_display_number
	CP   R30,R26
	BREQ _0x166
	CALL _lcd_clear
;old_display_number = display_number;
_0x166:
	LDS  R30,_display_number
	STS  _old_display_number,R30
;
;
;if(display_number ==DISP_MAIN_1) // 1   DRL  .   .   .
	LDS  R26,_display_number
	CPI  R26,LOW(0x65)
	BREQ PC+3
	JMP _0x167
;{
;//X
;//D< 12:01
;// 65.7 L = 255 
;//
;  lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;  lcd_putsf("                ");
	CALL SUBOPT_0x4B
;  if(PIN_DRL)
	SBIS 0x15,6
	RJMP _0x168
;  {
;  lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;  lcd_putsf("D< ");
	__POINTW2FN _0x0,55
	CALL _lcd_putsf
;  }
;
;  //lcd_gotoxy(6,0);
;
;  //if(chas < 10){lcd_putsf(" ");}
;  //ftoa(chas,0,displ_buffer);
;  //lcd_puts(displ_buffer);
;  //lcd_putsf(":");
;
;  //if(minut < 10){lcd_putsf("0");}
;  //ftoa(minut,0,displ_buffer);
;  //lcd_puts(displ_buffer);
;  //lcd_putsf(":");
;  //if(sek < 10){lcd_putsf("0");}
;  //ftoa(sek,0,displ_buffer);
; // lcd_puts(displ_buffer);
;  //lcd_gotoxy(5,0);
;
;   ftoa(speed,0,displ_buffer);
_0x168:
	CALL SUBOPT_0x4C
;    if(speed < 100)
	BRSH _0x169
;    {
;    if(speed < 10)lcd_gotoxy(6,0);
	LDI  R30,LOW(10)
	CP   R5,R30
	BRSH _0x16A
	LDI  R30,LOW(6)
	RJMP _0x1C1
;    else{lcd_gotoxy(5,0);}
_0x16A:
	LDI  R30,LOW(5)
_0x1C1:
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _lcd_gotoxy
;    }
;    if(speed >= 100){lcd_gotoxy(4,0);}
_0x169:
	LDI  R30,LOW(100)
	CP   R5,R30
	BRLO _0x16C
	CALL SUBOPT_0x4D
;    lcd_puts(displ_buffer);
_0x16C:
	CALL SUBOPT_0x4E
;
;    lcd_putsf("km/h ");
	__POINTW2FN _0x0,59
	CALL SUBOPT_0x4F
;
;  lcd_gotoxy(0,1);
;  lcd_putsf("                ");
;  lcd_gotoxy(0,1);
	CALL SUBOPT_0x50
;  lcd_putsf("ost ");
	__POINTW2FN _0x0,65
	CALL _lcd_putsf
;  ftoa(v_bake/1000,1,displ_buffer);
	CALL SUBOPT_0x1B
	CALL SUBOPT_0xE
	CALL SUBOPT_0x51
;  lcd_puts(displ_buffer);
;  lcd_putsf("L=");
	__POINTW2FN _0x0,70
	CALL _lcd_putsf
;  if(ost_km < 0)
	LDS  R26,_ost_km+3
	TST  R26
	BRPL _0x16D
;  {
;  lcd_putsf("- - ");
	__POINTW2FN _0x0,73
	RJMP _0x1C2
;  }
;  else
_0x16D:
;  {
;  if(ost_km > 999)
	LDS  R26,_ost_km
	LDS  R27,_ost_km+1
	LDS  R24,_ost_km+2
	LDS  R25,_ost_km+3
	__GETD1N 0x4479C000
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x16F
;  {
;  lcd_putsf("999");
	__POINTW2FN _0x0,78
	CALL _lcd_putsf
;  }
;  else
	RJMP _0x170
_0x16F:
;  {
;  ftoa(ost_km,0,displ_buffer);
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x52
;  lcd_puts(displ_buffer);
	CALL SUBOPT_0x4E
;  }
_0x170:
;  lcd_putsf(" km");
	__POINTW2FN _0x0,82
_0x1C2:
	CALL _lcd_putsf
;  }
;  refresh_display_worked = 0;return;
	LDI  R30,LOW(0)
	STS  _refresh_display_worked,R30
	RJMP _0x20C0006
; }
;
; if(display_number ==DISP_MAIN_2) // 2  .  .          rashod_mom_l     speed      dlit_vpr
_0x167:
	LDS  R26,_display_number
	CPI  R26,LOW(0x66)
	BREQ PC+3
	JMP _0x171
;{  //0123456789
;//XX
;//125 km/h 99.9 ms*
;// 99.9 L/100
;//{
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;
;   // lcd_putsf("2) ");
;    ftoa(speed,0,displ_buffer);
	CALL SUBOPT_0x4C
;    if(speed < 100)
	BRSH _0x172
;    {
;    if(speed < 10)lcd_gotoxy(2,0);
	LDI  R30,LOW(10)
	CP   R5,R30
	BRSH _0x173
	LDI  R30,LOW(2)
	RJMP _0x1C3
;    else{lcd_gotoxy(1,0);}
_0x173:
	LDI  R30,LOW(1)
_0x1C3:
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _lcd_gotoxy
;    }
;    if(speed >= 100){lcd_gotoxy(0,0);}
_0x172:
	LDI  R30,LOW(100)
	CP   R5,R30
	BRLO _0x175
	CALL SUBOPT_0x4A
;    lcd_puts(displ_buffer);
_0x175:
	CALL SUBOPT_0x4E
;    lcd_gotoxy(4,0);
	CALL SUBOPT_0x4D
;    lcd_putsf("km/h ");
	__POINTW2FN _0x0,59
	CALL _lcd_putsf
;
;
;    // 7 
;    dlit_vpr_f = dlit_vpr;
	LDS  R30,_dlit_vpr
	LDS  R31,_dlit_vpr+1
	LDS  R22,_dlit_vpr+2
	LDS  R23,_dlit_vpr+3
	CALL __CDF1U
	__PUTD1S 6
;    dlit_vpr_f=dlit_vpr_f/1000;
	__GETD2S 6
	CALL SUBOPT_0xE
	__PUTD1S 6
;
;
;
;    ftoa(dlit_vpr_f,2,displ_buffer);
	CALL SUBOPT_0x53
;    lcd_gotoxy(9,0);
	LDI  R30,LOW(9)
	CALL SUBOPT_0x54
;    lcd_puts(displ_buffer);
	CALL SUBOPT_0x4E
;    lcd_gotoxy(13,0);
	LDI  R30,LOW(13)
	CALL SUBOPT_0x54
;    lcd_putsf("ms");
	__POINTW2FN _0x0,86
	CALL _lcd_putsf
;
;    if((dlit_vpr_zamer_count < dlit_vpr_zamer/3)&&(dlit_vpr_zamer_count > 1)){lcd_gotoxy(15,0);lcd_putsf("*");}
	MOVW R26,R8
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CALL __DIVW21U
	CP   R10,R30
	CPC  R11,R31
	BRSH _0x177
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R10
	CPC  R31,R11
	BRLO _0x178
_0x177:
	RJMP _0x176
_0x178:
	LDI  R30,LOW(15)
	CALL SUBOPT_0x54
	__POINTW2FN _0x0,89
	CALL _lcd_putsf
;    lcd_gotoxy(0,1);
_0x176:
	CALL SUBOPT_0x50
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(0,1);
	CALL SUBOPT_0x50
;    lcd_putsf("mom ");
	__POINTW2FN _0x0,91
	CALL _lcd_putsf
;    ftoa(rashod_mom_l,1,displ_buffer);
	CALL SUBOPT_0x11
	CALL SUBOPT_0x51
;    lcd_puts(displ_buffer);
;    lcd_putsf(" L/100km");
	CALL SUBOPT_0x55
;    refresh_display_worked = 0;return;
	RJMP _0x20C0006
; }
;
;  if(display_number ==DISP_MAIN_3)// 3  .  .        put_total_m   vlito_total_ml       rashod_sred_l
_0x171:
	LDS  R26,_display_number
	CPI  R26,LOW(0x67)
	BREQ PC+3
	JMP _0x179
;{
;//X
;// 9999 km 999.99L
;// 99.9 L/100
;//
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    //lcd_putsf("3) ");
;    put_total_m_f = put_total_m;
	CALL SUBOPT_0x18
	CALL __CDF1U
	CALL SUBOPT_0x56
;    if(put_total_m_f < 1000){ftoa(put_total_m_f/1000,3,displ_buffer);}
	CALL SUBOPT_0x57
	CALL SUBOPT_0x58
	BRSH _0x17A
	CALL SUBOPT_0x59
	CALL SUBOPT_0x5A
;    if((put_total_m_f >= 1000)&&(put_total_m_f < 10000)){ftoa(put_total_m_f/1000,2,displ_buffer);}
_0x17A:
	CALL SUBOPT_0x57
	CALL SUBOPT_0x58
	BRLO _0x17C
	CALL SUBOPT_0x57
	CALL SUBOPT_0x5B
	BRLO _0x17D
_0x17C:
	RJMP _0x17B
_0x17D:
	CALL SUBOPT_0x59
	CALL SUBOPT_0x53
;    if((put_total_m_f >= 100000)&&(put_total_m_f < 1000000)){ftoa(put_total_m_f/1000,1,displ_buffer);}
_0x17B:
	CALL SUBOPT_0x57
	CALL SUBOPT_0x5C
	BRLO _0x17F
	CALL SUBOPT_0x5D
	BRLO _0x180
_0x17F:
	RJMP _0x17E
_0x180:
	CALL SUBOPT_0x59
	CALL SUBOPT_0x5E
;    if(put_total_m_f >= 1000000){ftoa(put_total_m_f/1000,0,displ_buffer);}
_0x17E:
	CALL SUBOPT_0x5D
	BRLO _0x181
	CALL SUBOPT_0x59
	CALL SUBOPT_0x52
;
;    ftoa(put_total_m_f/1000,2,displ_buffer);
_0x181:
	CALL SUBOPT_0x59
	CALL SUBOPT_0x53
;    lcd_puts(displ_buffer);
	CALL SUBOPT_0x4E
;    lcd_gotoxy(5,0);
	LDI  R30,LOW(5)
	CALL SUBOPT_0x54
;    lcd_putsf("km");
	__POINTW2FN _0x0,83
	CALL _lcd_putsf
;    lcd_gotoxy(10,0);
	LDI  R30,LOW(10)
	CALL SUBOPT_0x54
;    if(vlito_total_ml < 10000){ftoa(vlito_total_ml/1000,2,displ_buffer);}
	CALL SUBOPT_0x5F
	BRSH _0x182
	CALL SUBOPT_0x60
	CALL SUBOPT_0x53
;    if((vlito_total_ml > 10000)&&(vlito_total_ml < 100000)){ftoa(vlito_total_ml/1000,1,displ_buffer);}
_0x182:
	CALL SUBOPT_0x5F
	BREQ PC+2
	BRCC PC+3
	JMP  _0x184
	CALL SUBOPT_0x19
	CALL SUBOPT_0x5C
	BRLO _0x185
_0x184:
	RJMP _0x183
_0x185:
	CALL SUBOPT_0x60
	CALL SUBOPT_0x5E
;    if(vlito_total_ml >= 10000){ftoa(vlito_total_ml/1000,0,displ_buffer);}
_0x183:
	CALL SUBOPT_0x5F
	BRLO _0x186
	CALL SUBOPT_0x60
	CALL SUBOPT_0x52
;    lcd_puts(displ_buffer);
_0x186:
	CALL SUBOPT_0x4E
;    lcd_putsf("L");
	__POINTW2FN _0x0,105
	CALL SUBOPT_0x4F
;
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(0,1);
	CALL SUBOPT_0x50
;    lcd_putsf("cp ");
	__POINTW2FN _0x0,107
	CALL _lcd_putsf
;      if(rashod_sred_l == 99.9)
	LDS  R26,_rashod_sred_l
	LDS  R27,_rashod_sred_l+1
	LDS  R24,_rashod_sred_l+2
	LDS  R25,_rashod_sred_l+3
	__CPD2N 0x42C7CCCD
	BRNE _0x187
;      {
;      lcd_putsf("- - ");
	__POINTW2FN _0x0,73
	CALL _lcd_putsf
;      }
;      else
	RJMP _0x188
_0x187:
;      {
;      ftoa(rashod_sred_l,1,displ_buffer);
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x51
;      lcd_puts(displ_buffer);
;      }
_0x188:
;      lcd_putsf(" L/100km");
	CALL SUBOPT_0x55
;      refresh_display_worked = 0;return;
	RJMP _0x20C0006
;}
;
; if(display_number ==DISP_MENU)
_0x179:
	LDS  R26,_display_number
	CPI  R26,LOW(0x6E)
	BREQ PC+3
	JMP _0x189
; {
;switch (sel_item)
	LDS  R30,_sel_item
	LDS  R31,_sel_item+1
;  {
;   //X
;   //    
;   //
;   //
;    case DISP_ZAPRAVKA:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x18D
;    {
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(4,0);
	CALL SUBOPT_0x4D
;    lcd_putsf("Zapravka");
	__POINTW2FN _0x0,111
	CALL _lcd_putsf
;    }
;    refresh_display_worked = 0;break;
	RJMP _0x1C4
;    //X
;    //   
;    //   
;    //
;    case DISP_SERVIS:
_0x18D:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BRNE _0x18E
;    {
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(4,0);
	CALL SUBOPT_0x4D
;    lcd_putsf("Servisnye");
	__POINTW2FN _0x0,120
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(4,1);
	CALL SUBOPT_0x61
;    lcd_putsf("Intervaly");
	__POINTW2FN _0x0,130
	CALL _lcd_putsf
;    }
;    refresh_display_worked = 0;break;
	RJMP _0x1C4
;    //X
;    //  
;    //, 
;    //
;    case DISP_RST_COUNTERS:
_0x18E:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BRNE _0x18F
;    {
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("Sbros scetcikov");
	__POINTW2FN _0x0,140
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(0,1);
	CALL SUBOPT_0x50
;    lcd_putsf("probega, rashoda");
	__POINTW2FN _0x0,156
	CALL _lcd_putsf
;    }
;    refresh_display_worked = 0;break;
	RJMP _0x1C4
;    //X
;    // 
;    //   
;    //
;    case DISP_FORS:
_0x18F:
	CPI  R30,LOW(0xF)
	LDI  R26,HIGH(0xF)
	CPC  R31,R26
	BRNE _0x190
;    {
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("Nastroyka dannyh");
	__POINTW2FN _0x0,173
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(4,1);
	CALL SUBOPT_0x61
;    lcd_putsf("forsunok");
	__POINTW2FN _0x0,190
	CALL _lcd_putsf
;    }
;    refresh_display_worked = 0;break;
	RJMP _0x1C4
;
;    case DISP_SPEED:
_0x190:
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0x191
;    {
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(1,0);
	LDI  R30,LOW(1)
	CALL SUBOPT_0x54
;    lcd_putsf("Nastr. datcika");
	__POINTW2FN _0x0,199
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(4,1);
	CALL SUBOPT_0x61
;    lcd_putsf("skorosti");
	__POINTW2FN _0x0,214
	CALL _lcd_putsf
;    }
;    refresh_display_worked = 0;break;
	RJMP _0x1C4
;    //X
;    //   
;    //    
;    //
;    case DISP_GRM:
_0x191:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BRNE _0x192
;    {
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(2,0);
	LDI  R30,LOW(2)
	CALL SUBOPT_0x54
;    lcd_putsf("Sledyusaa");
	__POINTW2FN _0x0,223
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(2,1);
	CALL SUBOPT_0x62
;    lcd_putsf("zamena GRM");
	__POINTW2FN _0x0,233
	CALL _lcd_putsf
;    }
;    refresh_display_worked = 0;break;
	RJMP _0x1C4
;    //X
;    //   
;    //   
;    //
;    case DISP_OIL:
_0x192:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BRNE _0x193
;    {
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(2,0);
	LDI  R30,LOW(2)
	CALL SUBOPT_0x54
;    lcd_putsf("Sledyusaa");
	__POINTW2FN _0x0,223
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(1,1);
	LDI  R30,LOW(1)
	CALL SUBOPT_0x63
;    lcd_putsf("zamena masla");
	__POINTW2FN _0x0,244
	CALL _lcd_putsf
;    }
;    refresh_display_worked = 0;break;
	RJMP _0x1C4
;    //X
;    //     
;    //    
;    //
;    case DISP_DEBAG:
_0x193:
	CPI  R30,LOW(0xD2)
	LDI  R26,HIGH(0xD2)
	CPC  R31,R26
	BRNE _0x194
;    {
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(4,0);
	CALL SUBOPT_0x4D
;    lcd_putsf(" Debag");
	__POINTW2FN _0x0,257
	CALL _lcd_putsf
;    lcd_gotoxy(0,1);
	CALL SUBOPT_0x50
;    //lcd_putsf("                ");
;    //lcd_gotoxy(3,1);
;    //lcd_putsf("");
;    }
;    refresh_display_worked = 0;break;
	RJMP _0x1C4
;    //X
;    //     Reset
;    //    default
;    //
;    case RST_DEFAULT:
_0x194:
	CPI  R30,LOW(0x12)
	LDI  R26,HIGH(0x12)
	CPC  R31,R26
	BRNE _0x195
;    {
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(5,0);
	LDI  R30,LOW(5)
	CALL SUBOPT_0x54
;    lcd_putsf("Reset");
	__POINTW2FN _0x0,264
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(4,1);
	CALL SUBOPT_0x61
;    lcd_putsf("default");
	__POINTW2FN _0x0,270
	CALL _lcd_putsf
;    }
;    refresh_display_worked = 0;break;
	RJMP _0x1C4
;    case DISP_ABOUT:
_0x195:
	CPI  R30,LOW(0xC8)
	LDI  R26,HIGH(0xC8)
	CPC  R31,R26
	BRNE _0x196
;    {
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(5,0);
	LDI  R30,LOW(5)
	CALL SUBOPT_0x54
;    lcd_putsf("About");
	__POINTW2FN _0x0,278
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    }
;    refresh_display_worked = 0;break;
	RJMP _0x1C4
;    case DISP_CONTRAST:
_0x196:
	CPI  R30,LOW(0xC9)
	LDI  R26,HIGH(0xC9)
	CPC  R31,R26
	BRNE _0x197
;    {
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(3,0);
	LDI  R30,LOW(3)
	CALL SUBOPT_0x54
;    lcd_putsf("Contrast");
	__POINTW2FN _0x0,284
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    }
;    refresh_display_worked = 0;break;
	RJMP _0x1C4
;    case DISP_BRIGHTNESS:
_0x197:
	CPI  R30,LOW(0x11)
	LDI  R26,HIGH(0x11)
	CPC  R31,R26
	BRNE _0x198
;    {
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(2,0);
	LDI  R30,LOW(2)
	CALL SUBOPT_0x54
;    lcd_putsf("Brightness");
	__POINTW2FN _0x0,293
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    }
;    refresh_display_worked = 0;break;
	RJMP _0x1C4
;
;    case DISP_CLOCKS:
_0x198:
	CPI  R30,LOW(0x82)
	LDI  R26,HIGH(0x82)
	CPC  R31,R26
	BRNE _0x19A
;    {
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(2,0);
	LDI  R30,LOW(2)
	CALL SUBOPT_0x54
;    lcd_putsf(" Set clocks   ");
	__POINTW2FN _0x0,304
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    }
;    refresh_display_worked = 0;break;
;    default:refresh_display_worked = 0;break;
_0x19A:
_0x1C4:
	LDI  R30,LOW(0)
	STS  _refresh_display_worked,R30
;  };
; }
;
;  if(display_number ==DISP_ZAPRAVKA)// 5 
_0x189:
	LDS  R26,_display_number
	CPI  R26,LOW(0xA)
	BRNE _0x19B
;{
;    //X
;    //    
;    //     25.7 L
;    //
;
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(4,0);
	CALL SUBOPT_0x4D
;    lcd_putsf("Zapravka");
	__POINTW2FN _0x0,111
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(5,1);
	LDI  R30,LOW(5)
	CALL SUBOPT_0x63
;    ftoa(v_bake_plus/1000,1,displ_buffer);
	LDS  R26,_v_bake_plus
	LDS  R27,_v_bake_plus+1
	LDS  R24,_v_bake_plus+2
	LDS  R25,_v_bake_plus+3
	CALL SUBOPT_0xE
	CALL SUBOPT_0x51
;    lcd_puts(displ_buffer);
;    lcd_putsf(" L");
	__POINTW2FN _0x0,319
	CALL SUBOPT_0x64
;  refresh_display_worked = 0;return;
	RJMP _0x20C0006
; }
;
;  if(display_number ==DISP_SERVIS)// 6   
_0x19B:
	LDS  R26,_display_number
	CPI  R26,LOW(0xC)
	BRNE _0x19C
;{
;    //X
;    //  = 125000km
;    //  = 9999km
;    //
;
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(1,0);
	LDI  R30,LOW(1)
	CALL SUBOPT_0x54
;    lcd_putsf(" GRM = ");
	__POINTW2FN _0x0,322
	CALL _lcd_putsf
;    ftoa(do_zameny_grm_imp/imp_km,0,displ_buffer);
	CALL SUBOPT_0x65
;    lcd_puts(displ_buffer);
	CALL SUBOPT_0x4E
;    lcd_putsf("km");
	__POINTW2FN _0x0,83
	CALL SUBOPT_0x4F
;
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(1,1);
	LDI  R30,LOW(1)
	CALL SUBOPT_0x63
;    lcd_putsf(" maslo = ");
	__POINTW2FN _0x0,330
	CALL _lcd_putsf
;    ftoa(do_zameny_masla_imp/imp_km,0,displ_buffer);
	CALL SUBOPT_0x66
;    lcd_puts(displ_buffer);
	CALL SUBOPT_0x4E
;    lcd_putsf("km");
	__POINTW2FN _0x0,83
	CALL SUBOPT_0x64
;    refresh_display_worked = 0;return;
	RJMP _0x20C0006
; }
;
;  if(display_number ==DISP_RST_COUNTERS)// 7 Reset day`s count
_0x19C:
	LDS  R26,_display_number
	CPI  R26,LOW(0xB)
	BRNE _0x19D
;{
;    //X
;    // 
;    // <'"   '>''
;    //
;
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("Sbros scetcikov  <'No   '>'Yes'");
	__POINTW2FN _0x0,340
	CALL SUBOPT_0x64
;   refresh_display_worked = 0;return;
	RJMP _0x20C0006
; }
;
; if(display_number ==DISP_FORS)// 8  
_0x19D:
	LDS  R26,_display_number
	CPI  R26,LOW(0xF)
	BRNE _0x19E
;{
;    //X
;    // , 4
;    //  521.5 ml/min
;    //
;
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(1,0);
	LDI  R30,LOW(1)
	CALL SUBOPT_0x54
;    lcd_putsf("Forsunki");
	__POINTW2FN _0x0,372
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(2,1);
	CALL SUBOPT_0x62
;    ftoa(PrFors,1,displ_buffer);
	CALL SUBOPT_0x35
	CALL SUBOPT_0x51
;    lcd_puts(displ_buffer);
;    lcd_putsf(" ml/min");
	__POINTW2FN _0x0,381
	CALL SUBOPT_0x64
;    refresh_display_worked = 0;return;
	RJMP _0x20C0006
; }
;
;  if(display_number ==DISP_SPEED)// 9   
_0x19E:
	LDS  R26,_display_number
	CPI  R26,LOW(0x10)
	BRNE _0x19F
;{
;    //X
;    // 
;    //  5000 imp/km
;    //
;
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("Datcik skorosti ");
	__POINTW2FN _0x0,389
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(2,1);
	CALL SUBOPT_0x62
;    ftoa(imp_km,0,displ_buffer);
	CALL SUBOPT_0xB
	CALL __CDF1U
	CALL SUBOPT_0x52
;    lcd_puts(displ_buffer);
	CALL SUBOPT_0x4E
;    lcd_putsf(" imp/km");
	__POINTW2FN _0x0,406
	CALL SUBOPT_0x64
;    refresh_display_worked = 0;return;
	RJMP _0x20C0006
;}
;
;   if(display_number ==DISP_GRM)// 10 
_0x19F:
	LDS  R26,_display_number
	CPI  R26,LOW(0xE)
	BRNE _0x1A0
;{
;    //X
;    //    
;    //   120000 km
;    //
;
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(2,0);
	LDI  R30,LOW(2)
	CALL SUBOPT_0x54
;    lcd_putsf("GRM cerez");
	__POINTW2FN _0x0,414
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(2,1);
	CALL SUBOPT_0x62
;    ftoa((unsigned long int)(do_zameny_grm_imp/imp_km),0,displ_buffer);
	CALL SUBOPT_0x65
;    lcd_puts(displ_buffer);
	CALL SUBOPT_0x4E
;    lcd_putsf(" km");
	__POINTW2FN _0x0,82
	CALL SUBOPT_0x64
;    refresh_display_worked = 0;return;
	RJMP _0x20C0006
; }
;
; if(display_number ==DISP_OIL)// 11 
_0x1A0:
	LDS  R26,_display_number
	CPI  R26,LOW(0xD)
	BRNE _0x1A1
;{
;    //X
;    //   
;    //   1200 km
;    //
;
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(2,0);
	LDI  R30,LOW(2)
	CALL SUBOPT_0x54
;    lcd_putsf("maslo cerez");
	__POINTW2FN _0x0,424
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(3,1);
	LDI  R30,LOW(3)
	CALL SUBOPT_0x63
;    ftoa((unsigned long int)(do_zameny_masla_imp/imp_km),0,displ_buffer);
	CALL SUBOPT_0x66
;    lcd_puts(displ_buffer);
	CALL SUBOPT_0x4E
;    lcd_putsf(" km");
	__POINTW2FN _0x0,82
	CALL SUBOPT_0x64
;    refresh_display_worked = 0;return;
	RJMP _0x20C0006
; }
;
;   if(display_number ==DISP_DEBAG)// 12 
_0x1A1:
	LDS  R26,_display_number
	CPI  R26,LOW(0xD2)
	BRNE _0x1A2
;{
;lcd_clear();
	CALL _lcd_clear
; ftoa(debag_data1,3,displ_buffer);
	LDS  R30,_debag_data1
	LDS  R31,_debag_data1+1
	LDS  R22,_debag_data1+2
	LDS  R23,_debag_data1+3
	CALL SUBOPT_0x5A
;    lcd_puts(displ_buffer);
	CALL SUBOPT_0x4E
;    lcd_gotoxy(0,1);
	CALL SUBOPT_0x50
;    ftoa(debag_data2,3,displ_buffer);
	LDS  R30,_debag_data2
	LDS  R31,_debag_data2+1
	LDS  R22,_debag_data2+2
	LDS  R23,_debag_data2+3
	CALL SUBOPT_0x5A
;    lcd_puts(displ_buffer);
	CALL SUBOPT_0x4E
; refresh_display_worked = 0;return;
	LDI  R30,LOW(0)
	STS  _refresh_display_worked,R30
	RJMP _0x20C0006
; }
;
;   if(display_number ==RST_DEFAULT)// 13 Reset default
_0x1A2:
	LDS  R26,_display_number
	CPI  R26,LOW(0x12)
	BRNE _0x1A3
;{
;    //X
;    // Reset default?
;    // <'"   '>''
;    //
;
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("Reset default ?  <'No   '>'Yes'");
	__POINTW2FN _0x0,436
	CALL SUBOPT_0x64
;   refresh_display_worked = 0;return;
	RJMP _0x20C0006
;}
;
;    if(display_number ==DISP_ABOUT)// 14  :)
_0x1A3:
	LDS  R26,_display_number
	CPI  R26,LOW(0xC8)
	BRNE _0x1A4
;{
;   lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("vk.com/**** :)");
	__POINTW2FN _0x0,468
	CALL SUBOPT_0x64
;   refresh_display_worked = 0;return;
	RJMP _0x20C0006
;}
;
;if(display_number ==DISP_CONTRAST)// 15 
_0x1A4:
	LDS  R26,_display_number
	CPI  R26,LOW(0xC9)
	BRNE _0x1A5
;{
;refresh_display_worked = 0;display_number =DISP_MAIN_1;return;
	CALL SUBOPT_0x67
	RJMP _0x20C0006
;    //X
;    //    
;    //      255
;    //
;
;    lcd_gotoxy(0,0);
;    lcd_putsf("                ");
;    lcd_gotoxy(4,0);
;    lcd_putsf("Contrast");
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(6,1);
;   // ftoa(display_contrast,0,displ_buffer);
;    lcd_puts(displ_buffer);
;    refresh_display_worked = 0;return;
;}
;
;if(display_number ==DISP_BRIGHTNESS)//
_0x1A5:
	LDS  R26,_display_number
	CPI  R26,LOW(0x11)
	BRNE _0x1A6
;{
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("                ");
	CALL SUBOPT_0x4B
;    lcd_gotoxy(3,0);
	LDI  R30,LOW(3)
	CALL SUBOPT_0x54
;    lcd_putsf("Brightness");
	__POINTW2FN _0x0,293
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(7,1);
	LDI  R30,LOW(7)
	CALL SUBOPT_0x63
;    ftoa(display_brightness,0,displ_buffer);
	LDS  R30,_display_brightness
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL SUBOPT_0x52
;    lcd_puts(displ_buffer);
	CALL SUBOPT_0x4E
;    refresh_display_worked = 0;return;
	LDI  R30,LOW(0)
	STS  _refresh_display_worked,R30
	RJMP _0x20C0006
;}
;
;if(display_number ==DISP_CLIMAT)//
_0x1A6:
	LDS  R26,_display_number
	CPI  R26,LOW(0x96)
	BRNE _0x1A7
;{
;refresh_display_worked = 0;display_number =DISP_MAIN_1;return;
	CALL SUBOPT_0x67
	RJMP _0x20C0006
;    lcd_gotoxy(0,0);
;    lcd_putsf("                ");
;    lcd_gotoxy(0,0);
;    lcd_putsf("ust ");
;    ftoa(temp_set,0,displ_buffer);
;    lcd_puts(displ_buffer);
;    lcd_gotoxy(7,0);
;    lcd_putsf("real ");
;    ftoa(temp_real,1,displ_buffer);
;    lcd_puts(displ_buffer);
;
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    lcd_gotoxy(3,1);
;    ftoa(clima_step,0,displ_buffer);
;    lcd_puts(displ_buffer);
;    lcd_putsf(" step");
;    refresh_display_worked = 0;return;
;}
;
;
;if(display_number ==DISP_SAVING)// message
_0x1A7:
	LDS  R26,_display_number
	CPI  R26,LOW(0xCA)
	BRNE _0x1A8
;{
;    //X
;    //  Saving data
;    //
;    //
;
;    lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;    lcd_putsf("  Saving data   ");
	__POINTW2FN _0x0,500
	CALL SUBOPT_0x4F
;    lcd_gotoxy(0,1);
;    lcd_putsf("                ");
;    refresh_display_worked = 0;return;
	LDI  R30,LOW(0)
	STS  _refresh_display_worked,R30
	RJMP _0x20C0006
;}
;
;
;if(display_number ==DISP_CLOCKS)//
_0x1A8:
	LDS  R26,_display_number
	CPI  R26,LOW(0x82)
	BRNE _0x1A9
;{
;//X
;//D<  12:01:55
;// 65.7 L = 255 
;//
;  lcd_gotoxy(0,0);
	CALL SUBOPT_0x4A
;  lcd_putsf("                ");
	CALL SUBOPT_0x4B
;  lcd_gotoxy(4,0);
	CALL SUBOPT_0x4D
;
;  //if(chas < 10){lcd_putsf(" ");}
; // ftoa(chas,0,displ_buffer);
;  lcd_puts(displ_buffer);
	CALL SUBOPT_0x4E
;  lcd_putsf(":");
	CALL SUBOPT_0x69
;
; // if(minut < 10){lcd_putsf("0");}
; // ftoa(minut,0,displ_buffer);
;  lcd_puts(displ_buffer);
;  lcd_putsf(":");
	CALL SUBOPT_0x69
;//  if(sek < 10){lcd_putsf("0");}
;//  ftoa(sek,0,displ_buffer);
;  lcd_puts(displ_buffer);
;
;    refresh_display_worked = 0;return;
	LDI  R30,LOW(0)
	STS  _refresh_display_worked,R30
;}
;
;
;
;
;
;
;
;//  ftoa(PrFors/100,1,displ_buffer);
;//  itoa(PrFors/1000,Displ_Print);
;}
_0x1A9:
_0x20C0006:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,10
	RET
;
;
;
;/*****************************************************
;
;debag_data1 =;
;debag_data2 =;
;
;
;*****************************************************/
;
;
;void main_cykl(void){while(1){
; 0000 0011 void main_cykl(void){while(1){
_main_cykl:
_0x1AA:
; 0000 0012 
; 0000 0013  if(LEG_IGNITION)// ,   ,  -  
	SBIS 0x10,4
	RJMP _0x1AD
; 0000 0014   {
; 0000 0015    temp_data_saved =0;
	CLT
	BLD  R2,0
; 0000 0016    eeprom_power_on_flag = 1;
	CALL SUBOPT_0x4
; 0000 0017    calc_mom_rashod();
	CALL _calc_mom_rashod
; 0000 0018 
; 0000 0019 
; 0000 001A 
; 0000 001B    calc_dlit_vpr();
	CALL _calc_dlit_vpr
; 0000 001C 
; 0000 001D   }
; 0000 001E   else
	RJMP _0x1AE
_0x1AD:
; 0000 001F   {
; 0000 0020 //  #asm
; 0000 0021 //   JMP 0x0000;
; 0000 0022 //#endasm
; 0000 0023 
; 0000 0024     if(!temp_data_saved) { save_temp_data();eeprom_power_on_flag = 0;}
	SBRC R2,0
	RJMP _0x1AF
	CALL _save_temp_data
	LDI  R26,LOW(_eeprom_power_on_flag)
	LDI  R27,HIGH(_eeprom_power_on_flag)
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
; 0000 0025     dlit_vpr =0;
_0x1AF:
	LDI  R30,LOW(0)
	STS  _dlit_vpr,R30
	STS  _dlit_vpr+1,R30
	STS  _dlit_vpr+2,R30
	STS  _dlit_vpr+3,R30
; 0000 0026     rashod_mom_l = 0;
	STS  _rashod_mom_l,R30
	STS  _rashod_mom_l+1,R30
	STS  _rashod_mom_l+2,R30
	STS  _rashod_mom_l+3,R30
; 0000 0027      display_number=DISP_MAIN_1;
	LDI  R30,LOW(101)
	STS  _display_number,R30
; 0000 0028   }
_0x1AE:
; 0000 0029  kb();  //    -  
	CALL _kb
; 0000 002A  if(flag_calculate_data){calculate_data();}
	LDS  R30,_flag_calculate_data
	CPI  R30,0
	BREQ _0x1B0
	CALL _calculate_data
; 0000 002B  if(flag_refresh_display){refresh_display();}
_0x1B0:
	LDS  R30,_flag_refresh_display
	CPI  R30,0
	BREQ _0x1B1
	RCALL _refresh_display
; 0000 002C  if(flag_measure_speed == 0){flag_measure_speed =1;} //  
_0x1B1:
	TST  R4
	BRNE _0x1B2
	LDI  R30,LOW(1)
	MOV  R4,R30
; 0000 002D  enable_drl(); //   
_0x1B2:
	CALL _enable_drl
; 0000 002E  light_display();
	CALL _light_display
; 0000 002F 
; 0000 0030 }}//   
	RJMP _0x1AA
;
;
;
;
;//     .       255
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 0037 {
_timer2_ovf_isr:
	CALL SUBOPT_0x1
; 0000 0038 if(!LEG_IGNITION){return;} // ,   :)
	SBIS 0x10,4
	RJMP _0x1C6
; 0000 0039 //debag_data1 = overflov_count_fors_mks;
; 0000 003A overflov_count_fors_mks++;
	LDI  R26,LOW(_overflov_count_fors_mks)
	LDI  R27,HIGH(_overflov_count_fors_mks)
	CALL SUBOPT_0x0
; 0000 003B //overflov_count_fors_mks = overflov_count_fors_mks + 1;  //255 
; 0000 003C 
; 0000 003D }
_0x1C6:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;
; //   
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 0041 {
_ext_int0_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0042  float vlito_tek_ml;
; 0000 0043  unsigned long int current_time_vprysk =0;
; 0000 0044  if(!LEG_IGNITION){TCCR2=0x00;return;}   //  , ......    ,     ...  :)
	SBIW R28,8
	CALL SUBOPT_0x6A
	LDI  R30,LOW(0)
	STD  Y+3,R30
;	vlito_tek_ml -> Y+4
;	current_time_vprysk -> Y+0
	SBIC 0x10,4
	RJMP _0x1B4
	LDI  R30,LOW(0)
	OUT  0x25,R30
	RJMP _0x1C5
; 0000 0045    if ( PIND.2 ) //    ,  ,  
_0x1B4:
	SBIS 0x10,2
	RJMP _0x1B5
; 0000 0046     {
; 0000 0047 
; 0000 0048         temp_data_saved =0;
	CLT
	BLD  R2,0
; 0000 0049         TCCR2=0x00; //   
	LDI  R30,LOW(0)
	OUT  0x25,R30
; 0000 004A         // 
; 0000 004B         current_time_vprysk = (unsigned long int)(overflov_count_fors_mks*255)+TCNT2;
	LDS  R30,_overflov_count_fors_mks
	LDS  R31,_overflov_count_fors_mks+1
	LDS  R22,_overflov_count_fors_mks+2
	LDS  R23,_overflov_count_fors_mks+3
	__GETD2N 0xFF
	CALL __MULD12U
	MOVW R26,R30
	MOVW R24,R22
	IN   R30,0x24
	LDI  R31,0
	CALL __CWD1
	CALL __ADDD12
	CALL __PUTD1S0
; 0000 004C 
; 0000 004D         //915.5413138; // vlito_total_ml 60      60 000 000 / i  .         -
; 0000 004E         if(current_time_vprysk)
	CALL SUBOPT_0x10
	CALL __CPD10
	BRNE PC+3
	JMP _0x1B6
; 0000 004F         {
; 0000 0050         vlito_tek_ml = PrFors/(60000000/current_time_vprysk);
	CALL SUBOPT_0x10
	__GETD2N 0x3938700
	CALL __DIVD21U
	LDS  R26,_PrFors
	LDS  R27,_PrFors+1
	LDS  R24,_PrFors+2
	LDS  R25,_PrFors+3
	CALL SUBOPT_0xC
	__PUTD1S 4
; 0000 0051         if(!dlit_vpr_ready)
	TST  R7
	BRNE _0x1B7
; 0000 0052         {
; 0000 0053         revs_count_dl_vpr++;
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
; 0000 0054         count_dlit_vpr_mks = count_dlit_vpr_mks + current_time_vprysk;
	CALL SUBOPT_0x10
	CALL SUBOPT_0x15
	CALL __ADDD12
	STS  _count_dlit_vpr_mks,R30
	STS  _count_dlit_vpr_mks+1,R31
	STS  _count_dlit_vpr_mks+2,R22
	STS  _count_dlit_vpr_mks+3,R23
; 0000 0055         }
; 0000 0056         vlito_total_ml = vlito_total_ml + vlito_tek_ml;
_0x1B7:
	__GETD1S 4
	CALL SUBOPT_0x19
	CALL __ADDF12
	STS  _vlito_total_ml,R30
	STS  _vlito_total_ml+1,R31
	STS  _vlito_total_ml+2,R22
	STS  _vlito_total_ml+3,R23
; 0000 0057         v_bake = v_bake - vlito_tek_ml;
	__GETD2S 4
	CALL SUBOPT_0x20
	CALL __SUBF12
	CALL SUBOPT_0x2F
; 0000 0058         }
; 0000 0059         overflov_count_fors_mks =0;
_0x1B6:
	LDI  R30,LOW(0)
	STS  _overflov_count_fors_mks,R30
	STS  _overflov_count_fors_mks+1,R30
	STS  _overflov_count_fors_mks+2,R30
	STS  _overflov_count_fors_mks+3,R30
; 0000 005A         TCNT2 =0;
	OUT  0x24,R30
; 0000 005B 
; 0000 005C 
; 0000 005D 
; 0000 005E 
; 0000 005F 
; 0000 0060     }
; 0000 0061     else   //   ,  ,   
	RJMP _0x1B8
_0x1B5:
; 0000 0062     {
; 0000 0063         if(LEG_IGNITION)  //     .  :)
	SBIS 0x10,4
	RJMP _0x1B9
; 0000 0064         {
; 0000 0065          TCNT2 =0;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 0066          TCCR2=0x02; //   
	LDI  R30,LOW(2)
	OUT  0x25,R30
; 0000 0067         }
; 0000 0068     }
_0x1B9:
_0x1B8:
; 0000 0069 }
_0x1C5:
	ADIW R28,8
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;

	.CSEG
_ftoa:
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,4
	CALL SUBOPT_0x6A
	LDI  R30,LOW(63)
	STD  Y+3,R30
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x200000D
	CALL SUBOPT_0x6B
	__POINTW2FN _0x2000000,0
	CALL _strcpyf
	RJMP _0x20C0005
_0x200000D:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x200000C
	CALL SUBOPT_0x6B
	__POINTW2FN _0x2000000,1
	CALL _strcpyf
	RJMP _0x20C0005
_0x200000C:
	LDD  R26,Y+12
	TST  R26
	BRPL _0x200000F
	__GETD1S 9
	CALL __ANEGF1
	CALL SUBOPT_0x6C
	CALL SUBOPT_0x6D
	LDI  R30,LOW(45)
	ST   X,R30
_0x200000F:
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRLO _0x2000010
	LDI  R30,LOW(6)
	STD  Y+8,R30
_0x2000010:
	LDD  R17,Y+8
_0x2000011:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x2000013
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x56
	RJMP _0x2000011
_0x2000013:
	CALL SUBOPT_0x6F
	CALL __ADDF12
	CALL SUBOPT_0x6C
	LDI  R17,LOW(0)
	__GETD1N 0x3F800000
	CALL SUBOPT_0x56
_0x2000014:
	CALL SUBOPT_0x6F
	CALL __CMPF12
	BRLO _0x2000016
	CALL SUBOPT_0x57
	CALL SUBOPT_0x1C
	CALL __MULF12
	CALL SUBOPT_0x56
	SUBI R17,-LOW(1)
	CPI  R17,39
	BRLO _0x2000017
	CALL SUBOPT_0x6B
	__POINTW2FN _0x2000000,5
	CALL _strcpyf
	RJMP _0x20C0005
_0x2000017:
	RJMP _0x2000014
_0x2000016:
	CPI  R17,0
	BRNE _0x2000018
	CALL SUBOPT_0x6D
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x2000019
_0x2000018:
_0x200001A:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x200001C
	CALL SUBOPT_0x6E
	__GETD2N 0x3F000000
	CALL __ADDF12
	MOVW R26,R30
	MOVW R24,R22
	CALL _floor
	CALL SUBOPT_0x56
	CALL SUBOPT_0x6F
	CALL __DIVF21
	CALL __CFD1U
	MOV  R16,R30
	CALL SUBOPT_0x6D
	CALL SUBOPT_0x70
	CALL SUBOPT_0x57
	CALL SUBOPT_0x68
	CALL __MULF12
	CALL SUBOPT_0x71
	CALL SUBOPT_0x72
	RJMP _0x200001A
_0x200001C:
_0x2000019:
	LDD  R30,Y+8
	CPI  R30,0
	BREQ _0x20C0004
	CALL SUBOPT_0x6D
	LDI  R30,LOW(46)
	ST   X,R30
_0x200001E:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x2000020
	CALL SUBOPT_0x71
	CALL SUBOPT_0x1C
	CALL __MULF12
	CALL SUBOPT_0x6C
	__GETD1S 9
	CALL __CFD1U
	MOV  R16,R30
	CALL SUBOPT_0x6D
	CALL SUBOPT_0x70
	CALL SUBOPT_0x71
	CALL SUBOPT_0x68
	CALL SUBOPT_0x72
	RJMP _0x200001E
_0x2000020:
_0x20C0004:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20C0005:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,13
	RET

	.DSEG

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G102:
	ST   -Y,R26
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2040004
	SBI  0x1B,3
	RJMP _0x2040005
_0x2040004:
	CBI  0x1B,3
_0x2040005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2040006
	SBI  0x1B,2
	RJMP _0x2040007
_0x2040006:
	CBI  0x1B,2
_0x2040007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2040008
	SBI  0x1B,1
	RJMP _0x2040009
_0x2040008:
	CBI  0x1B,1
_0x2040009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x204000A
	SBI  0x1B,0
	RJMP _0x204000B
_0x204000A:
	CBI  0x1B,0
_0x204000B:
	__DELAY_USB 5
	SBI  0x1B,4
	__DELAY_USB 13
	CBI  0x1B,4
	__DELAY_USB 13
	RJMP _0x20C0002
__lcd_write_data:
	ST   -Y,R26
	LD   R26,Y
	RCALL __lcd_write_nibble_G102
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R26,Y
	RCALL __lcd_write_nibble_G102
	__DELAY_USB 133
	RJMP _0x20C0002
_lcd_gotoxy:
	ST   -Y,R26
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G102)
	SBCI R31,HIGH(-__base_y_G102)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R26,R30
	RCALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R26,LOW(2)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	CALL SUBOPT_0x5
	LDI  R26,LOW(12)
	RCALL __lcd_write_data
	LDI  R26,LOW(1)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	CALL SUBOPT_0x5
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
	ST   -Y,R26
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2040011
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2040010
_0x2040011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R26,__lcd_y
	SUBI R26,-LOW(1)
	STS  __lcd_y,R26
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2040013
	RJMP _0x20C0002
_0x2040013:
_0x2040010:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	SBI  0x1B,6
	LD   R26,Y
	RCALL __lcd_write_data
	CBI  0x1B,6
	RJMP _0x20C0002
_lcd_puts:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2040014:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2040016
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2040014
_0x2040016:
	RJMP _0x20C0003
_lcd_putsf:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2040017:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2040019
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2040017
_0x2040019:
_0x20C0003:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_lcd_init:
	ST   -Y,R26
	SBI  0x1A,3
	SBI  0x1A,2
	SBI  0x1A,1
	SBI  0x1A,0
	SBI  0x1A,4
	SBI  0x1A,6
	SBI  0x1A,5
	CBI  0x1B,4
	CBI  0x1B,6
	CBI  0x1B,5
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G102,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G102,3
	LDI  R26,LOW(20)
	CALL SUBOPT_0x5
	CALL SUBOPT_0x73
	CALL SUBOPT_0x73
	CALL SUBOPT_0x73
	LDI  R26,LOW(32)
	RCALL __lcd_write_nibble_G102
	__DELAY_USW 200
	LDI  R26,LOW(40)
	RCALL __lcd_write_data
	LDI  R26,LOW(4)
	RCALL __lcd_write_data
	LDI  R26,LOW(133)
	RCALL __lcd_write_data
	LDI  R26,LOW(6)
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x20C0002:
	ADIW R28,1
	RET

	.CSEG

	.CSEG
_ftrunc:
	CALL __PUTPARD2
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
_floor:
	CALL __PUTPARD2
	CALL __GETD2S0
	CALL _ftrunc
	CALL __PUTD1S0
    brne __floor1
__floor0:
	CALL SUBOPT_0x10
	RJMP _0x20C0001
__floor1:
    brtc __floor0
	CALL SUBOPT_0x10
	__GETD2N 0x3F800000
	CALL __SUBF12
_0x20C0001:
	ADIW R28,4
	RET

	.CSEG
_strcpyf:
	ST   -Y,R27
	ST   -Y,R26
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpyf0:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcpyf0
    movw r30,r24
    ret

	.ESEG
_eeprom_display_brightness:
	.DB  0x5
_eeprom_v_bake:
	.BYTE 0x4
_eeprom_imp_km:
	.BYTE 0x2
_eeprom_PrFors:
	.BYTE 0x4
_eeprom_do_zameny_grm_imp:
	.BYTE 0x4
_eeprom_do_zameny_masla_imp:
	.BYTE 0x4
_eeprom_vlito_total_ml:
	.BYTE 0x4
_eeprom_put_total_imp:
	.BYTE 0x4
_eeprom_power_on_flag:
	.BYTE 0x1
_eeprom_hardreset_count:
	.BYTE 0x4

	.DSEG
_chasiki:
	.BYTE 0x4
_PrFors:
	.BYTE 0x4
_imp_km:
	.BYTE 0x4
_overflov_count_fors_mks:
	.BYTE 0x4
_put_total_imp:
	.BYTE 0x4
_put_total_m:
	.BYTE 0x4
_vlito_total_ml:
	.BYTE 0x4
_rashod_sred_l:
	.BYTE 0x4
_v_bake:
	.BYTE 0x4
_rashod_mom_l:
	.BYTE 0x4
_calc_mom_rashod_count:
	.BYTE 0x4
_put_start_imp_mom_rash:
	.BYTE 0x4
_vlito_start_mom_rash:
	.BYTE 0x4
_speed_counter:
	.BYTE 0x4
_dlit_vpr:
	.BYTE 0x4
_count_dlit_vpr_mks:
	.BYTE 0x4
_do_zameny_grm_imp:
	.BYTE 0x4
_do_zameny_masla_imp:
	.BYTE 0x4
_ost_km:
	.BYTE 0x4
_sred_ost_km:
	.BYTE 0x4
_adc_data:
	.BYTE 0x4
_v_bake_plus:
	.BYTE 0x4
_displ_buffer:
	.BYTE 0x10
_display_brightness:
	.BYTE 0x1
_old_display_number:
	.BYTE 0x1
_sel_item:
	.BYTE 0x2
_refresh_lcd_count:
	.BYTE 0x1
_flag_refresh_display:
	.BYTE 0x1
_flag_calculate_data:
	.BYTE 0x1
_display_number:
	.BYTE 0x1
_refresh_display_worked:
	.BYTE 0x1
_flag_calculate_data_worked:
	.BYTE 0x1
_debag_data1:
	.BYTE 0x4
_debag_data2:
	.BYTE 0x4
_temp_set:
	.BYTE 0x4
_temp_real:
	.BYTE 0x4
_clima_step:
	.BYTE 0x2
__seed_G100:
	.BYTE 0x4
__base_y_G102:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x0:
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2:
	CALL __GETD1P_INC
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	CALL __PUTDP1_DEC
	__SUBD1N -1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x3:
	__GETD1N 0x0
	CALL __EEPROMWRD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4:
	LDI  R26,LOW(_eeprom_power_on_flag)
	LDI  R27,HIGH(_eeprom_power_on_flag)
	LDI  R30,LOW(1)
	CALL __EEPROMWRB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 36 TIMES, CODE SIZE REDUCTION:102 WORDS
SUBOPT_0x5:
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(0)
	STS  _sred_ost_km,R30
	STS  _sred_ost_km+1,R30
	STS  _sred_ost_km+2,R30
	STS  _sred_ost_km+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x7:
	LDI  R26,LOW(_eeprom_PrFors)
	LDI  R27,HIGH(_eeprom_PrFors)
	CALL __EEPROMRDD
	STS  _PrFors,R30
	STS  _PrFors+1,R31
	STS  _PrFors+2,R22
	STS  _PrFors+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x8:
	LDI  R26,LOW(_eeprom_imp_km)
	LDI  R27,HIGH(_eeprom_imp_km)
	CALL __EEPROMRDW
	CLR  R22
	CLR  R23
	STS  _imp_km,R30
	STS  _imp_km+1,R31
	STS  _imp_km+2,R22
	STS  _imp_km+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 45 TIMES, CODE SIZE REDUCTION:85 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(0)
	STS  _refresh_lcd_count,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0xA:
	LDS  R30,_put_total_imp
	LDS  R31,_put_total_imp+1
	LDS  R22,_put_total_imp+2
	LDS  R23,_put_total_imp+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 25 TIMES, CODE SIZE REDUCTION:141 WORDS
SUBOPT_0xB:
	LDS  R30,_imp_km
	LDS  R31,_imp_km+1
	LDS  R22,_imp_km+2
	LDS  R23,_imp_km+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	CALL __CDF1U
	CALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xD:
	LDS  R30,_vlito_total_ml
	LDS  R31,_vlito_total_ml+1
	LDS  R22,_vlito_total_ml+2
	LDS  R23,_vlito_total_ml+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:41 WORDS
SUBOPT_0xE:
	__GETD1N 0x447A0000
	CALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	__GETD2N 0x42C80000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x10:
	CALL __GETD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x11:
	LDS  R30,_rashod_mom_l
	LDS  R31,_rashod_mom_l+1
	LDS  R22,_rashod_mom_l+2
	LDS  R23,_rashod_mom_l+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x12:
	CALL __GETD2S0
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x13:
	STS  _rashod_mom_l,R30
	STS  _rashod_mom_l+1,R31
	STS  _rashod_mom_l+2,R22
	STS  _rashod_mom_l+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	__GETD1N 0x42C7CCCD
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x15:
	LDS  R26,_count_dlit_vpr_mks
	LDS  R27,_count_dlit_vpr_mks+1
	LDS  R24,_count_dlit_vpr_mks+2
	LDS  R25,_count_dlit_vpr_mks+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x16:
	LDS  R26,_put_total_imp
	LDS  R27,_put_total_imp+1
	LDS  R24,_put_total_imp+2
	LDS  R25,_put_total_imp+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x17:
	__GETD2N 0x3E8
	CALL __MULD12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x18:
	LDS  R30,_put_total_m
	LDS  R31,_put_total_m+1
	LDS  R22,_put_total_m+2
	LDS  R23,_put_total_m+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x19:
	LDS  R26,_vlito_total_ml
	LDS  R27,_vlito_total_ml+1
	LDS  R24,_vlito_total_ml+2
	LDS  R25,_vlito_total_ml+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1A:
	LDS  R30,_rashod_sred_l
	LDS  R31,_rashod_sred_l+1
	LDS  R22,_rashod_sred_l+2
	LDS  R23,_rashod_sred_l+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1B:
	LDS  R26,_v_bake
	LDS  R27,_v_bake+1
	LDS  R24,_v_bake+2
	LDS  R25,_v_bake+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	__GETD1N 0x41200000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x1D:
	LDS  R30,_ost_km
	LDS  R31,_ost_km+1
	LDS  R22,_ost_km+2
	LDS  R23,_ost_km+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x1E:
	RCALL SUBOPT_0x10
	STS  _ost_km,R30
	STS  _ost_km+1,R31
	STS  _ost_km+2,R22
	STS  _ost_km+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1F:
	LDS  R26,_sred_ost_km
	LDS  R27,_sred_ost_km+1
	LDS  R24,_sred_ost_km+2
	LDS  R25,_sred_ost_km+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x20:
	LDS  R30,_v_bake
	LDS  R31,_v_bake+1
	LDS  R22,_v_bake+2
	LDS  R23,_v_bake+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x21:
	LDS  R30,_do_zameny_grm_imp
	LDS  R31,_do_zameny_grm_imp+1
	LDS  R22,_do_zameny_grm_imp+2
	LDS  R23,_do_zameny_grm_imp+3
	LDI  R26,LOW(_eeprom_do_zameny_grm_imp)
	LDI  R27,HIGH(_eeprom_do_zameny_grm_imp)
	CALL __EEPROMWRD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x22:
	LDS  R30,_do_zameny_masla_imp
	LDS  R31,_do_zameny_masla_imp+1
	LDS  R22,_do_zameny_masla_imp+2
	LDS  R23,_do_zameny_masla_imp+3
	LDI  R26,LOW(_eeprom_do_zameny_masla_imp)
	LDI  R27,HIGH(_eeprom_do_zameny_masla_imp)
	CALL __EEPROMWRD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x23:
	LDI  R26,LOW(_eeprom_do_zameny_grm_imp)
	LDI  R27,HIGH(_eeprom_do_zameny_grm_imp)
	CALL __EEPROMRDD
	STS  _do_zameny_grm_imp,R30
	STS  _do_zameny_grm_imp+1,R31
	STS  _do_zameny_grm_imp+2,R22
	STS  _do_zameny_grm_imp+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x24:
	LDI  R26,LOW(_eeprom_do_zameny_masla_imp)
	LDI  R27,HIGH(_eeprom_do_zameny_masla_imp)
	CALL __EEPROMRDD
	STS  _do_zameny_masla_imp,R30
	STS  _do_zameny_masla_imp+1,R31
	STS  _do_zameny_masla_imp+2,R22
	STS  _do_zameny_masla_imp+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 25 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x25:
	STS  _display_number,R30
	JMP  _refresh_display

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	STS  _sel_item,R30
	STS  _sel_item+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x27:
	STS  _old_display_number,R30
	LDI  R26,LOW(_sel_item)
	LDI  R27,HIGH(_sel_item)
	LD   R30,X+
	LD   R31,X+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x28:
	ST   -X,R31
	ST   -X,R30
	LDS  R26,_sel_item
	LDS  R27,_sel_item+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x29:
	STS  _old_display_number,R30
	LDS  R30,_v_bake_plus
	LDS  R31,_v_bake_plus+1
	LDS  R22,_v_bake_plus+2
	LDS  R23,_v_bake_plus+3
	__GETD2N 0x42C80000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x2A:
	CALL __ADDF12
	STS  _v_bake_plus,R30
	STS  _v_bake_plus+1,R31
	STS  _v_bake_plus+2,R22
	STS  _v_bake_plus+3,R23
	JMP  _refresh_display

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2B:
	LDS  R30,_v_bake_plus
	LDS  R31,_v_bake_plus+1
	LDS  R22,_v_bake_plus+2
	LDS  R23,_v_bake_plus+3
	__GETD2N 0x447A0000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2C:
	CALL __SUBF12
	STS  _v_bake_plus,R30
	STS  _v_bake_plus+1,R31
	STS  _v_bake_plus+2,R22
	STS  _v_bake_plus+3,R23
	JMP  _refresh_display

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2D:
	LDS  R30,_v_bake_plus
	LDS  R31,_v_bake_plus+1
	LDS  R22,_v_bake_plus+2
	LDS  R23,_v_bake_plus+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:36 WORDS
SUBOPT_0x2E:
	STS  _old_display_number,R30
	LDI  R30,LOW(110)
	RJMP SUBOPT_0x25

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2F:
	STS  _v_bake,R30
	STS  _v_bake+1,R31
	STS  _v_bake+2,R22
	STS  _v_bake+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x30:
	STS  _old_display_number,R30
	LDS  R30,_PrFors
	LDS  R31,_PrFors+1
	LDS  R22,_PrFors+2
	LDS  R23,_PrFors+3
	__GETD2N 0x3DCCCCCD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x31:
	CALL __ADDF12
	STS  _PrFors,R30
	STS  _PrFors+1,R31
	STS  _PrFors+2,R22
	STS  _PrFors+3,R23
	JMP  _refresh_display

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x32:
	LDS  R30,_PrFors
	LDS  R31,_PrFors+1
	LDS  R22,_PrFors+2
	LDS  R23,_PrFors+3
	__GETD2N 0x3F800000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x33:
	CALL __SUBF12
	STS  _PrFors,R30
	STS  _PrFors+1,R31
	STS  _PrFors+2,R22
	STS  _PrFors+3,R23
	JMP  _refresh_display

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x34:
	STS  _old_display_number,R30
	LDI  R30,LOW(110)
	STS  _display_number,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	LDS  R30,_PrFors
	LDS  R31,_PrFors+1
	LDS  R22,_PrFors+2
	LDS  R23,_PrFors+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x36:
	STS  _old_display_number,R30
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x37:
	STS  _imp_km,R30
	STS  _imp_km+1,R31
	STS  _imp_km+2,R22
	STS  _imp_km+3,R23
	JMP  _refresh_display

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x38:
	LDS  R26,_do_zameny_grm_imp
	LDS  R27,_do_zameny_grm_imp+1
	LDS  R24,_do_zameny_grm_imp+2
	LDS  R25,_do_zameny_grm_imp+3
	CALL __ADDD12
	STS  _do_zameny_grm_imp,R30
	STS  _do_zameny_grm_imp+1,R31
	STS  _do_zameny_grm_imp+2,R22
	STS  _do_zameny_grm_imp+3,R23
	JMP  _refresh_display

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x39:
	__GETD2N 0x64
	CALL __MULD12U
	LDS  R26,_do_zameny_grm_imp
	LDS  R27,_do_zameny_grm_imp+1
	LDS  R24,_do_zameny_grm_imp+2
	LDS  R25,_do_zameny_grm_imp+3
	CALL __SUBD21
	STS  _do_zameny_grm_imp,R26
	STS  _do_zameny_grm_imp+1,R27
	STS  _do_zameny_grm_imp+2,R24
	STS  _do_zameny_grm_imp+3,R25
	JMP  _refresh_display

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x3A:
	__GETD2N 0x64
	CALL __MULD12U
	LDS  R26,_do_zameny_masla_imp
	LDS  R27,_do_zameny_masla_imp+1
	LDS  R24,_do_zameny_masla_imp+2
	LDS  R25,_do_zameny_masla_imp+3
	CALL __ADDD12
	STS  _do_zameny_masla_imp,R30
	STS  _do_zameny_masla_imp+1,R31
	STS  _do_zameny_masla_imp+2,R22
	STS  _do_zameny_masla_imp+3,R23
	JMP  _refresh_display

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x3B:
	__GETD2N 0xA
	CALL __MULD12U
	LDS  R26,_do_zameny_masla_imp
	LDS  R27,_do_zameny_masla_imp+1
	LDS  R24,_do_zameny_masla_imp+2
	LDS  R25,_do_zameny_masla_imp+3
	CALL __SUBD21
	STS  _do_zameny_masla_imp,R26
	STS  _do_zameny_masla_imp+1,R27
	STS  _do_zameny_masla_imp+2,R24
	STS  _do_zameny_masla_imp+3,R25
	JMP  _refresh_display

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x3C:
	CALL _refresh_display
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3D:
	CALL _refresh_display
	LDI  R26,LOW(250)
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3E:
	LDS  R30,_display_brightness
	SUBI R30,-LOW(1)
	STS  _display_brightness,R30
	LDS  R26,_display_brightness
	CPI  R26,LOW(0xB)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3F:
	LDS  R30,_display_brightness
	SUBI R30,LOW(1)
	STS  _display_brightness,R30
	LDS  R26,_display_brightness
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x40:
	STS  _old_display_number,R30
	LDI  R26,LOW(_clima_step)
	LDI  R27,HIGH(_clima_step)
	LD   R30,X+
	LD   R31,X+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x41:
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	LDS  R26,_clima_step
	LDS  R27,_clima_step+1
	CPI  R26,LOW(0x65)
	LDI  R30,HIGH(0x65)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x42:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	STS  _clima_step,R30
	STS  _clima_step+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x43:
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
	LDS  R26,_clima_step
	LDS  R27,_clima_step+1
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x44:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _clima_step,R30
	STS  _clima_step+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x45:
	STS  _old_display_number,R30
	LDS  R30,_chasiki
	LDS  R31,_chasiki+1
	LDS  R22,_chasiki+2
	LDS  R23,_chasiki+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x46:
	__ADDD1N 3600
	STS  _chasiki,R30
	STS  _chasiki+1,R31
	STS  _chasiki+2,R22
	STS  _chasiki+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x47:
	LDS  R30,_chasiki
	LDS  R31,_chasiki+1
	LDS  R22,_chasiki+2
	LDS  R23,_chasiki+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x48:
	__SUBD1N 3600
	STS  _chasiki,R30
	STS  _chasiki+1,R31
	STS  _chasiki+2,R22
	STS  _chasiki+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x49:
	__ADDD1N 60
	STS  _chasiki,R30
	STS  _chasiki+1,R31
	STS  _chasiki+2,R22
	STS  _chasiki+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 36 TIMES, CODE SIZE REDUCTION:102 WORDS
SUBOPT_0x4A:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 49 TIMES, CODE SIZE REDUCTION:93 WORDS
SUBOPT_0x4B:
	__POINTW2FN _0x0,38
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x4C:
	MOV  R30,R5
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __PUTPARD1
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(_displ_buffer)
	LDI  R27,HIGH(_displ_buffer)
	CALL _ftoa
	LDI  R30,LOW(100)
	CP   R5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x4D:
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 26 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x4E:
	LDI  R26,LOW(_displ_buffer)
	LDI  R27,HIGH(_displ_buffer)
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 22 TIMES, CODE SIZE REDUCTION:144 WORDS
SUBOPT_0x4F:
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	RJMP SUBOPT_0x4B

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x50:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x51:
	CALL __PUTPARD1
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R26,LOW(_displ_buffer)
	LDI  R27,HIGH(_displ_buffer)
	CALL _ftoa
	RJMP SUBOPT_0x4E

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:57 WORDS
SUBOPT_0x52:
	CALL __PUTPARD1
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(_displ_buffer)
	LDI  R27,HIGH(_displ_buffer)
	JMP  _ftoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x53:
	CALL __PUTPARD1
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R26,LOW(_displ_buffer)
	LDI  R27,HIGH(_displ_buffer)
	JMP  _ftoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x54:
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x55:
	__POINTW2FN _0x0,96
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	STS  _refresh_display_worked,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x56:
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x57:
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x58:
	__GETD1N 0x447A0000
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x59:
	RCALL SUBOPT_0x57
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x5A:
	CALL __PUTPARD1
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R26,LOW(_displ_buffer)
	LDI  R27,HIGH(_displ_buffer)
	JMP  _ftoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x5B:
	__GETD1N 0x461C4000
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5C:
	__GETD1N 0x47C35000
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5D:
	RCALL SUBOPT_0x57
	__GETD1N 0x49742400
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5E:
	CALL __PUTPARD1
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R26,LOW(_displ_buffer)
	LDI  R27,HIGH(_displ_buffer)
	JMP  _ftoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5F:
	RCALL SUBOPT_0x19
	RJMP SUBOPT_0x5B

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x60:
	RCALL SUBOPT_0x19
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x61:
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x62:
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x63:
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x64:
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	STS  _refresh_display_worked,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x65:
	RCALL SUBOPT_0xB
	LDS  R26,_do_zameny_grm_imp
	LDS  R27,_do_zameny_grm_imp+1
	LDS  R24,_do_zameny_grm_imp+2
	LDS  R25,_do_zameny_grm_imp+3
	CALL __DIVD21U
	CALL __CDF1U
	RJMP SUBOPT_0x52

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x66:
	RCALL SUBOPT_0xB
	LDS  R26,_do_zameny_masla_imp
	LDS  R27,_do_zameny_masla_imp+1
	LDS  R24,_do_zameny_masla_imp+2
	LDS  R25,_do_zameny_masla_imp+3
	CALL __DIVD21U
	CALL __CDF1U
	RJMP SUBOPT_0x52

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x67:
	LDI  R30,LOW(0)
	STS  _refresh_display_worked,R30
	LDI  R30,LOW(101)
	STS  _display_number,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x68:
	CALL __CWD1
	CALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x69:
	__POINTW2FN _0x0,517
	CALL _lcd_putsf
	RJMP SUBOPT_0x4E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6A:
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6B:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6C:
	__PUTD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x6D:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6E:
	RCALL SUBOPT_0x57
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x6F:
	__GETD1S 2
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x70:
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R16
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x71:
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x72:
	CALL __SWAPD12
	CALL __SUBF12
	RJMP SUBOPT_0x6C

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x73:
	LDI  R26,LOW(48)
	CALL __lcd_write_nibble_G102
	__DELAY_USW 200
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

	.equ __w1_port=0x1B
	.equ __w1_bit=0x03

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__SUBD12:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	SBC  R23,R25
	RET

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__PUTPARD2:
	ST   -Y,R25
	ST   -Y,R24
	ST   -Y,R27
	ST   -Y,R26
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDD:
	ADIW R26,2
	RCALL __EEPROMRDW
	MOVW R22,R30
	SBIW R26,2

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRD:
	RCALL __EEPROMWRW
	ADIW R26,2
	MOVW R0,R30
	MOVW R30,R22
	RCALL __EEPROMWRW
	MOVW R30,R0
	SBIW R26,2
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

;END OF CODE MARKER
__END_OF_CODE:
